define(["underscore","../model/SearchSetupInformation","../model/SearchModelFrontEndData","./SearchParameterFieldControl"],function(f,g,h,i){var e=function(a,b,d){if(!a||!(a instanceof g&&b&&b instanceof h&&d&&d instanceof i))throw Error("Illegal arguments passed to FieldLayoutAPI");this._setupInfo=a;this._searchData=b;this._paramFieldControl=d};e.prototype._withSearchField=function(a,b){this._searchData.requireFieldInformationAvailable(a,f.bind(function(){var d=this._searchData.getFieldInformation(a,
this._setupInfo);b.call(this,d)},this))};e.prototype.getListOfAllCriterionIds=function(){return f.union(this.getListOfCriterionIds(),this.getListOfColumnDisplayCriterionIds(),this.getListOfDesignPanelCriterionIds(),this.getListOfSortingCriterionIds())};e.prototype.getListOfCriterionIds=function(){var a=[];this._setupInfo.getCriteriaList().each(function(b){a.push(b.getFieldId())});return a};e.prototype.getListOfColumnDisplayCriterionIds=function(){var a=[];this._setupInfo.getDisplayColumns().each(function(b){a.push(b.getFieldId())});
return a};e.prototype.setColumnDisplayView=function(a,b){var d=this._setupInfo.getDisplayColumns().findByFieldId(a);d||(d=this._setupInfo.getDisplayColumns().createItem(a),this._setupInfo.getDisplayColumns().add(d));d.setEnabled(b)};e.prototype.getListOfDesignPanelCriterionIds=function(){var a=[];this._setupInfo.getDesignPanelItems().each(function(b){a.push(b.getFieldId())});return a};e.prototype.getListOfSortingCriterionIds=function(){var a=[];this._setupInfo.getSortingCriteriaList().each(function(b){a.push(b.getFieldId())});
return a};e.prototype.makeParameterField=function(a,b,d){this._withSearchField(a,function(){this._paramFieldControl.makeParameterField(a,b);d&&d()})};e.prototype.destroyParameterField=function(a){this._paramFieldControl.destroyParameterField(a)};e.prototype.focusParameterField=function(a){this._paramFieldControl.focusParameterField(a)};e.prototype.registerFieldColumnDisplaySettingsController=function(a,b){if(!a||!("string"===typeof a&&b&&"object"===typeof b&&"function"===typeof b.configure&&"function"===
typeof b.destroy))throw Error("Illegal object passed to registerFieldColumnDisplaySettingsController in FieldLayoutAPI");this._withSearchField(a,function(d){var c=this._setupInfo.getDisplayColumns().findByFieldId(a);c||(c=this._setupInfo.getDisplayColumns().createItem(a),this._setupInfo.getDisplayColumns().add(c));b.configure(d,c)})};e.prototype.unregisterFieldColumnDisplaySettingsController=function(a){a.destroy()};e.prototype.registerFieldDesignPanelSettingsController=function(a,b){if(!a||!("string"===
typeof a&&b&&"object"===typeof b&&"function"===typeof b.configure&&"function"===typeof b.destroy))throw Error("Illegal object passed to registerFieldDesignPanelSettingsController in FieldLayoutAPI");this._withSearchField(a,function(d){var c=this._setupInfo.getDesignPanelItems().findByFieldId(a);c||(c=this._setupInfo.getDesignPanelItems().createItem(a),this._setupInfo.getDesignPanelItems().add(c));b.configure(d,c)})};e.prototype.unregisterFieldDesignPanelSettingsController=function(a){a.destroy()};
e.prototype.registerFieldSortingSettingsController=function(a,b){if(!a||!("string"===typeof a&&b&&"object"===typeof b&&"function"===typeof b.configure&&"function"===typeof b.destroy))throw Error("Illegal object passed to registerFieldSortingSettingsController in FieldLayoutAPI");this._withSearchField(a,function(d){var c=this._setupInfo.getSortingCriteriaList().findByFieldId(a);c||(c=this._setupInfo.getSortingCriteriaList().createItem(a),this._setupInfo.getSortingCriteriaList().add(c));b.configure(d,
c)})};e.prototype.unregisterFieldSortingSettingsController=function(a){a.destroy()};e.prototype.tryCopyAllInformationForField=function(a,b){this.tryCopyCriterion(a,b);this.tryCopyDisplayColumnCriterion(a,b);this.tryCopyDesignPanelCriterion(a,b);this.tryCopySortingCriterion(a,b)};e.prototype.tryCopyCriterion=function(a,b){var d=this._setupInfo.getCriteriaList().findByFieldId(a),c=this._setupInfo.getCriteriaList().findByFieldId(b);d&&!c&&(c=this._setupInfo.getCriteriaList().createItem(b),c.copyFrom(d),
this._setupInfo.getCriteriaList().add(c))};e.prototype.tryCopyDisplayColumnCriterion=function(a,b){var d=this._setupInfo.getDisplayColumns().findByFieldId(a),c=this._setupInfo.getDisplayColumns().findByFieldId(b);d&&!c&&(c=this._setupInfo.getDisplayColumns().createItem(b),this._withSearchField(b,function(a){c.safeCopyFrom(a,d)}),this._setupInfo.getDisplayColumns().add(c))};e.prototype.tryCopyDesignPanelCriterion=function(a,b){var d=this._setupInfo.getDesignPanelItems().findByFieldId(a),c=this._setupInfo.getDesignPanelItems().findByFieldId(b);
d&&!c&&(c=this._setupInfo.getDesignPanelItems().createItem(b),this._withSearchField(b,function(a){c.safeCopyFrom(a,d)}),this._setupInfo.getDesignPanelItems().add(c))};e.prototype.tryCopySortingCriterion=function(a,b){var d=this._setupInfo.getSortingCriteriaList().findByFieldId(a),c=this._setupInfo.getSortingCriteriaList().findByFieldId(b);d&&!c&&(c=this._setupInfo.getSortingCriteriaList().createItem(b),this._withSearchField(b,function(a){c.safeCopyFrom(a,d)}),this._setupInfo.getSortingCriteriaList().add(c))};
e.prototype.tryMoveAllInformationForField=function(a,b){this.tryMoveCriterion(a,b);this.tryMoveDisplayColumnCriterion(a,b);this.tryMoveDesignPanelCriterion(a,b);this.tryMoveSortingCriterion(a,b)};e.prototype.tryMoveCriterion=function(a,b){var d=this._setupInfo.getCriteriaList().findByFieldId(a),c=this._setupInfo.getCriteriaList().findByFieldId(b);d&&!c&&(c=this._setupInfo.getCriteriaList().createItem(b),c.copyFrom(d),this._setupInfo.getCriteriaList().tryToRemoveItem(d),this._setupInfo.getCriteriaList().add(c))};
e.prototype.tryMoveDisplayColumnCriterion=function(a,b){var d=this._setupInfo.getDisplayColumns().findByFieldId(a),c=this._setupInfo.getDisplayColumns().findByFieldId(b);d&&!c&&(c=this._setupInfo.getDisplayColumns().createItem(b),this._withSearchField(b,function(a){c.safeCopyFrom(a,d)}),this._setupInfo.getDisplayColumns().tryToRemoveItem(d),this._setupInfo.getDisplayColumns().add(c))};e.prototype.tryMoveDesignPanelCriterion=function(a,b){var d=this._setupInfo.getDesignPanelItems().findByFieldId(a),
c=this._setupInfo.getDesignPanelItems().findByFieldId(b);d&&!c&&(c=this._setupInfo.getDesignPanelItems().createItem(b),this._withSearchField(b,function(a){c.safeCopyFrom(a,d)}),this._setupInfo.getDesignPanelItems().tryToRemoveItem(d),this._setupInfo.getDesignPanelItems().add(c))};e.prototype.tryMoveSortingCriterion=function(a,b){var d=this._setupInfo.getSortingCriteriaList().findByFieldId(a),c=this._setupInfo.getSortingCriteriaList().findByFieldId(b);d&&!c&&(c=this._setupInfo.getSortingCriteriaList().createItem(b),
this._withSearchField(b,function(a){c.safeCopyFrom(a,d)}),this._setupInfo.getSortingCriteriaList().tryToRemoveItem(d),this._setupInfo.getSortingCriteriaList().add(c))};e.prototype.tryDeleteAllInformationForField=function(a){this.tryDeleteCriterion(a);this.tryDeleteDisplayColumnCriterion(a);this.tryDeleteDesignPanelCriterion(a);this.tryDeleteSortingCriterion(a)};e.prototype.tryDeleteCriterion=function(a){(a=this._setupInfo.getCriteriaList().findByFieldId(a))&&this._setupInfo.getCriteriaList().tryToRemoveItem(a)};
e.prototype.tryDeleteDisplayColumnCriterion=function(a){(a=this._setupInfo.getDisplayColumns().findByFieldId(a))&&this._setupInfo.getDisplayColumns().tryToRemoveItem(a)};e.prototype.tryDeleteDesignPanelCriterion=function(a){(a=this._setupInfo.getDesignPanelItems().findByFieldId(a))&&this._setupInfo.getDesignPanelItems().tryToRemoveItem(a)};e.prototype.tryDeleteSortingCriterion=function(a){(a=this._setupInfo.getSortingCriteriaList().findByFieldId(a))&&this._setupInfo.getSortingCriteriaList().tryToRemoveItem(a)};
e.prototype.getSetupLabel=function(a,b){this._withSearchField(a,function(a){b(a.getDefaultLabel())})};e.prototype.getExternalSearchSettings=function(){return this._searchData.getSearchSettings()};e.prototype.getLayoutOptions=function(){return this._setupInfo.getLayoutOptions()};e.prototype.updateObjectModelOrder=function(a){this._setupInfo.getDisplayColumns().reorderItemsByIds(a);this._setupInfo.getCriteriaList().reorderItemsByIds(a);this._setupInfo.getDesignPanelItems().reorderItemsByIds(a);this._setupInfo.getSortingCriteriaList().reorderItemsByIds(a)};
e.prototype.watch=function(a,b){this._setupInfo.getCriteriaList().watch(a,b)};e.prototype.unwatch=function(a,b){this._setupInfo.getCriteriaList().unwatch(fieldId,b)};return e});