/**
     * Constructor of DocumentRowFactory class. Never use "new DocumentRowFactory()" - use the instance
     * created at the end of this class/file.
     * 
     * @param {Boolean} isPCMEnabled - True if the PCM license is active on this system, false otherwise.
     */

define("doctablex/StaticDocumentRowView","doctablex/DocTableXUtils utils/WCEvent wcr/webcenter_xml wcr/webcenter_html jquery underscore component/actionbuttons/UploadNewVersionButton component/actionbuttons/ViewButton component/actionbuttons/DownloadButton component/actionbuttons/Open3DButton component/actionbuttons/OpenACADButton component/contentoverflow/OverflowContentContainer component/table/DropdownOverflowUtil utils/ColorUtils utils/webi18n!DocRefStrings wcr/extpopup wcr/approvalInfoPopup".split(" "),
function(h,n,k,l,e,i,d,f,b,a,c,j,r,v,q){var p=function(c,a,g){if(!c&&!a&&!g)return this;this.dm=c;if(!this.dm)return window.alert("Cannot initialized view without data model."),null;this.phElemID=a;this.rowIndex=-1;this.renderOptions=g;this.renderOptions||(this.renderOptions=this.dm.renderOptions);this.supportAdvancedThumb=g.supportAdvancedThumb;!this.supportAdvancedThumb&&!1!==this.supportAdvancedThumb&&(this.supportAdvancedThumb=!1,this.constructor==p.prototype.constructor&&(this.supportAdvancedThumb=
!0));this.itemRootElemStr=this.renderOptions.itemRootElemStr||"td";this.renderMethodMap={AttributeFlapout:this.renderExpandCollapseButton,UpDownArrows:this.renderSortingArrows,SequenceNumber:this.renderSequenceNumber,RowSelector:this.renderRowSelector,DocumentName:this.renderDocumentSpec,DocumentActions:this.renderDocumentActions,DocumentProperty_Thumbnail:this.renderThumbnail,DocumentProperty_Description:this.renderDocumentDescription,DocumentProperty_ApprovalStatus:this.renderApprovalStatus,DocumentProperty_ApprovalStage:this.renderApprovalStage,
DocumentProperty_Project:this.renderDocProjectName,DocumentProperty_VersionRevision:this.renderDocumentVersion,DocumentProperty_VersionAuthor:this.renderDocumentAuthor,DocumentProperty_ModifiedDate:this.renderDocumentModifiedDate,ReferenceProperty:this.renderReferenceProperty,DocumentAttribute:this.renderDocAttribute,ProjectAttribute:this.renderProjectAttribute,ProjectProperty_ProjectName:this.renderDocProjectName,ProjectProperty_ProjectStatus:this.renderProjectStatus,ProjectProperty_ProjectDueDate:this.renderProjectDueDate,
LocalRemote:this.renderLocalRemoteButton,DeleteButton:this.renderDeleteButton,ReplaceButton:this.renderReplaceButton,CloneButton:this.renderCloneButton};this._newVersionCell=this._newVersionRow=this.newVersionBtn=this.openAcadBtn=this.open3dBtn=this.downloadBtn=this.viewBtn=null;return this};p.prototype.getSAHIHelperStr=function(c){return"jira_"+c+"-"+this.dm.getParentDocTable().getTablePrefix()+"-"+this.dm._creationIdx};p.prototype.render=function(c){var a=e("#"+this.phElemID);if(0===a.length)return a;
var g=this.renderOptions;c&&(this.renderOptions=c);this.rowIndex=this.dm.getIndexInTable();a.addClass(this.getSAHIHelperStr("docrow"));"list"==this.renderOptions.renderMethod?this.renderSimple(a):"table"==this.renderOptions.renderMethod?this.renderComplex(a):window.alert("Not supported render method: "+this.renderOptions.renderMethod+".");this.renderOptions=g;this.applyCustomStyle(a);return a};p.prototype.repaintRow=function(){this.renderOptions.isRepaintRow=!0;this.render();this.renderOptions.isRepaintRow=
!1};p.prototype.renderSimple=function(c){if(!c||0===c.length)return c;try{c.html(""),e("#"+this.dm.hiddenPropValsElemID).html(""),this.renderACatPlaceholders(c),this.renderNewVersionPlaceholder(c),this.renderSortingArrows(c),this.renderThumbnail(c,{thumbnailSize:50}),this.renderDocumentSpec(c,{}),this.renderDeleteButton(c)}catch(a){return h.log("Problem in StaticDocumentRowView.renderSimple:\n"+a),null}return c};p.prototype.renderComplex=function(c){if(!c||0===c.length)return c;this.destroy(!1);c.html("");
e("#"+this.dm.hiddenPropValsElemID).html("");r.cleanupDropdowns();var a=this.renderACatPlaceholders(c),g=this.renderNewVersionPlaceholder(c),j=this.renderOptions.columns;if(j)for(var b=0;b<j.length;b++){var f=this.renderOptions.columns[b];if(f){var d=f.type;if("DocumentProperty"===d||"ProjectProperty"===d)d+="_"+f.typeDetail;(d=this.renderMethodMap[d])&&d.call(this,c,f)}}j=c.find(">td").size()-1;a.find(" > td.attrCategoryColumn").attr("colspan",j);g&&g.find(" > td.uploadNewVersionColumn").attr("colspan",
j);return c};p.prototype.renderExpandCollapseButton=function(c){try{var a="",a=a+("<"+this.itemRootElemStr+' class="td-narrow td-centered">');if(!this.dm.isInErrorStatus()){var g=this.dm.getThisInDOM()+".expandClicked(this); return false;",j=this.dm.hasAttrCat()?"":" hiddenElement",b="icon icon-normal",f="";this.dm.dependsOnItself?(b+=" icon-WCR_Refresh",f=k.xmlencode(q.t("DocRowCyclicDepTooltip"))):this.dm.aCatExpanded?(b+=" activIcon icon-WCR_Minus-square collapseDepButton",f=k.xmlencode(q.t("DocRowCollapseTooltip"))):
(b+=" activIcon icon-WCR_Plus-square expandDepButton",f=k.xmlencode(q.t("DocRowExpandTooltip")));a+='<i class="'+b+" expandCollapseButton "+j+'" onclick="'+g+'" title="'+f+'"/>'}a+="</"+this.itemRootElemStr+">";c.append(a)}catch(r){h.log("Problem in StaticDocumentRowView.renderExpandCollapseButton:\n"+r)}};p.prototype.renderSortingArrows=function(c){try{if(this.dm.parentDocTable.isEditable){var a="",a=a+("<"+this.itemRootElemStr+' class="td-narrow">'),g=this.dm.getParentInDOM()+".moveUpButtonClicked("+
this.rowIndex+");return false;",j=this.dm.getParentInDOM()+".moveDownButtonClicked("+this.rowIndex+");return false;",b=0===this.rowIndex,f=this.rowIndex==this.dm.getParentDocTable().getNumberOfRows()-1;b&&!f?a+='<a class="btn btn9x14 float-right" href="#" onclick="'+j+'"><i class="icon icon-WCR_Sort-Down"></i></a>':f&&!b?a+='<a class="btn btn9x14 float-right" href="#" onclick="'+g+'"><i class="icon icon-WCR_Sort-Up"></i></a>':!b&&!f&&(a+='<div class="float-right">',a+='<a class="btn btn9x14 float-right" href="#" onclick="'+
g+'"><i class="icon icon-WCR_Sort-Up"></i></a><br/>',a+='<a class="btn btn9x14 float-right" href="#" onclick="'+j+'"><i class="icon icon-WCR_Sort-Down"></i></a>',a+="</div>");a+="</"+this.itemRootElemStr+">";c.append(a)}}catch(r){h.log("Problem in StaticDocumentRowView.renderSortingArrows:\n"+r)}};p.prototype.renderSequenceNumber=function(a){try{var c="",c=c+("<"+this.itemRootElemStr+' class="center td-narrow">'),c=c+("<span>"+(this.rowIndex+1)+"</span>"),c=c+("</"+this.itemRootElemStr+">");a.append(c)}catch(g){h.log("Problem in StaticDocumentRowView.renderSequenceNumber:\n"+
g)}};p.prototype.renderRowSelector=function(c){try{var a="",a=a+("<"+this.itemRootElemStr+' class="td-narrow">');if(!this.dm.isInErrorStatus()&&this.dm.docVerID){var g=this.dm.getThisInDOM()+".selectRowClicked(this);",a=a+('<input type="checkbox" id="'+this.phElemID+'_rowSelector"'),a=a+(' name="'+this.dm.getParentDocTable().getRootLevelPrefix()+'_selectedDocs"'),a=a+(' value="'+this.dm.docVerID+'" onclick="'+g+'"');this.dm.isSelected&&(a+=' checked="checked"');a+=">"}a+="</"+this.itemRootElemStr+
">";c.append(a)}catch(j){h.log("Problem in StaticDocumentRowView.renderRowSelector:\n"+j)}};p.prototype.renderThumbnail=function(a,c){try{var g="";if(this.renderOptions.showThumbnails){g+="<"+this.itemRootElemStr+' class="td-narrow">';if(!this.dm.isInErrorStatus())var j=this.dm.thumbnailURL,g=j&&0<j.length?g+this.customThumbnailHTML(j,c.thumbnailSize):g+'<div class="thumb"></div>';g+="</"+this.itemRootElemStr+">"}a.append(g)}catch(b){h.log("Problem in StaticDocumentRowView.renderThumbnail:\n"+b)}};
p.prototype.renderDocumentSpec=function(a,c){try{var g=e("<"+this.itemRootElemStr+">");c.width&&"auto"!=c.width&&g.width(c.width);var j=e(this.addStartOfCustomWidthDiv(c,"150px"));j.append(e(this.renderInlineLabel(c)));j.append(this.renderDocNameLink());g.append(j);a.append(g)}catch(b){h.log("Problem in StaticDocumentRowView.renderDocumentSpec:\n"+b)}};p.prototype.renderDocNameLink=function(){var a=e("<div>");if(this.dm.isInErrorStatus()){var c=e("<span>"),g="";this.dm.docName&&(g+=this.dm.docName+
": ");g+=q.t("DocRowCannotLoadDoc");c.text(g);g=e("<i>",{"class":"icon icon-WCR_Msg-Warning",title:q.t("DocRowCannotLoadDoc")});a.append(g,c)}else c=window.webcenterConfig.jspBaseUrl+"docdetails.jsp?docVerID="+this.dm.docVerID+"&amp;menu_file="+h.getMenuFileParamValue(),c=e("<a>",{target:"_blank","class":"docrefdoclink",href:c}).text(this.dm.docName),a.append(c),this.dm.docCheckedOutOwner&&(c=e("<i>",{"class":"icon icon-normal icon-WCR_Actions-Lock12 add-spacing-left",title:q.t("DOC_CHECKED_OUT"),
alt:q.t("DOC_CHECKED_OUT")}),a.append(c));return a};p.prototype.renderDocumentActions=function(a,c){var g;g=""+("<"+this.itemRootElemStr+' class="docrefactionscol td-narrow">');g+='<div class="row-actions row-actions-always-visible">';if(!this.dm.isInErrorStatus())for(var j=c.typeDetail.split("|"),b=0;b<j.length;b++){var f=j[b],r=this.phElemID+"_actionBtn_"+h.getNextUniquePrefix();g+='<div id="'+r+'" class="hiddenElement"/>';var d=null;switch(f){case "View":d=this.getViewBtn();break;case "Open3d":d=
this.getOpen3DBtn();break;case "OpenAcad":d=this.getOpenACADBtn();break;case "Download":d=this.getDownloadBtn();break;case "UploadNewVersion":d=this.getUploadNewVersionBtn()}d&&i.defer(i.bind(function(a,c){c.renderBtn(e("#"+a))},this,r,d))}g=g+"</div>"+("</"+this.itemRootElemStr+">");a.append(g)};p.prototype.renderDocumentDescription=function(a,c){try{var g=e("<"+this.itemRootElemStr+">");c.width&&"auto"!=c.width&&g.width(c.width);var b=e(this.addStartOfCustomWidthDiv(c,"150px")),f=e("<div>"),r=new j(f,
44);b.append(r.getJQElement());!this.dm.isInErrorStatus()&&this.dm.docDesc&&(f.append(this.renderInlineLabel(c)),f.append(e("<span>").text(this.dm.docDesc)));g.append(b);a.append(g)}catch(d){h.log("Problem in StaticDocumentRowView.renderDocumentDescription:\n"+d)}};p.prototype.renderApprovalStatus=function(c,a){try{var g="",g=g+("<"+this.itemRootElemStr+' class="td-status">'),g=g+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var j=this.dm.appStatus;if(j&&j.cycleStatus){for(var b=null,f=
this.dm.appTypeList,r=0;r<f.length;r++){var d=f[r];if(d.id==j.statusID){b=d;break}}var e="onclick=\"javascript:showapprovaldetails(this, event,'"+this.dm.docVerID+"', 'Approval Setup "+k.xmlencode(l.encodeForJScript(this.dm.docName))+"')\"",e=e+' onmouseout="javascript:delayhidemenu();"',g=g+'<div class="docrefApprovalStatus">',i,v;"Not Started"==j.cycleStatus?(i=k.xmlencode(q.t("APPROVAL_STATUS_HOLD")),v="icon icon-WCR_Stopped icon-blue"):b&&(i=k.xmlencode(b.translName),"rejected.gif"==b.icon?v=
"icon-WCR_Rejected icon-red":"approved.gif"==b.icon?v="icon-WCR_Approved icon-green":"pending.gif"==b.icon?v="icon-WCR_Pending icon-blue":"rejectforce.gif"==b.icon?v="icon-WCR_ForceReject icon-red":"approveforce.gif"==b.icon?v="icon-WCR_ForceApproved icon-green":"approvedcond.gif"==b.icon?v="icon-WCR_ApprovedConditional icon-green":"fappcond.gif"==b.icon&&(v="icon-WCR_ApprovedConditional icon-green"));g+='<i class="'+v+'" style="cursor: pointer;" title="'+i+'" '+e+" />";g+="</div>";g+="</div>"}}g+=
"</"+this.itemRootElemStr+">";c.append(g)}catch(p){h.log("Problem in StaticDocumentRowView.renderApprovalStatus:\n"+p)}};p.prototype.renderApprovalStage=function(c,a){try{var g="",g=a.width&&"auto"!=a.width?g+("<"+this.itemRootElemStr+' class="docrefApprovalStage" style="width:'+a.width+'">'):g+("<"+this.itemRootElemStr+' class="docrefApprovalStage" >'),g=g+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var j=this.dm.appStatus;j&&j.stageName&&(g+=this.addStartOfCustomWidthDiv(a,"50px"),
g+=k.xmlencode(j.stageName),g+=this.addEndOfCustomWidthDiv())}g+="</"+this.itemRootElemStr+">";c.append(g)}catch(b){h.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+b)}};p.prototype.renderDocProjectName=function(a,c){try{this._renderProjectProperty(a,c,function(a){var c='<a href="'+window.webcenterConfig.jspBaseUrl+"projdetails.jsp?projectID="+a.id+"&amp;menu_file="+h.getMenuFileParamValue()+'" target="_blank">',c=c+k.xmlencode(a.name);return c+"</a>"})}catch(g){h.log("Problem in StaticDocumentRowView.renderDocProjectName:\n"+
g)}};p.prototype._renderProjectProperty=function(a,c,g,j){var b="",b=c.width&&"auto"!=c.width?b+("<"+this.itemRootElemStr+' style="width:'+c.width+'">'):b+("<"+this.itemRootElemStr+">"),b=b+this.renderInlineLabel(c);if(!this.dm.isInErrorStatus()){b+=this.addStartOfCustomWidthDiv(c,"50px");if((c=this.dm.projects)&&0<c.length)for(var f=0;f<c.length;f++){var r=c[f];r&&r.id&&(0<f&&!j&&(b+="<br/>"),b+=g(r))}else this.dm.project.id&&(b+=g(this.dm.project));b+=this.addEndOfCustomWidthDiv()}b+="</"+this.itemRootElemStr+
">";a.append(b)};p.prototype.renderProjectDueDate=function(c,a){try{this._renderProjectProperty(c,a,function(c){var a=c.dueDate;try{a=!a||0==a?"":new Date(parseInt(a))}catch(g){h.log("Failed to parse '"+c.dueDate+"' to a Date object."),a=""}return k.xmlencode(l.getDateHourString(a))})}catch(g){h.log("Problem in StaticDocumentRowView.renderProjectDueDate:\n"+g)}};p.prototype.renderProjectStatus=function(c,a){try{this._renderProjectProperty(c,a,function(c){var g="";if(c&&c.statusObj&&c.statusObj.statusName)switch(a.projectStatusLayout){case "LabelAndIcon":c.statusObj.iconURL&&
(g+='<img alt="" border="0" title="'+k.xmlencode(c.statusObj.statusName)+'" src="images/statuses/'+c.statusObj.iconURL+'" />');g=g+"<br />"+k.xmlencode(c.statusObj.statusName);break;case "OnlyLabel":g+=k.xmlencode(c.statusObj.statusName);break;case "ColorLabel":if(c.statusObj.colorRGB)var j=v.calculateForegroundColor(c.statusObj.colorRGB),g=g+('<div class="projectStatus" style="background-color: '+c.statusObj.colorRGB+"; color: "+j+';">'),g=g+('<a class="btn btn-no-action">'+k.xmlencode(c.statusObj.statusName)+
"</a></div>");else g+=k.xmlencode(c.statusObj.statusName);break;case "OnlyIcon":c.statusObj.iconURL&&(g+='<img alt="" border="0" title="'+k.xmlencode(c.statusObj.statusName)+'" src="images/statuses/'+c.statusObj.iconURL+'" />')}return g},"ColorLabel"===a.projectStatusLayout)}catch(g){h.log("Problem in StaticDocumentRowView.renderProjectStatus:\n"+g)}};p.prototype.renderDocumentVersion=function(c,a){try{var g=e("<"+this.itemRootElemStr+">",{"class":"td-centered td-narrow"});g.html(this.renderInlineLabel(a));
if(!this.dm.isInErrorStatus()){if(this.dm.docVerIdx){var j=this.dm.docVerIdx;this.dm.docRevLetter&&(j+="("+this.dm.docRevLetter+")");g.append(e("<span>",{"class":"row-action-text"}).text(j));if(this.dm.docVerIdx!=this.dm.latestDocVerIdx&&0===this.dm.parentDocTable.docReferenceMode){var b=e("<i>",{"class":"icon icon-WCR_Msg-Warning",title:q.t("DocTableRefNotLatestVersion")});g.append(b)}}if(a.uploadNewVersion){var f=e("<div>",{"class":"row-actions row-actions-always-visible"}),r=e("<div>",{id:this.phElemID+
"_uploadNewVersionBtn"});f.append(r);g.append(f);i.defer(i.bind(function(){var c=this.getUploadNewVersionBtn();c&&c.setBtnContext(e("#"+this.phElemID+"_uploadNewVersionBtn"))},this))}}c.append(g)}catch(d){h.log("Problem in StaticDocumentRowView.renderDocumentVersion:\n"+d)}};p.prototype.renderDocumentAuthor=function(c,a){try{var g="",g=a.width&&"auto"!=a.width?g+("<"+this.itemRootElemStr+' class="Black_11" style="width:'+a.width+'">'):g+("<"+this.itemRootElemStr+' class="Black_11">'),g=g+this.renderInlineLabel(a);
!this.dm.isInErrorStatus()&&this.dm.docAuthor&&(g+=this.addStartOfCustomWidthDiv(a,"50px"),g+=l.getUserNameStringActiveHTML(this.dm.docAuthor.id,this.dm.docAuthor.firstName,this.dm.docAuthor.lastName,this.dm.docAuthor.username,this.dm.docAuthor.isActive,q.t("DocRefUserDeactivated"),!0),g+=this.addEndOfCustomWidthDiv());g+="</"+this.itemRootElemStr+">";c.append(g)}catch(j){h.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+j)}};p.prototype.renderDocumentModifiedDate=function(c,a){try{var g=
"",g=a.width&&"auto"!=a.width?g+("<"+this.itemRootElemStr+' class="center" style="width:'+a.width+'">'):g+("<"+this.itemRootElemStr+' class="center">'),g=g+this.renderInlineLabel(a);!this.dm.isInErrorStatus()&&this.dm.modDate&&(g+=this.addStartOfCustomWidthDiv(a,"50px"),g+=k.xmlencode(l.getDateHourString(this.dm.modDate)),g+=this.addEndOfCustomWidthDiv());g+="</"+this.itemRootElemStr+">";c.append(g)}catch(j){h.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+j)}};p.prototype.renderLocalRemoteButton=
function(c,a){try{if(this.dm.parentDocTable.isEditable){var g="",g=g+("<"+this.itemRootElemStr+' class="td-narrow">');if(!this.dm.isInErrorStatus()&&this.dm.getParentDocTable().hasLocalRemoteButton()&&this.dm.isRemoteDocument())if(this.dm.isEditable&&this.dm.canUserAddDocuments()&&"ReadOnly"!=a.visibility&&!this.dm.dependsOnItself)var j="javascript: "+this.dm.getParentInDOM()+".localRemoteButtonClicked("+this.rowIndex+",'LocalRemote');",b=k.xmlencode(q.t("DocRowLocalRemoteButtonTooltip")),g=g+('<button type="button" class="btn btn-xs btn-default actionBtn" title="'+
b+'" onclick="'+j+'">'),g=g+'<i class="icon icon-WCR_Actions-MakeLocal12"/>',g=g+"</button>";else b=k.xmlencode(q.t("DocRowLocalRemoteInfoTooltip")),g+='<i class="icon icon-WCR_Actions-MakeLocal12" title="'+b+'" />';g+="</"+this.itemRootElemStr+">";c.append(g)}}catch(f){h.log("Problem in StaticDocumentRowView.renderLocalRemoteButton:\n"+f)}};p.prototype.renderReplaceButton=function(c){try{if(this.dm.parentDocTable.isEditable){var a=e("<"+this.itemRootElemStr+">",{"class":"td-narrow"}).css("min-width",
"70px"),g=this.dm.getParentDocTable().getDocSrcLinks(),j=g.length;if(0<j){var b=e("<i>",{"class":"icon icon-normal icon-WCR_Actions-Replace12"}),f=e("<div/>").attr({"class":"btn-group"}),r=e("<button/>").attr({"class":"btn btn-xs btn-default",id:"replace_greenlinks"+this.phElemID,title:q.t("DocRowReplaceButtonTag")}).append(b);f.append(r);if(1<j){var d=this.dm.getParentDocTable(),v=d.getDocumentSourceOptions(d.greenLinksPrefix+"_inline"),k=e("<button/>").attr({"class":"btn btn-xs btn-default dropdown-toggle",
"data-toggle":"dropdown"}),p=e("<span/>").attr({"class":"caret"}),l=e("<span/>").attr({"class":"sr-only"}).text(q.t("DocRowReplaceButtonTag"));k.append(p);k.append(l);var n=e("<ul/>").attr({"class":"dropdown-menu dropdown-menu-right",role:"menu"});f.append(k);f.append(n);e("<li/>").addClass("dropdown-header").text(q.t("DocRowReplaceBy")).appendTo(n);for(b=0;b<j;b++)if(g[b]){var x=e("<a/>").attr({href:"#","class":"optionClass",id:this.phElemID+"_option_"+b}).text(g[b].label.getLabel(v.currentLanguage)).click(i.bind(function(c){c=
e(c.target).attr("id");c=c.substring(c.lastIndexOf("_")+1,c.length);c=g[c];this.dm.getParentDocTable().processReplaceRequest(c,this.rowIndex)},this));e("<li/>").append(x).appendTo(n)}}r.on("click",function(){0<g.length&&this.dm.getParentDocTable().processReplaceRequest(g[0],this.rowIndex);return!1}.bind(this));a.append(f)}c.append(a)}}catch(D){h.log("Problem in StaticDocumentRowView.renderReplaceButton:\n"+D)}};p.prototype.renderCloneButton=function(c){try{if(this.dm.parentDocTable.isEditable){var a=
"";if("Copy"===this.dm.docOperation||"New"===this.dm.docOperation||!this.dm.isRemoteDocument()&&"Link"!==this.dm.docOperation&&this.dm.canUserDownloadDocument())var g="javascript: "+this.dm.getParentInDOM()+".addCloneRowAction("+this.rowIndex+");return false;",a=a+("<"+this.itemRootElemStr+' class="td-narrow">'),a=a+('<button class="btn btn-xs btn-default actionBtn" title="'+q.t("DocRowDuplicateButtonTag")+'" onclick="'+g+'">'),a=a+'<i class="icon icon-normal icon-WCR_Duplicate"/>',a=a+"</button>",
a=a+("</"+this.itemRootElemStr+">");else a+="<"+this.itemRootElemStr+"/>";c.append(a)}}catch(j){h.log("Problem in StaticDocumentRowView.renderCloneButton:\n"+j)}};p.prototype.renderDeleteButton=function(c){try{if(this.dm.parentDocTable.isEditable){var a="",g="javascript: "+this.dm.getParentInDOM()+".deleteButtonClicked("+this.rowIndex+");return false;",a=a+("<"+this.itemRootElemStr+' class="td-narrow">'),a=a+('<button class="btn btn-xs btn-default actionBtn" title="'+q.t("DocRowRemoveButtonTag")+
'" onclick="'+g+'">'),a=a+'<i class="icon icon-normal icon-WCR_Actions-Delete12"/>',a=a+"</button>",a=a+("</"+this.itemRootElemStr+">");c.append(a)}}catch(j){h.log("Problem in StaticDocumentRowView.renderDeleteButton:\n"+j)}};p.prototype.renderReferenceProperty=function(a,c){var g={isProperty:!0,aCatObj:this.dm.propsACatObj,canEdit:this.dm.canUserEditProperties(),aCatPrefix:this.dm.propsACatPrefix,rootElement:this.itemRootElemStr,className:"referencePropertyCell",tooltipKey:"DocRowCannotFindProperty",
messageKey:"DocRowCannotFindPropertyShort"};if("Hidden"==c.visibility){var j=e("#"+this.dm.hiddenPropValsElemID);if(1==j.length){var b=this.itemRootElemStr;this.itemRootElemStr="div";this._renderAttrValue(j,c,g);this.itemRootElemStr=b}}else this._renderAttrValue(a,c,g)};p.prototype.renderDocAttribute=function(a,c){if(this.dm.isInErrorStatus()||this.dm.dependsOnItself)a.append("<"+this.itemRootElemStr+"/>");else{var g={isProperty:!1,aCatObj:this.dm.aCatObj,canEdit:this.dm.canUserEditAttributes(),aCatPrefix:this.dm.aCatPrefix,
rootElement:this.itemRootElemStr,className:"documentAttributeCell",tooltipKey:"DocRowCannotFindAttribute",messageKey:"DocRowCannotFindAttributeShort"};this._renderAttrValue(a,c,g)}};p.prototype.renderProjectAttribute=function(a,c){var g=this.dm.projects;if(g&&0<g.length){for(var j=e("<"+this.itemRootElemStr+">"),b=0;b<g.length;b++){var f=g[b];f&&(f.id&&f.aCatObj)&&(f={isProperty:!1,aCatObj:f.aCatObj,canEdit:!1,aCatPrefix:this.dm.projACatPrefix+f.id,rootElement:"div",className:"projectAttributeCell",
tooltipKey:"DocRowCannotFindProjectAttribute",messageKey:"DocRowCannotFindProjectAttributeShort"},this._renderAttrValue(j,c,f))}a.append(j)}else this.dm.project&&(this.dm.project.id&&this.dm.project.aCatObj)&&(f={isProperty:!1,aCatObj:this.dm.project.aCatObj,canEdit:!1,aCatPrefix:this.dm.projACatPrefix+this.dm.project.id,rootElement:this.itemRootElemStr,className:"projectAttributeCell",tooltipKey:"DocRowCannotFindProjectAttribute",messageKey:"DocRowCannotFindProjectAttributeShort"},this._renderAttrValue(a,
c,f))};p.prototype._renderAttrValue=function(a,c,g){try{var j=!1,b=g.isProperty&&"Hidden"==c.visibility,f=c.visibility;b&&(f="Editable");var r=c.typeDetail,d=g.aCatObj;if(r&&this.dm.isAttrCatLoaded(d)){var i=d.findAttribute(r,c.attributeName);if(i&&!i.isRichText()){var v=d.findCell(i);if(v){var p=v.cellObj,l=v.row,n=v.col,x="ReadOnly"!=f&&g.canEdit,D=g.aCatPrefix,r=D+"td_"+l+"_"+n,H=e("#"+r);if(1==H.length){var v='<span class="docRefInfo">',I=k.xmlencode(q.t("DocRowAttributeInColumnInfo")+": "+c.label),
v=v+('<img border="0" src="images/doc_ref_info.png" title="'+I+'"/>'),v=v+"</span>";H.removeAttr("id");H.html(v)}else 1<H.length&&window.alert("More than one HTML element with ID '"+r+"' on the page!");var u="<"+g.rootElement+' id="'+r+'" class="'+g.className+'"',u=!b&&c.width&&"auto"!=c.width?u+(' style="width:'+c.width+'">'):u+">";b||(u+=this.renderInlineLabel(c));i.isDocReference()?i.valueHyperlink&&(u+=i.valueHyperlink.replace(/ \| /g,"<br/>")):u+=d.renderAttributeValueInternal(p,i,l,n,f,x,!1);
var u=u+("</"+g.rootElement+">"),M=e(u),J=M.find("div.form-entry");c&&(c.width&&"auto"!=c.width&&0<J.length)&&(c.width.trim().match(/%$/)?J.addClass("LimitWidth").css("width","100%"):J.addClass("LimitWidth").css("width",c.width));a.append(M);x&&i.type&&"datetime"==i.type.toLowerCase()&&d.createCalendar("#"+D+"longFormat_adate"+i.id,"#"+D+"date_period_of_day_"+i.id);j=!0}}}if(!j&&!b){u="<"+g.rootElement+' class="'+g.className+'">';u+=this.renderInlineLabel(c);if(this.dm.isAttrCatLoaded(d))var K=k.xmlencode(q.t(g.tooltipKey)),
L=k.xmlencode(q.t(g.messageKey)),u=u+('<span style="color: #cccccc" title="'+K+'">'),u=u+L,u=u+"</span>";else!g.isProperty&&this.dm.hasNoAttrCat()&&(K=k.xmlencode(q.t("DocRowNoAttrCategoryInfo")),L=k.xmlencode(q.t("DocRowNoAttrCategoryInfoShort")),u+='<span style="color: #cccccc"  title="'+K+'">',u+=L,u+="</span>");u+="</"+g.rootElement+">";a.append(u)}}catch(N){h.log("Problem in StaticDocumentRowView._renderAttrValue "+c.label+":\n"+N)}};p.prototype.renderACatPlaceholders=function(c){if(this.renderOptions.isRepaintRow)return c.siblings("#"+
this.dm.aCatRowID);this.dm.destroy();e("#"+this.dm.aCatRowID).remove();var a,g=this.renderOptions.columns;a=""+('<tr id="'+this.dm.aCatRowID+'" class="rowNoBorder hiddenElement">');a+='<td></td><td class="attrCategoryColumn">';null!=h.getRenderItem(g,"ReferenceProperty")&&(a+='<div id="'+this.dm.propsACatElemID+'" class="hiddenElement"></div>',a+='<div id="'+this.dm.hiddenPropValsElemID+'" class="hiddenElement"></div>');if(!this.aCatExpandDisabled||null!=h.getRenderItem(g,"DocumentAttribute"))a+=
'<div id="'+this.dm.aCatElemID+'"></div>';if(null!=h.getRenderItem(g,"ProjectAttribute"))if((g=this.dm.projects)&&0<g.length)for(var j=0;j<g.length;j++){var b=g[j];b&&b.id&&(a+='<div id="'+this.dm.projACatElemIDPrefix+b.id+'" class="hiddenElement"></div>')}else this.dm.project&&this.dm.project.id&&(a+='<div id="'+this.dm.projACatElemIDPrefix+this.dm.project.id+'" class="hiddenElement"></div>');a+="</td>";a+="</tr>";a=e(a);this.applyCustomStyle(a);c.after(a);return a};p.prototype.renderNewVersionPlaceholder=
function(a){if(this.renderOptions.isRepaintRow)return this._newVersionRow;this._newVersionRow&&this._newVersionRow.remove();this._newVersionRow=e('<tr id="'+this.phElemID+'_newVersionRow" class="newVersionRow"></tr>');a.after(this._newVersionRow);this._newVersionCell=e('<td class="uploadNewVersionColumn">');this._newVersionRow.append(e("<td>"));this._newVersionRow.append(this._newVersionCell);this.newVersionBtn&&this.newVersionBtn.setRowContext(this._newVersionCell);this.applyCustomStyle(this._newVersionRow);
return this._newVersionRow};p.prototype.customThumbnailHTML=function(a,c){var g="";if(!c||"0"==c)c="50";if(this.supportAdvancedThumb&&this.dm.docVerID)var j=window.webcenterConfig.jspBaseUrl+"DownloadViewerThumbnail.jsp?docversionid="+this.dm.docVerID+"&amp;pix=500&amp;ajax=1",b=this.dm.docDesc?this.dm.docDesc:"",f=window.webcenterConfig.jspBaseUrl+"viewdocument.jsp?docVerID="+this.dm.docVerID+"&amp;menu_file="+h.getMenuFileParamValue()+"&amp;sourcePage="+h.getSourcePageURLEncoded(),g=g+('<a href="'+
f+'" target="_blank">')+'<img onmouseout="delayhidethumb();"',g=g+(" onmouseover=\"showthumb(event, '"+a+"', '"+k.xmlencode(l.encodeForJScript(this.dm.docName))+"', 202, null, '"+j+"', 500);\""),g=g+(' src="'+window.webcenterConfig.jspBaseUrl+a+'"'),g=g+(' alt="'+k.xmlencode(b)+'" width="'+c+'px" height="'+c+'px" border="0" align="middle">'),g=g+"</a>";else g+='<img src="'+window.webcenterConfig.jspBaseUrl+a+'"',g+=' width="'+c+'px" height="'+c+'px" border="0" align="middle">';return g};p.prototype.renderInlineLabel=
function(a){var c="";this.renderOptions.hideHeader&&(a&&a.label)&&(c+='<div class="docrefinlinelabel">'+h.getEncodedTranslatedLabel(a.label),"Required"==a.visibility&&(c+='&nbsp;<font color="red">*</font>'),c+="</div>");return c};p.prototype.addStartOfCustomWidthDiv=function(a,c){var g="<div>";a.width&&"auto"!=a.width?g=a.width.trim().match(/%$/)?'<div class="LimitWidth" style="width:100%">':'<div class="LimitWidth" style="width:'+a.width+'">':c&&(g='<div style="min-width:'+c+'">');return g};p.prototype.addEndOfCustomWidthDiv=
function(){return"</div>"};p.prototype.getUploadNewVersionBtn=function(){if(!this.newVersionBtn&&this.showAdvancedDocumentActions()&&this.dm.canUserUploadNewVersion()){var a={useInlineForm:!0,docReferenceMode:this.dm.getParentDocTable().docReferenceMode,alwaysUpdateAllProjects:!0,uniqueIdPrefix:h.getNextUniquePrefix()+"_",onCancelCallback:i.bind(function(){this.dm.setIsNewDocVersionUploaded(!1)},this)};this.newVersionBtn=new d(this.dm.docVerID,null,this.dm.parentDocTable.currentUser,a);n.on("btnClicked.UploadNewVersion."+
this.dm.docVerID,i.bind(function(){this.dm.setIsChanged();this.dm.setIsNewDocVersionUploaded(!0);var a=e("#SaveButtonRowID");1==a.length&&a.show()},this));this._newVersionCell&&this.newVersionBtn.setRowContext(this._newVersionCell)}return this.newVersionBtn};p.prototype.getViewBtn=function(){this.viewBtn||(this.viewBtn=new f(this.dm.docVerID));return this.viewBtn};p.prototype.getDownloadBtn=function(){this.downloadBtn||(this.downloadBtn=new b(this.dm.docVerID));return this.downloadBtn};p.prototype.getOpen3DBtn=
function(){this.open3dBtn||(this.open3dBtn=new a(this.dm.docVerID));return this.open3dBtn};p.prototype.getOpenACADBtn=function(){this.openAcadBtn||(this.openAcadBtn=new c(this.dm.docVerID));return this.openAcadBtn};p.prototype.showAdvancedDocumentActions=function(){return!0};p.prototype.destroy=function(){};p.prototype.applyCustomStyle=function(a){this.renderOptions.styleObj&&(a.find("*").not(".darktext_greenlink_12_bold, .darktext_greenlink_11, .icon, button, .TextContentElementWidget *, .input-group-addon, .form-div, .form-div *, .elementypecolor").css(this.renderOptions.styleObj),
a.find("input, select, option").not(".greenlink_button").css("background-color","white"))};return p});
define("doctablex/StaticDocumentRow","doctablex/DocTableXUtils doctablex/StaticDocumentRowView doctablex/AJAXDataCache utils/webi18n!DocRefStrings wcr/ObjectArrayCloneUtil wcr/webcenter_xml underscore jquery lib/PromisePolyfill".split(" "),function(h,n,k,l,e,i,d,f){var b=function(a){if(!a)return this;this.setStatus("init");this.isChanged=!1;this.rowID=null;this.rowID=a.origDocRow?a.origDocRow.rowID:a.rowID?a.rowID:h.getNextUniquePrefix();if(this.parentDocTable=a.parentDocTable){this.prefix=this.getParentDocTable().getTablePrefix()+
"_"+this.rowID;this._creationIdx=this.getParentDocTable().getNextRowCreationIndex();this.isEditable=this.getParentDocTable().isEditable;"undefined"!=typeof a.isEditable&&(this.isEditable=!0===a.isEditable);this.aCatNotExpandedYet=!0;this.isSelected=this.dependsOnItself=!1;this.renderOptions=a.renderOptions;this.renderOptions||(this.renderOptions=this.getParentDocTable().renderOptions);this.renderOptions||(this.renderOptions={});this.docInfoRequest=f.Deferred();this.drID=a.drID;this.docVerID=a.docVerID;
this.docID=a.docID;this.docName=a.docName;this.docDesc=a.docDesc;this.docVerIdx=a.docVerIdx;this.latestDocVerIdx=a.latestDocVerIdx;this.docRevLetter=a.docRevLetter;this.appStatus=a.appStatus;this.thumbnailURL=a.thumbnailURL;this.docAuthor=a.docVerAuthor;this.modDate=a.modDate;this.folder={id:null,name:null};a.folder&&(this.folder.id=a.folder.id||null,this.folder.name=a.folder.name||null);this.appTypeList=a.appTypeList;this.userPerms=a.userPerms||{};this.docCheckedOutOwner=this.docType=this.docTypeID=
null;this.project={id:a.projectID||null,name:a.projectID?a.projectName:null,isTemplate:a.isInTemplate||null};this.projects=a.projects||[];var c=this.renderOptions.columns;if(c&&a.properties)for(var j=0;j<a.properties.length;j++){var r=a.properties[j];if(r&&!h.getRenderItem(c,"ReferenceProperty",r.id)&&(r.value||0===r.value)){var d={type:"ReferenceProperty",typeDetail:r.id,label:r.name,visibility:"Hidden"};c.push(d)}}var e=[];if(c)for(j=0;j<c.length;j++)if((d=c[j])&&d.type&&"ReferenceProperty"==d.type){var i=
d.typeDetail;(r=this.findPropertyByID(i,a.properties))?(r.name=d.label,r.isRequired="Required"==d.visibility,r.isVisible="Hidden"!=d.visibility):r={id:i,name:d.label,isRequired:"Required"==d.visibility,isVisible:"Hidden"!=d.visibility,value:""};e.push(r)}this.props=e;this.propsValuesInitialized=!1;c=h.getRenderItem(this.renderOptions.columns,"AttributeFlapout");this.aCatExpandDisabled=!c;this.aCatExpanded=a.aCatExpanded||!1;this.projectCreationContext=this.parentDocTable.projectCreationContext;this.aCatView=
this.getParentDocTable().aCatView;c&&c.typeDetail&&(this.aCatView=c.typeDetail);this.aCatPrefix=this.getRowPrefix()+"_ACat_";this.aCatRowID=this.getRowPrefix()+"_ACatRow";this.aCatElemID=this.getRowPrefix()+"_ACatPanel";this.aCatID=a.aCatID||null;this.aCatObj=this.aCatModDate=null;this.renderedAttrCat={id:"",isEditable:!1};this.isExpandedAttrsEditable=!0;c&&(this.isExpandedAttrsEditable="Editable"==c.visibility);this.propsACatPrefix=this.getRowPrefix()+"_PropsACat_";this.propsACatElemID=this.getRowPrefix()+
"_PropsACatID";this.hiddenPropValsElemID=this.getRowPrefix()+"_HiddenPropValuesContainerID";this.propsACatID=this.getParentDocTable().propsACatID;this.propsACatObj=null;this.hasDocRowSelector=null!=h.getRenderItem(this.renderOptions.columns,"RowSelector");this.phElemID=this.getRowPrefix();this.view=new (a.viewClass||n)(this,this.phElemID,this.renderOptions);this.projACatPrefix=this.getRowPrefix()+"_ProjACat_";this.projACatElemIDPrefix=this.getRowPrefix()+"_ProjACatID_";this.copyOfExistingRowID=a.copyOfExistingRowID||
null;this.constructor==b.prototype.constructor&&this._initializeFromServer();return this}alert("StaticDocumentRow cannot be initialized without parent table reference!")};b.prototype._initializeFromServer=function(){this.updateDocInfoFromServer(!0)};b.prototype.getDocRowInfo=function(){var a={copyOfExistingRowID:this.rowID,parentDocTable:this.getParentDocTable(),drID:this.drID,docVerID:this.docVerID,docID:this.docID,docName:this.docName,docDesc:this.docDesc,docVerIdx:this.docVerIdx,latestDocVerIdx:this.latestDocVerIdx,
docRevLetter:this.docRevLetter,appStatus:this.appStatus,thumbnailURL:this.thumbnailURL,docAuthor:this.docAuthor,modDate:this.modDate,appTypeList:this.appTypeList,userPerms:this.userPerms,project:d.extend({},this.project),projects:[],properties:[],aCatID:this.aCatID};a.folder={id:this.folder.id,name:this.folder.name};d.each(this.projects,function(c){a.projects.push(d.extend({},c))},this);d.each(this.properties,function(c){a.properties.push(d.extend({},c))},this);return a};b.prototype.duplicateItselfTo=
function(a){var c=this.getDocRowInfo();return a.appendDocRow(c,this.constructor)};b.prototype.getParentDocRow=function(){return this.getParentDocTable().getParentDocRow()};b.prototype.isDirectChildOfClonedRow=function(){var a=this.getParentDocRow();return!(!a||!a.clonedFrom)};b.prototype.isIndirectlyClonedRow=function(){return this.isDirectChildOfClonedRow()&&!!this.copyOfExistingRowID};b.prototype.getAllDescendantRows=function(){var a=[];this.getAllDescendantRowsRecursive(a);return a};b.prototype.getAllDescendantRowsRecursive=
function(a){a.push(this);this.aCatObj&&this.aCatObj.executeOnAllDocReferences(function(c){for(var j=0;j<c.docRows.length;j++){var b=c.docRows[j];b&&b.getAllDescendantRowsRecursive(a)}},this)};b.prototype.getAllRowsCopiedFromRows=function(a){var c=[];if(!a||0==a.length)return c;var j=this.getParentDocTable().getRootLevelTable();if(!j)return c;j.getRowsCopiedFromRowsRecursive(a,c);return d.filter(c,function(c){return-1==a.indexOf(c)})};b.prototype.getMasterOfIndirectlyClonedRow=function(){if(this.isDirectChildOfClonedRow()&&
this.getParentDocRow()){var a=[];this.getParentDocRow().getParentDocTable().getRowByIDRecursive(this.copyOfExistingRowID,a);if(1==a.length)return a[0];1<a.length&&window.alert('More than one document row with the very same "rowID"!!!')}return null};b.prototype.getAllClonesOfThisRow=function(){return this.getParentDocTable().getAllRowsClonedFrom(this)};b.prototype.setCustomView=function(a,c){a&&(this.view=a,this.view.dm=this,this.view.phElemID||(this.view.phElemID=this.getRowPrefix()),c&&this.displayRow())};
b.prototype.setIsEditable=function(a){void 0!==a&&a!=this.isEditable&&(this.isEditable=a)};b.prototype.isInactive=function(){return this.getParentDocTable().isInactive};b.prototype.setIsSelected=function(a,c){var j=this.isSelected!=(!0==a);this.hasDocRowSelector&&(this.isSelected=!0==a,c&&this.updateRowSelector());j&&f("#"+this.phElemID+"_rowSelector").trigger("change")};b.prototype.updateRowSelector=function(){f("#"+this.phElemID+"_rowSelector").prop("checked",this.isSelected)};b.prototype.validateDocToDownload=
function(a){this.isSelected&&(a.lockedDocFound||(a.lockedDocFound=!!this.docCheckedOutOwner),this.canUserDownloadDocument()?a.rowsToDownload.push(this):a.noPermDocNames.push(this.docName));this.aCatObj&&this.aCatObj.executeOnAllDocReferences(function(c){c.validateDocDownloadAction(a)},this)};b.prototype.displayRow=function(a){this.view.render();this.propsACatID&&null!=h.getRenderItem(this.renderOptions.columns,"ReferenceProperty")&&this._prepareReferenceCategoryObj(!1);h.getRenderItem(this.renderOptions.columns,
"ProjectAttribute")&&this._doForEachProject(function(a){a.categoryID&&this._prepareProjectCategoryObj(a,!1)});this.isAttrCatNeeded()&&this.showDocAttributeCategory(!1,a)};b.prototype.resetDocument=function(){k.getInstance().resetDocDataByDocVerID(this.docVerID);this.dependsOnItself=!1;this.modDate=this.docDesc=this.thumbnailURL=this.docVerIdx=this.appStatus=this.docName=this.docID=this.docVerID="";this.appTypeList=[];this.userPerms={};this.project={};this.projects=[];this.folder={};this.docType=this.docTypeID=
null;this.resetDocumentAttrCategory();this.isSelected=this.isChanged=!1};b.prototype.resetDocumentAttrCategory=function(){this.aCatID=null;this.renderedAttrCat={id:"",isEditable:!1};this.destroyACatObj(!0)};b.prototype.setIsChanged=function(){this.isChanged=!0;this.getParentDocTable()&&this.getParentDocTable().setIsChanged()};b.prototype.getIsChanged=function(){return this.isChanged};b.prototype.setIsNewDocVersionUploaded=function(a){this.isNewDocVersionUploaded=!!a};b.prototype.getIsNewDocVersionUploaded=
function(){return this.isNewDocVersionUploaded};b.prototype.setStatus=function(a){this.isInErrorStatus()||(this.status=a,this.isInErrorStatus()&&(this.view.repaintRow(),this.hideDocAttributeCategory(),this.view.newVersionBtn&&this.view.newVersionBtn.clearRow()))};b.prototype.isInErrorStatus=function(){return"noperm"==this.status||"error"==this.status};b.prototype.getParentDocTable=function(){return this.parentDocTable};b.prototype.getIndexInTable=function(){return this.getParentDocTable()?this.getParentDocTable().docRows.indexOf(this):
-1};b.prototype.getRowPrefix=function(){return this.prefix};b.prototype.getThisInDOM=function(){return this.getParentInDOM()+".getRowByID("+this.rowID+")"};b.prototype.getParentInDOM=function(){if(this.getParentDocTable())return this.getParentDocTable().getThisInDOM();h.error("Error: Cannot find itself in parent documents table!");return"window"};b.prototype.findPropertyByID=function(a,c){c||(c=this.props);if(c)for(var j=0;j<c.length;j++){var b=c[j];if(b.id==a)return b}return null};b.prototype.updatePropertyValues=
function(a){if(this.isAttrCatLoaded(this.propsACatObj)&&(a||(a=this.props),a))for(var c=0;c<a.length;c++){var j=a[c];if(j&&j.id){var b=this.propsACatObj.findAttribute(j.id,j.name);b&&(j.value=b.value)}}};b.prototype._updateDocInfo=function(a){var c=!1;if(a&&a.docVerID&&a.docVerID==this.docVerID){this.docID!=a.docID&&(c=!0,this.docID=a.docID);!this.docName&&this.docName!=a.docName&&(c=!0,this.docName=a.docName);!this.docDesc&&this.docDesc!=a.docDesc&&(c=!0,this.docDesc=a.docDesc);this.docVerIdx!=a.docVerIdx&&
(c=!0,this.docVerIdx=a.docVerIdx);this.latestDocVerIdx!=a.latestDocVerIdx&&(c=!0,this.latestDocVerIdx=a.latestDocVerIdx);this.docRevLetter!=a.docRevLetter&&(c=!0,this.docRevLetter=a.docRevLetter);this.appStatus!=a.appStatus&&(c=!0,this.appStatus=a.appStatus);this.thumbnailURL!=a.thumbnailURL&&(c=!0,this.thumbnailURL=a.thumbnailURL);this.docTypeID!=a.docTypeID&&(c=!0,this.docTypeID=a.docTypeID);"Move"!=this.docOperation&&(!this.project.id&&(a.projList[0]&&this.project.id!=a.projList[0].id)&&(c=!0,
this.project=d.extend(this.project,a.projList[0])),a.projList&&""+this.projects!=""+a.projList&&(c=!0,this.projects=[],d.each(a.projList,function(a){this.projects.push(d.extend({},a))},this)));this.isRemoteDocument()&&(this.projectCreationContext=!1);a.folderInfo&&(this.folder.id=a.folderInfo.id,this.folder.name=a.folderInfo.name);if(a.docVerAuthor&&(!this.docAuthor||this.docAuthor.id!=a.docVerAuthor.id))c=!0,this.docAuthor=a.docVerAuthor;if(this.modDate!=a.modDate)try{c=!0,this.modDate=a.modDate?
new Date(parseInt(a.modDate)):""}catch(j){h.log("Failed to parse '"+a.modDate+"' to a Date object."),this.modDate=""}a.userPerms&&(this.userPerms=a.userPerms);a.appTypeList&&(this.appTypeList=a.appTypeList);a.docCheckedOutOwner&&(this.docCheckedOutOwner=a.docCheckedOutOwner);this.updateDocAttrCategoryFromValue(a.catInfo)&&(c=!0)}else k.isEmptyValue(a)&&this.setStatus("noperm");return c};b.prototype.updateDocInfoFromServer=function(a,c){this.setStatus("loading");if(!this.docVerID)return f.Deferred().reject("Cannot update document info from server, this.docVerID is not known!").promise();
this.docInfoRequest=k.getInstance().getDocInfoWithThumbnail(this.docVerID,this.getDocSourceProjectID(),c);f.when(this.docInfoRequest).done(function(j){var j=this._updateDocInfo(j),b=this.updateOtherInfoFromServer(a,c);(j||b)&&a&&this.view.repaintRow()}.bind(this)).fail(function(a){this.setStatus("error");h.log(a)}.bind(this));return this.docInfoRequest};b.prototype.updateOtherInfoFromServer=function(){this._loadProjectStatusAndCategories().then(d.bind(function(){this.displayRow()},this)).catch(function(a){a&&
h.log("StaticDocumentRow.updateOtherInfoFromServer() has an error:"+a)});return!1};b.prototype._loadProjectStatusAndCategories=function(){var a=h.getRenderItem(this.renderOptions.columns,"ProjectProperty_ProjectStatus"),c=h.getRenderItem(this.renderOptions.columns,"ProjectAttribute");if(this.getParentDocTable().isProjectCreationContext()&&this.docOperation&&!("Link"==this.docOperation||"Reference"==this.docOperation))c=a=!1;return a||c?Promise.all(d.map(this._getProjects(),d.bind(function(c){return Promise.resolve(c).then(d.bind(function(a){return!a.statusID||
!a.categoryID?this._extendWithProjectInfo(a):a},this)).then(function(c){if(a){var j=c.statusID;if(j)return Promise.resolve(k.getInstance().getProjectStatuses()).then(function(a){if(a=a[j])c.statusObj=a;return c})}return c})},this))).catch(function(a){h.log("StaticDocumentRow._loadProjectStatusAndCategories() has an error:"+a)}):Promise.reject()};b.prototype.getDocSourceProjectID=function(){if(this.sourceProjID)return this.sourceProjID;if(!this.isRemoteDocument())return this.getParentDocTable().projectID;
if(this.projects&&0<this.projects.length){if(this.project&&this.project.id){var a=d.find(this.projects,function(a){return a&&a.id==this.project.id},this);if(a)return a.id}return this.projects[0]}return null};b.prototype._doForEachProject=function(a){var c=this.projects;if(c&&0<c.length)for(var j=0;j<c.length;j++)a.call(this,c[j]);else this.project&&this.project.id&&a.call(this,this.project)};b.prototype._getProjects=function(){var a=[],c=this.projects;if(c&&0<c.length)for(var j=0;j<c.length;j++)a.push(c[j]);
else this.project&&this.project.id&&a.push(this.project);return a};b.prototype._extendWithProjectInfo=function(a){return Promise.resolve().then(function(){if(a&&a.id)return Promise.resolve(k.getInstance().getProjectInfo(a.id)).then(function(c){return a=d.extend(a,c)});throw Error("Project or Project ID is undefined");})};b.prototype.isInConfigPreview=function(){return this.getParentDocTable().isInConfigPreview};b.prototype.isRemoteDocument=function(){var a=!0;return a=this.projects&&1<this.projects.length?
!d.find(this.projects,function(a){return a.id==this.getParentDocTable().projectID},this):this.project.id&&this.project.id!=this.getParentDocTable().projectID};b.prototype.isLatestDocVersion=function(){return this.latestDocVerIdx&&this.docVerIdx==this.latestDocVerIdx};b.prototype.hasAttrCat=function(){return!!this.aCatID&&!k.isEmptyValue(this.aCatID)&&h.isValidID(this.aCatID)};b.prototype.hasNoAttrCat=function(){return!!this.aCatID&&k.isEmptyValue(this.aCatID)};b.prototype.setDocumentHasNoAttrCategory=
function(){this.aCatID=k.getEmptyValue();this.destroyACatObj(!0)};b.prototype.isAttrCatNeeded=function(){return h.getRenderItem(this.renderOptions.columns,"AttributeFlapout")||h.getRenderItem(this.renderOptions.columns,"DocumentAttribute")?!0:!1};b.prototype.isAttrCatUpdateNeeded=function(){return this.renderedAttrCat.id!=this.aCatID||this.renderedAttrCat.isEditable!=this.canUserEditExpandedAttributes()};b.prototype.isAttrCatLoaded=function(a){return a&&a.loaded};b.prototype.canUserEditAttributes=
function(){return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&this.userPerms.change};b.prototype.canUserEditExpandedAttributes=function(){return this.canUserEditAttributes()&&this.isExpandedAttrsEditable};b.prototype.canUserEditProperties=function(){return!this.isInactive()&&this.isEditable&&!this.dependsOnItself};b.prototype.canUserAddDocuments=function(){return this.getParentDocTable().canUserAddDocuments};b.prototype.canUserDownloadDocument=function(){return this.userPerms.download};
b.prototype.canUserUploadNewVersion=function(){return!this.isInactive()&&!this.isInErrorStatus()&&!!this.isLatestDocVersion()&&!this.dependsOnItself&&1!=this.getParentDocTable().docReferenceMode&&!!this.userPerms.checkout&&!this.isModifiedElsewhere()};b.prototype.isModifiedElsewhere=function(){return!0===this.getParentDocTable().isModifiedElsewhere};b.prototype.updateDocAttrCategoryFromValue=function(a){var c=!1;a?(a.id?(this.aCatID!=a.id&&(c=!0),this.aCatID=a.id):(k.isEmptyValue(this.aCatID)||(c=
!0),this.setDocumentHasNoAttrCategory()),this.aCatModDate=a.modTime):(k.isEmptyValue(this.aCatID)||(c=!0),this.setDocumentHasNoAttrCategory());return c};b.prototype._initializeAndRenderAttrCategoryObj=function(a,c){if(!this.getParentDocTable().parentACatNotExpandedYet&&0!=f("#"+this.aCatElemID).length)if(this.hasAttrCat()){this.setStatus("loading");var j=e.getCloneOfObject(this.getParentDocTable().currentUser);j.canEditAttributes=this.canUserEditExpandedAttributes();var b=[],d=this.getParentDocTable().parentDocVerIDs;
d&&0<d.length&&(b=e.getCloneOfArray(d));this.docVerID?b.push(this.docVerID):this.newDocTmpID?b.push(this.newDocTmpID):window.alert("Problems in composing inheritance path!!!");var i={};i.prefix=this.aCatPrefix;i.ACatObj=this.aCatElemID;i.ACatPanel=this.aCatElemID;i.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+this.aCatID+"&ajax=1";this.aCatModDate&&(i.readURL+="&lastmodified="+this.aCatModDate);i.valuesURL=this.generateDocAttributeValuesAJAXURL();i.valuesURL||
(i.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?categoryid="+this.aCatID+"&ajax=1");i.currentUser=j;i.view=this.getAttCatView();i.type="document";i.projectID=this.project.id;i.documentID=this.docID;this.docVerID&&(i.docVersionID=this.docVerID);a&&(i.callbackOnRender=a);c&&(i.callbackOnFail=c);i.callbackOnLoad=function(){this.aCatObj.noCurrentViewDisplay&&this.getParentDocTable().autoExpandAllRows&&(this.aCatExpandDisabled=!0,this.showDocAttributeCategory())}.bind(this);i.docTableParentDocVerIDs=
b;i.level=b.length;i.projectCreationContext=this.projectCreationContext;if(0<i.level&&("Link"==this.docOperation||"Reference"==this.docOperation))i.projectCreationContext=!1;i.parentDocRow=this;i.isInactive=this.isInactive();i.aCatNotExpandedYet=this.aCatNotExpandedYet;this.renderOptions.styleObj&&(i.defaultStyleObject=this.renderOptions.styleObj.inlineStyleObject);require(["attributecategory/AttributeCategory"],function(a){a=new a(i);this.aCatObj&&this.aCatObj.destroy(!0);this.aCatObj=a;var c=this.getParentDocTable().getRootLevelTable();
c&&c.onChangeCallback&&this.aCatObj.valueChangedListeners.push(function(){c.onChangeCallback()}.bind(this))}.bind(this));this.renderedAttrCat.id=this.aCatID;this.renderedAttrCat.isEditable=j.canEditAttributes}else h.log("Attempt to render attribute category when its ID is not known!")};b.prototype._initializeAndRenderReferenceCategoryObj=function(a,c){if(!this.getParentDocTable().parentACatNotExpandedYet&&0!=f("#"+this.propsACatElemID).length)if(this.propsACatID){this.setStatus("loading");this.propsValuesInitialized=
!1;var j=e.getCloneOfObject(this.currentUser);j.canEditAttributes=this.canUserEditProperties();var b={};b.prefix=this.propsACatPrefix;b.ACatObj=this.propsACatElemID;b.ACatPanel=this.propsACatElemID;b.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+this.propsACatID+"&ajax=1";b.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?categoryid="+this.propsACatID+"&ajax=1";b.currentUser=j;b.isDocRefPropertiesACat=!0;a&&(b.callbackOnRender=a);c&&(b.callbackOnFail=
c);require(["attributecategory/AttributeCategory"],function(a){a=new a(b);this.propsACatObj&&this.propsACatObj.destroy(!0);this.propsACatObj=a;var c=this.getParentDocTable().getRootLevelTable();c&&c.onChangeCallback&&this.propsACatObj.valueChangedListeners.push(function(){c.onChangeCallback()}.bind(this))}.bind(this))}else h.log("Attempt to initialize reference properties when reference category ID is not known!")};b.prototype._initializeAndRenderProjectCategoryObj=function(a,c,j){if(!this.getParentDocTable().parentACatNotExpandedYet)if(!a||
!a.id||!a.categoryID)h.log("Attempt to initialize project attributes when project or attribute category ID is not known!");else if(0!=f("#"+(this.projACatElemIDPrefix+a.id)).length){this.setStatus("loading");var b=e.getCloneOfObject(this.currentUser);b.canEditAttributes=this.canUserEditProperties();var d={};d.prefix=this.projACatPrefix+a.id;d.ACatObj=this.projACatElemIDPrefix+a.id;d.ACatPanel=this.projACatElemIDPrefix+a.id;d.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+
a.categoryID+"&ajax=1";d.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?projectid="+a.id;d.type="project";d.projectID=a.id;d.currentUser=b;d.aCatNotExpandedYet=this.aCatNotExpandedYet;d.isProjectInfoACat=!0;c&&(d.callbackOnRender=c);j&&(d.callbackOnFail=j);require(["attributecategory/AttributeCategory"],function(a){a=new a(d);this.aCatObj&&this.aCatObj.destroy(!0);this.aCatObj=a}.bind(a))}};b.prototype.generateDocAttributeValuesAJAXURL=function(){var a=null;this.docVerID&&(a=window.webcenterConfig.jspBaseUrl+
"GetAttributes.jsp?docverid="+this.docVerID);return a};b.prototype.showDocAttributeCategory=function(a,c){this.aCatExpandDisabled&&(c=!1);this.docVerID&&!this.aCatID?(this.docInfoRequest.done(function(j){var b=!1;this.aCatID||(b=this.updateDocAttrCategoryFromValue(j.catInfo));this._showDocAttributeCategory(a||b,c)}.bind(this)),this.docInfoRequest.fail(function(){this.hideDocAttributeCategory()}.bind(this))):this.hasAttrCat()?this._showDocAttributeCategory(a,c):this.hideDocAttributeCategory()};b.prototype.getExpColButton=
function(){return f("#"+this.getRowPrefix()+" > "+this.view.itemRootElemStr+" > i.expandCollapseButton")};b.prototype._expandDocAttrCat=function(a){this.aCatExpandDisabled||(a||(a=this.getExpColButton()),this.dependsOnItself?a.removeClass("icon-WCR_Plus-square expandDepButton").addClass("icon-WCR_Refresh cyclicDepButton").attr("title",i.xmlencode(l.t("DocRowCyclicDepTooltip"))):a.removeClass("icon-WCR_Plus-square expandDepButton icon-WCR_Refresh cyclicDepButton").addClass("icon-WCR_Minus-square collapseDepButton").attr("title",
i.xmlencode(l.t("DocRowCollapseTooltip"))),f("#"+this.aCatRowID).removeClass("hiddenElement"),this.aCatExpanded=!0,this.aCatNotExpandedYet&&this.setACatIsExpanded())};b.prototype.setACatIsExpanded=function(){this.aCatNotExpandedYet=!1;this.aCatObj&&(this.aCatObj.setACatIsExpanded(),this.displayRow())};b.prototype._collapseDocAttrCat=function(a){a||(a=this.getExpColButton());this.dependsOnItself?a.removeClass("icon-WCR_Minus-square collapseDepButton").addClass("icon-WCR_Refresh cyclicDepButton").attr("title",
i.xmlencode(l.t("DocRowCyclicDepTooltip"))):a.removeClass("icon-WCR_Minus-square collapseDepButton icon-WCR_Refresh cyclicDepButton").addClass("icon-WCR_Plus-square expandDepButton").attr("title",i.xmlencode(l.t("DocRowExpandTooltip")));f("#"+this.aCatRowID).addClass("hiddenElement");this.aCatExpanded=!1};b.prototype._showDocAttributeCategory=function(a,c){(a||this.isAttrCatUpdateNeeded())&&this.destroyACatObj(!0);if(!this.hasAttrCat()||!this.isAttrCatNeeded())this.hideDocAttributeCategory();else{var j=
this.getExpColButton();this.aCatExpandDisabled?(j.addClass("hiddenElement"),this.aCatExpanded&&this.hideDocAttributeCategory()):j.removeClass("hiddenElement");if(this.dependsOnItself)this._collapseDocAttrCat(j);else if(c||this.aCatExpanded?this._expandDocAttrCat(j):this._collapseDocAttrCat(j),j=null!=h.getRenderItem(this.renderOptions.columns,"DocumentAttribute"),!this.aCatNotExpandedYet||j)if(this.aCatObj){var j=!1,b=f("#"+this.aCatElemID);1==b.length&&b[0].ACatObj!=this.aCatObj&&(b[0].ACatObj=this.aCatObj,
j=!0);j&&(this.aCatObj.isInactive=this.isInactive(),this.aCatObj.displayAttributeCategory())}else this._initializeAndRenderAttrCategoryObj(this._onAttrCategoryReady.bind(this,"docCat"),this._onAttrCategoryLoadFailed.bind(this))}};b.prototype._prepareReferenceCategoryObj=function(a){if(this.propsACatID)if(a&&this.destroyPropsACatObj(!0),this.propsACatObj){var a=!1,c=f("#"+this.propsACatElemID);1==c.length&&c[0].ACatObj!=this.propsACatObj&&(c[0].ACatObj=this.propsACatObj,a=!0);a&&this.propsACatObj.displayAttributeCategory()}else this._initializeAndRenderReferenceCategoryObj(this._onAttrCategoryReady.bind(this,
"refPropsCat"),this._onAttrCategoryLoadFailed.bind(this));else h.log("StaticDocumentRow._prepareReferenceCategoryObj() called when no reference category ID known (or it was nullified)")};b.prototype._prepareProjectCategoryObj=function(a,c){if(a.categoryID)if(c&&this.destroyProjACatObj(a,!0),a.aCatObj){var b=!1,d=f("#"+this.projACatElemIDPrefix+a.id);1==d.length&&d[0].ACatObj!=a.aCatObj&&(d[0].ACatObj=a.aCatObj,b=!0);b&&a.aCatObj.displayAttributeCategory()}else this._initializeAndRenderProjectCategoryObj(a,
this._onAttrCategoryReady.bind(this,"projInfoCat"),this._onAttrCategoryLoadFailed.bind(this));else h.log("StaticDocumentRow._prepareProjectCategoryObj() called when no attribute category ID known (or it was nullified)")};b.prototype._onAttrCategoryReady=function(a){var c=!0;if("refPropsCat"==a&&this.isAttrCatLoaded(this.propsACatObj)){if(!this.propsValuesInitialized){for(a=0;a<this.props.length;a++){var b=this.props[a];if(b&&b.id){var d=this.propsACatObj.findAttribute(b.id,b.name);d&&d.copyValueFromDocRefProp(b)}}this.propsValuesInitialized=
!0}}else"docCat"==a&&this.isAttrCatLoaded(this.aCatObj)&&(!this.aCatNotExpandedYet&&this.aCatObj.aCatNotExpandedYet)&&(this.setACatIsExpanded(),c=!1);this.setStatus("ready");c&&this.view.repaintRow()};b.prototype._onAttrCategoryLoadFailed=function(){this.setStatus("error");h.log("Failed to load attribute category.")};b.prototype.hideDocAttributeCategory=function(){var a=this.getExpColButton();this._collapseDocAttrCat(a);this.hasAttrCat()||(a.addClass("hiddenElement"),a=f("#"+this.aCatElemID),this.aCatObj&&
this.aCatObj!==a.ACatObj&&this.aCatObj.destroy(!0),a.ACatObj&&a.ACatObj.destroy(!0),this.aCatObj=this.aCatID=null,a.ACatObj=null,a.html(""))};b.prototype.collapseAllDescendants=function(){this.aCatObj&&this.aCatObj.executeOnAllDocReferences(function(a){a.collapseAllRows()},this);this._collapseDocAttrCat()};b.prototype.selectAllDescendants=function(a){this.aCatObj&&this.aCatExpanded&&this.aCatObj.executeOnAllDocReferences(function(c){c.setSelectAllRows(a)},this);this.setIsSelected(a,!0)};b.prototype.deleteItself=
function(a){for(var c=this.getAllDescendantRows(),b=this.getAllRowsCopiedFromRows(c),i=0;i<c.length;i++){var e=c[i],h=d.filter(b,function(a){return a.copyOfExistingRowID==e.rowID});if(0<h.length){var k=h[0];k.copyOfExistingRowID=e.copyOfExistingRowID;k.salvageValuablesFromDocRow(e);for(var l=1;l<h.length;l++)h[l].copyOfExistingRowID=k.rowID}h=e.getAllClonesOfThisRow();if(0<h.length){k=h[0];k.clonedFrom=e.clonedFrom;k.salvageValuablesFromDocRow(e);for(l=1;l<h.length;l++)h[l].clonedFrom=k}}this.destroy(!0);
a?f("#"+this.view.phElemID).empty():f("#"+this.view.phElemID).remove();f("#"+this.aCatRowID).remove();this.view._newVersionRow&&this.view._newVersionRow.remove()};b.prototype.salvageValuablesFromDocRow=function(){};b.prototype.swapWith=function(a){this.aCatObj&&this.aCatObj.beforeMove();var c=f("#"+this.view.phElemID).parent(),b=f("#"+a.view.phElemID).parent();c.insertAfter(b);this.displayRow();a.view.repaintRow();this.aCatObj&&this.aCatObj.afterMove()};b.prototype.setDependsOnItself=function(a){this.dependsOnItself=
!0==a};b.prototype.convertRefPropertiesToXML=function(){var a="";try{if(this.props&&0<this.props.length){for(var a=a+"<refatts>",c=0;c<this.props.length;c++){var b=this.props[c];b&&b.id&&(a+="<att>",a+=i.ElementEncode("id",b.id),a+="</att>")}a+="</refatts>";a+=i.ElementEncode("refprefix",this.propsACatPrefix)}}catch(d){h.log("Problem in StaticDocumentRow.convertRefPropertiesToXML:\n"+d),a=""}return a};b.prototype.convertUploadNewVersionToXML=function(){var a="";if(this.view.newVersionBtn&&this.view.newVersionBtn.isExpanded&&
this.view._newVersionCell){var c=this.view._newVersionCell,a=a+"<ds>"+i.ElementEncode("action","UploadNewVersion"),a=a+i.ElementEncode("file_form_field","newVersionDocFile_"+this.docVerID),a=a+i.ElementEncode("version_comment",c.find("input[name=newVersionDocDesc_"+this.docVerID+"]").val()),a=a+i.ElementEncode("raise_revision","checked"==c.find("input[name=incrementRevision_"+this.docVerID+"]").attr("checked")?"1":"0"),a=a+i.ElementEncode("update_all_projects","checked"==c.find("input[name=updateAllProjects_"+
this.docVerID+"]").attr("checked")?"1":"0"),a=0<f("input[name=AppCycleFlag"+this.docVerID+"]").length?a+i.ElementEncode("start_approval","checked"==c.find("input[name=AppCycleFlag"+this.docVerID+"]").attr("checked")?"1":"0"):a+i.ElementEncode("start_approval",c.find("input[name=startApprovalDefaultValue"+this.docVerID+"]").val());void 0!=c.find("input[name=due_date"+this.docVerID+"]").val()&&(a+=i.ElementEncode("approval_due_date",c.find("input[name=due_date"+this.docVerID+"]").val()));void 0!=c.find("select[name=due_periodOfDay"+
this.docVerID+"]").val()&&(a+=i.ElementEncode("approval_due_period",c.find("select[name=due_periodOfDay"+this.docVerID+"]").val()));a+="</ds>"}return a};b.prototype.convertToXML=function(a){var c="";try{c+="<dr>";this.drID&&(c+=i.ElementEncode("id",this.drID));a&&0<a.length&&(c+=a);this.docVerID&&(c+=i.ElementEncode("dv",this.docVerID),this.docVerIdx&&(c+=i.ElementEncode("dvidx",this.docVerIdx)),this.docID&&(c+=i.ElementEncode("doc_id",this.docID)),this.docName&&(c+=i.ElementEncode("dn",this.docName)));
this.appStatus&&this.appStatus.cycleStatus&&(c+=i.ElementEncode("astat",this.appStatus.cycleStatus));if(this.isEditable||this.getIsNewDocVersionUploaded())c+=this.convertUploadNewVersionToXML();this.isEditable&&(c+=this.convertRefPropertiesToXML());this.isInErrorStatus()||(c+=i.ElementEncode("daprefix",this.aCatPrefix));c+="</dr>"}catch(b){h.log("Problem in StaticDocumentRow.convertToXML:\n"+b),c=""}return c};b.prototype.validateDocRow=function(a,c){var b=!0;if(this.isInactive())return b;if(this.isAttrCatLoaded(this.aCatObj)){var d=
[];if(this.canUserEditAttributes()&&!a.isTemplate){var i=this.renderOptions.columns;if(i)for(var e=0;e<i.length;e++){var h=i[e];if(h&&h.type&&"DocumentAttribute"==h.type){var k=h.typeDetail;d.push(k);if("Required"==h.visibility&&(h=this.aCatObj.findAttribute(k,h.attributeName))&&!h.value)b={level:c,attrLabel:this.aCatObj.getAttributeLabel(h),element:f("#"+this.aCatObj.prefix+h.id).closest("td"),docRowObj:this},a.errors.push(b),b=!1}}}this.aCatObj.validateAttributes(!1,a,d,this,c+1)||(b=!1)}if(this.canUserEditProperties()&&
!a.isTemplate&&this.props&&this.isAttrCatLoaded(this.propsACatObj))for(e=0;e<this.props.length;e++)if((d=this.props[e])&&d.id&&d.isRequired)if((i=this.propsACatObj.findAttribute(d.id,d.name))&&!i.value)b={level:c,msg:l.t("DocRowPropertyRequiredButNull",d.name),element:f("#"+this.propsACatObj.prefix+i.id).closest("td"),docRowObj:this},a.errors.push(b),b=!1;if(this.view.newVersionBtn&&(d=this.view.newVersionBtn.validate())&&0<d.length){for(e=0;e<d.length;e++)b=d[e],b.level=c,b.docRowObj=this,a.errors.push(b);
b=!1}return b};b.prototype.expandBranchTillThis=function(a){for(var c=this.getRowPrefix().split("_"),b=1,d=0,e="";d+2<c.length&&b<a;){var i=c[d]+"_"+c[++d],h=e+i+"_docTable",k=c[++d],h=f("#"+h);if(1==h.length&&(h=h[0].docTable))(h=h.getRowByID(k))&&h.showDocAttributeCategory(!1,!0);e+=i+"_"+k+"_ACat_";d+=2;b++}};b.prototype._onSubmit=function(){this.aCatObj&&!this.isInactive()&&this.aCatObj.convertDocReferencesToXML()};b.prototype.expandClicked=function(a){a&&(a=f(a),a.hasClass("cyclicDepButton")||
(a.hasClass("expandDepButton")?this.showDocAttributeCategory(!1,!0):a.hasClass("collapseDepButton")&&this.hideDocAttributeCategory()))};b.prototype.selectRowClicked=function(a){this.setIsSelected(a&&a.checked);this.getParentDocTable().updateAllRowsSelector()};b.prototype.destroy=function(a){this.destroyACatObj(a);this.destroyPropsACatObj(a);this.destroyProjACatObjAll(a);this.view.destroy(a)};b.prototype.destroyACatObj=function(a){this.aCatObj&&this.aCatObj.destroy(a);a&&(this.aCatObj=null)};b.prototype.destroyPropsACatObj=
function(a){this.propsACatObj&&this.propsACatObj.destroy(a);a&&(this.propsACatObj=null)};b.prototype.destroyProjACatObjAll=function(a){var c=this.projects;if(c&&0<c.length)for(var b=0;b<c.length;b++){var d=c[b];d&&this.destroyProjACatObj(d,a)}else this.project&&this.destroyProjACatObj(this.project,a)};b.prototype.destroyProjACatObj=function(a,c){a.aCatObj&&a.aCatObj.destroy(c);c&&(a.aCatObj=null)};b.prototype.reconstruct=function(){this.aCatObj&&this.aCatObj.reconstruct()};b.prototype.getAttCatView=
function(){return this.aCatView||"Default"};return b});
define("doctablex/DocumentRowView",["doctablex/StaticDocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(h,n,k,l){var e=function(e,d,f){if(!e&&!d&&!f)return this;h.call(this,e,d,f);return this};e.prototype=new h;e.prototype.constructor=e;e.prototype.parent=h.prototype;e.prototype.renderDocTemplateSelector=function(e){var d=$("<div>");try{var f=this.dm.docTemplates;if(!f||0==f.length)return;if("FixedDocTemplate"==this.dm.docTempType){var b=$("<div>").text(k.t("PROJ_CREATION_DOCUMENT_TEMPLATE")),
a=$("<div>",{"class":this.getSAHIHelperStr("doctemplate")}).text(f[0].name);d.append(b,a)}else{var c="javascript: "+this.dm.getThisInDOM()+".docTemplateSelected(this.value);",j=$("<select>",{"class":"docname-input "+this.getSAHIHelperStr("doctemplate"),onChange:c}),r=$("<option>",{value:-1}).text(k.t("SELECTDOCTEMPLATE"));this.dm.selDocTemplate||r.attr("selected","selected");j.append(r);if(f)for(b=0;b<f.length;b++){var h=f[b],l=$("<option>",{value:b}).text(h.name);this.dm.selDocTemplate==h&&l.attr("selected",
"selected");j.append(l)}this.dm.isEditable||j.prop("disabled",!0);d.append(j)}!1===e&&d.hide()}catch(p){n.log("Problem in DocumentRowView.renderDocTemplateSelector:\n"+p)}return d};e.prototype.renderDocFolderSelector=function(e){var d=$("<div>");try{var f=this.dm.targetFolders;if(!f||0==f.length)return d;if(1==f.length){var b=f[0].name;"0"==f[0].id&&(b=k.t("DEFAULT_FOLDER_ROOT"));var a=$("<span>",{"class":this.getSAHIHelperStr("docfolder")}).text(k.t("FOLDER")+": "+b);d.append(a)}else{var c="javascript: "+
this.dm.getThisInDOM()+".targetFolderSelected(this.value);",j=$("<select>",{"class":"docname-input "+this.getSAHIHelperStr("docfolder"),onChange:c});this.dm.isEditable||j.prop("disabled",!0);var r=f[0].id;this.dm.selTargetFolder&&(r=this.dm.selTargetFolder.id);b=!1;if(this.dm.selDocTemplate){this.dm.selTargetFolder.isDefaultFromDocTempl&&(b=!0);var h=(new $("<option>",{value:-1})).text(k.t("DEFAULT_FOLDER_TEMPLATE"));b&&h.attr("selected","selected");j.append(h)}for(a=0;a<f.length;a++){var l=f[a],
p=r==l.id&&!b,h=new $("<option>",{value:a});p&&h.attr("selected","selected");"0"==l.id?h.text(k.t("DEFAULT_FOLDER_ROOT")):h.text(l.name);j.append(h)}d.append(j)}!1===e&&d.hide()}catch(s){n.log("Problem in DocumentRowView.renderDocFolderSelector:\n"+s)}return d};e.prototype.showAdvancedDocumentActions=function(){return!1};e.prototype.renderRowSelector=function(e){e.append("<"+this.itemRootElemStr+' class="center">')};e.prototype.renderReplaceButton=function(e){try{var d=$("<"+this.itemRootElemStr+
">",{"class":"center"});if(this.dm.origDocRow&&"Replace"==this.dm.docFlowType){var f=$("<button>").addClass("btn btn-xs btn-default actionBtn").attr("title",l.xmlencode(k.t("DocRowLocalRemoteResetButtonTooltip"))),b=$("<i>",{"class":"icon icon-normal activIcon icon icon icon-WCR_Revert"});f.append(b);f.on("click",function(){this.dm.getParentDocTable().localRemoteButtonClicked(this.rowIndex);return!1}.bind(this));d.append(f)}e.append(d)}catch(a){n.log("Problem in DocumentRowView.renderReplaceButton:\n"+
a)}};e.prototype.getAutoNamingPreview=function(){var e=0;this.dm.anCounterLength&&(e=this.dm.anCounterLength);for(var d="",f=0;f<e;f++)d+="X";e="";this.dm.anPrefix&&(e=this.dm.anPrefix);f="";this.dm.anSuffix&&(f=this.dm.anSuffix);var b=/^'(.*)'$/.exec(e);null!=b&&1<b.length&&(e=b[1]);b=/^'(.*)'$/.exec(f);null!=b&&1<b.length&&(f=b[1]);return e+d+f};e.prototype.renderCloneButton=function(e){try{var d="",d=d+("<"+this.itemRootElemStr+"/>");e.append(d)}catch(f){n.log("Problem in DocumentRowView.renderCloneButton:\n"+
f)}};return e});
define("doctablex/DocumentRow","doctablex/StaticDocumentRow doctablex/DocumentRowView doctablex/DocTableXUtils doctablex/AJAXDataCache wcr/webcenter_xml utils/EventBasedValidator utils/webi18n!DocRefStrings underscore jquery".split(" "),function(h,n,k,l,e,i,d,f,b){var a=function(c){if(!c)return this;c.viewClass||(c.viewClass=n);h.call(this,c);this.newDocTmpID=null;this.docOperation=c.operation||null;this.docFlowType=c.flowType||null;this.useDocTypeDefaultACat=!1;this.origDocRow=c.origDocRow||null;
this.hasOrigDocACat=!1;this.docVerIdx="1";this.docRevLetter="";this.latestDocVerIdx="1";if(!this.project||!this.project.id)this.project={id:this.getParentDocTable().projectID};this.projects||(this.projects=[this.project]);this.sourceProjID=c.sourceProjID||null;this.isChangedByUser=!1;this.fieldsModByUser=[];this.docNameSuffix=null;this.anPrefix=c.anPrefix||null;this.anSuffix=c.anSuffix||null;this.anCounterLength=c.anCounterLength||0;this.docTempType=c.docTempType;this.docTempType||(this.docTempType=
"AnyDocTemplate");this.docTempNames=c.docTempNames||"";this.docTemplates=c.docTemplates||null;this.selDocTemplate=c.selDocTemplate||null;this.defTaskDocAttrCatID=this.getParentDocTable().defTaskDocAttrCatID;this.targetFolderName=c.targetFolderName||"";this.defaultTargetFolderName=null==c.defaultTargetFolderName?this.targetFolderName:c.defaultTargetFolderName;this.targetFolders=c.targetFolders||null;this.selTargetFolder=c.selTargetFolder||null;this.defTaskDocFolderName=this.getParentDocTable().defTaskDocFolderName;
this.constructor==a.prototype.constructor&&this.setStatus("ready");this._validationCallback=f.bind(function(a){this.validateDocRowUniqueName(a)},this);i.getInstance().onValidateUniqueDocName(this._validationCallback);return this};a.prototype=new h;a.prototype.constructor=a;a.prototype.parent=h.prototype;a.prototype.getDocRowInfo=function(){var c=a.prototype.parent.getDocRowInfo.call(this);f.extend(c,{docOperation:this.docOperation,docFlowType:this.docFlowType,origDocRow:this.origDocRow,hasOrigDocACat:this.hasOrigDocACat,
anPrefix:this.anPrefix,anSuffix:this.anSuffix,anCounterLength:this.anCounterLength,docTempType:this.docTempType,docTempNames:this.docTempNames,targetFolderName:this.targetFolderName,docTemplates:this.docTemplates,selDocTemplate:this.selDocTemplate,targetFolders:this.targetFolders,selTargetFolder:this.selTargetFolder,sourceProjID:this.sourceProjID});return c};a.prototype.resetDocument=function(c){this.anSuffix=this.anPrefix=null;this.anCounterLength=0;c&&(a.prototype.parent.resetDocument.call(this),
this.isChangedByUser=!1,this.fieldsModByUser=[])};a.prototype.updateDocAttrCategoryFromValue=function(c){var b=!this.aCatID,c=a.prototype.parent.updateDocAttrCategoryFromValue.call(this,c);b&&(this.hasOrigDocACat=this.hasAttrCat());return c};a.prototype._strippedUpdateDocInfo=function(c){var b=!1;"Copy"==this.docOperation?(this.docDesc="",c&&c.docVerID&&c.docVerID==this.docVerID?(!this.docName&&this.docName!=c.docName&&(b=!0,this.docName=c.docName),this.thumbnailURL!=c.thumbnailURL&&(b=!0,this.thumbnailURL=
c.thumbnailURL),this.docTypeID!=c.docTypeID&&(b=!0,this.docTypeID=c.docTypeID),this.projectCreationContext&&this.isRemoteDocument()&&(this.projectCreationContext=!1),c.folderInfo&&(this.folder.id=c.folderInfo.id,this.folder.name=c.folderInfo.name),c.appTypeList&&(this.appTypeList=c.appTypeList),this.updateDocAttrCategoryFromValue(c.catInfo)&&(b=!0)):l.isEmptyValue(c)&&this.setStatus("noperm")):b=a.prototype.parent._updateDocInfo.call(this,c);return b};a.prototype.canUserEditAttributes=function(){var a=
!1;this.selTargetFolder?a=this.selTargetFolder.changePropPerm:this.getParentDocTable().isBlankProjectCreationContext()&&(a=!0);return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&a};a.prototype.canUserDownloadDocument=function(){return!1};a.prototype.generateDocAttributeValuesAJAXURL=function(){var a=window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&k.isValidID(this.selDocTemplate.categoryID)?(a=a+"GetAttributes.jsp?doctemplate=1"+("&projectid="+
this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):k.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:k.log("Cannot generate URL in DocumentRowNew.generateDocAttributeValuesAJAXURL().");return a};a.prototype.setIsChangedByUser=function(a){if(!this.isChangedByUser){this.isChangedByUser=!0;if(this.newDocTmpID){if(!this.storedState||!this.storedState.newDocTmpID)this.storedState=
{newDocTmpID:this.newDocTmpID};this.setNewDocTmpID("newID_"+k.getNextUniquePrefix())}this.copyOfExistingRowID=null;!1!==a&&(this.view.repaintRow(),a=!1)}a&&this.view.repaintRow()};a.prototype.setNewDocTmpID=function(a){this.newDocTmpID=a};a.prototype.isModifiedByUser=function(a){return-1<this.fieldsModByUser.indexOf(a)};a.prototype.setFieldModByUser=function(a,b){if(b){var d=this.fieldsModByUser.indexOf(a);-1<d&&this.fieldsModByUser.splice(d,1)}else this.fieldsModByUser.push(a)};a.prototype.isAutonamingEnabled=
function(){return null!=this.anPrefix&&0<this.anPrefix.length};a.prototype.hasAutonameSuffix=function(){return this.anSuffix&&-1<this.anSuffix.toLowerCase().indexOf("[editfield]")};a.prototype.setIsSelected=function(){this.isSelected=!1};a.prototype.selectAllDescendants=function(){};a.prototype.updateDocumentType=function(a,b){var d=a.docTypeList;if(d&&this.docTypeID)for(var f=this.getParentDocTable().isBlankProjectCreationContext(),e=f&&!a.useDefAutoname4BlankProj,f=f&&!a.useDefCategory4BlankProj,
i=0;i<d.length;i++){var h=d[i];if(this.docTypeID==h.id){this.docType=h;e||(this.anPrefix=h.anPrefix,this.anSuffix=h.anSuffix,this.anCounterLength=h.anCounterLength);this.selDocTemplate&&(this.aCatID=this.selDocTemplate.categoryID);!this.hasAttrCat()&&(this.useDocTypeDefaultACat&&!f)&&(this.aCatID=h.categoryID);b&&(this.view.repaintRow(),this.showDocAttributeCategory(!1,!0));break}}};a.prototype.updateDocTemplates=function(a){this.docTemplates=[];if(a&&!(0==a.length||this.isInConfigPreview()))if(!this.docTempType||
"AnyDocTemplate"==this.docTempType)this.docTemplates=a;else if("NoDocTemplate"!=this.docTempType)if("FixedDocTemplate"==this.docTempType){var b=this.docTempNames[0];if(b){for(var d=0;d<a.length;d++){var f=a[d];if(f&&f.name&&f.name.toLowerCase()==b){this.docTemplates.push(f);break}}1==this.docTemplates.length&&this.updateDocTemplateSelection(0)}}else if("ListDocTemplate"==this.docTempType)for(d=0;d<a.length;d++)(f=a[d])&&(f.name&&0<=this.docTempNames.indexOf(f.name.toLowerCase()))&&this.docTemplates.push(f)};
a.prototype.preselectDocTemplate=function(){if(!this.docTempType||!("NoDocTemplate"==this.docTempType||"FixedDocTemplate"==this.docTempType)){var a=this.origFileExt;a||(a=this.fileExt);a=this._matchDocTemplate("default."+a);0>a&&(a=this._matchDocTemplate("default"));this.updateDocTemplateSelection(a)}};a.prototype._matchDocTemplate=function(a){if(this.docTemplates)for(var b=0;b<this.docTemplates.length;b++)if(this.docTemplates[b].name.toLowerCase()==a)return b;return-1};a.prototype.updateDocTemplateSelection=
function(a){-1==a?(this.selDocTemplate=null,this.defTaskDocAttrCatID?this.aCatID=this.defTaskDocAttrCatID:this.docType&&this.useDocTypeDefaultACat&&(this.aCatID=this.docType.categoryID)):this.docTemplates&&(0<=a&&a<this.docTemplates.length)&&(this.selDocTemplate=a=this.docTemplates[a],this.aCatID=a.categoryID,!this.hasAttrCat()&&(this.docType&&this.useDocTypeDefaultACat)&&(this.aCatID=this.docType.categoryID));this.preselectTargetFolder()};a.prototype.updateTargetFolders=function(a,b){if(!this.targetFolders||
b)a&&0<a.length&&!this.isInConfigPreview()?this.targetFolders=a:(this.targetFolders=[],this.selTargetFolder=null)};a.prototype.preselectTargetFolder=function(){if(!this.targetFolders||0==this.targetFolders.length)this.selTargetFolder=null;else if(!this.isModifiedByUser("targetFolder")){var a=this._findTargetFolderByName(this.defTaskDocFolderName);a?this.setSelectedTargetFolder(a,!1):(a=this._findTargetFolderByName(this.defaultTargetFolderName),this.setSelectedTargetFolder(a,!a))}};a.prototype.setTargetFolderByName=
function(a){a=this._findTargetFolderByName(a,!0);this.setSelectedTargetFolder(a,!a);this.displayRow()};a.prototype._findTargetFolderByName=function(a,b){if(this.targetFolders&&(a||b)&&"string"===typeof a)for(var d=a.toLowerCase(),f=0;f<this.targetFolders.length;f++){var e=this.targetFolders[f];if(e&&e.name.toLowerCase()==d)return e}return null};a.prototype.setSelectedTargetFolder=function(a,b){this.selTargetFolder&&(this.selTargetFolder.isDefaultFromDocTempl=!1);if(!this.targetFolders||0==this.targetFolders.length)this.selTargetFolder=
null;else{if(b){if(this.selDocTemplate&&(this.selTargetFolder=this._findTargetFolderByName(this.selDocTemplate.folderName)))this.selTargetFolder.isDefaultFromDocTempl=!0}else this.selTargetFolder=a;this.selTargetFolder||(this.selTargetFolder=this.targetFolders[0],b&&(this.selTargetFolder.isDefaultFromDocTempl=!0));this.selTargetFolder&&(this.targetFolderName=this.selTargetFolder.name)}};a.prototype.convertToXML=function(a){var b="";try{if(this.isInErrorStatus())return b;b+="<dr>";this.origDocRow?
(this.origDocRow.drID&&(b+=e.ElementEncode("id",this.origDocRow.drID)),this.origDocRow.docVerID&&(b+=e.ElementEncode("dv",this.origDocRow.docVerID))):this.drID&&(b+=e.ElementEncode("id",this.drID));a&&0<a.length&&(b+=a);b+=this.convertRefPropertiesToXML();this.canUserEditAttributes()&&(b+=e.ElementEncode("daprefix",this.aCatPrefix));b+="</dr>"}catch(d){k.log("Problem in DocumentRow.convertToXML:\n"+d),b=""}return b};a.prototype.validateDocRow=function(c,j){var f=!0,e=b("#"+this.getRowPrefix()+" div.DocumentNameRow > :input:first"),
i=null;0==e.length?!this.docName&&!this.isAutonamingEnabled()&&(i={isBlocking:!0,level:j,msg:d.t("DocRowDocNameRequired"),element:b("#"+this.getRowPrefix()),docRowObj:this}):1==e.length&&(!e.val()&&!this.isAutonamingEnabled())&&(i={isBlocking:!0,level:j,msg:d.t("DocRowDocNameRequired"),element:e,docRowObj:this});null!=i&&(c.errors.push(i),f=!1);a.prototype.parent.validateDocRow.call(this,c,j)||(f=!1);return f};a.prototype.validateDocRowUniqueName=function(a){if(!this.isAutonamingEnabled()&&this.isEditable&&
!this.isInactive()&&!this.isModifiedElsewhere()){var j=b("#"+this.getRowPrefix()+" div.DocumentNameRow > input:first"),d=j;0==j.length&&(j=b('<input type="text" class="fake-docname-input docname-input"></input>').val(this.docName),d=b("#"+this.getRowPrefix()));a.addDoc(j,this.project.id,{row:this},d)}};a.prototype.deleteItself=function(a){h.prototype.deleteItself.call(this,a);i.getInstance().removeListener(this._validationCallback)};a.prototype.destroy=function(a){h.prototype.destroy.call(this,a);
a&&i.getInstance().removeListener(this._validationCallback)};a.prototype.docNameChanged=function(a){this.docName!=a&&(this.docName=a,this.setIsChanged(),this.setIsChangedByUser(),this.setFieldModByUser("docName",!a))};a.prototype.docNameSuffixChanged=function(a){this.docNameSuffix!=a&&(this.docNameSuffix=a,this.setIsChanged(),this.setIsChangedByUser(),this.setFieldModByUser("docNameSuffix",!a))};a.prototype.docDescChanged=function(a){this.docDesc!=a&&(this.docDesc=a,this.setIsChanged(),this.setIsChangedByUser(),
this.setFieldModByUser("docDescription",!a))};a.prototype.docTemplateSelected=function(a){this.resetDocumentAttrCategory();this.updateDocTemplateSelection(a);this.setIsChanged();this.setIsChangedByUser(!1);this.setFieldModByUser("docTemplate",-1==a);this.view.repaintRow();this.showDocAttributeCategory(!1,!0)};a.prototype.targetFolderSelected=function(a){-1==a?this.setSelectedTargetFolder(null,!0):this.setSelectedTargetFolder(this.targetFolders[a]);k.hasTextContentItem(this.renderOptions.columns)&&
("Copy"===this.docOperation||"New"===this.docOperation||"Move"===this.docOperation)&&this.view.repaintRow();this.setIsChanged();this.setIsChangedByUser();this.setFieldModByUser("targetFolder",-1==a);this.showDocAttributeCategory(!1,!1)};return a});
define("doctablex/DocumentRowBrowseView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(h,n,k){var l=function(e,i,d){if(!e&&!i&&!d)return this;h.call(this,e,i,d);this._fakeBrowseButton=$();return this};l.prototype=new h;l.prototype.constructor=l;l.prototype.parent=h.prototype;l.prototype.render=function(e){l.prototype.parent.render.call(this,e);this.dm.isEditable&&this.enableFileInputField(!0)};l.prototype.renderThumbnail=function(e,
i){try{var d="",d=d+("<"+this.itemRootElemStr+' class="td-narrow">'),d=d+this.customThumbnailHTML("thumbnails/other.gif",i.thumbnailSize),d=d+("</"+this.itemRootElemStr+">");e.append(d)}catch(f){n.log("Problem in DocumentRowBrowseView.renderThumbnail:\n"+f)}};l.prototype.getFileOnChangeMethod=function(){return"javascript: "+this.dm.getThisInDOM()+".fileChangedByUser(this);"};l.prototype.renderFileInputField=function(){this.uploadInput||(this.uploadInput=$("<input>",{type:"file",name:this.dm.fileInputName,
onchange:this.getFileOnChangeMethod(),"class":"hiddenElement"}));return this.uploadInput};l.prototype.enableFileInputField=function(e){e?(this._fakeBrowseButton.prop("disabled",!1),this.dm.getFileInputObj().prop("disabled",!1)):(this._fakeBrowseButton.prop("disabled",!0),this.dm.getFileInputObj().prop("disabled",!0))};l.prototype.renderDocumentSpec=function(e,i){try{this._nameColResizer&&$(window).off("resize",this._nameColResizer);var d=$("<"+this.itemRootElemStr+">");i.width&&"auto"!=i.width&&d.width(i.width);
var f=$(this.addStartOfCustomWidthDiv(i,"150px")),b=$("<div>",{"class":"docname-upload"}),a="javascript: "+this.dm.getThisInDOM()+".fakeBrowseButtonOnClickMethod(); return false;";this._fakeBrowseButton=$("<a>",{href:"#","class":"btn btn-default btn-sm",onclick:a,title:k.t("DocSrcHdlOpenFileBrowser")}).text(k.t("DocSrcHdlOpenFileBrowser"));this._fakeBrowseButton.append($("<i>"),{"class":"icon icon-WCR_Actions-Upload12"});var c=$("<span>");c.append(this._fakeBrowseButton);var j=this.dm.getSelectedFileName();
j||(j=k.t("DocSrcHdlNoFileSelected"));var h=$("<span>",{"class":"docname-upload-text"}).text(j);b.append(c);b.append(h);b.append(this.renderFileInputField());var l;if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix()){var q="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",p=this.dm.docNameSuffix?this.dm.docNameSuffix:"";l=$("<input>",{type:"text","class":this.getSAHIHelperStr("docnamesuffix")+" docname-input",placeholder:k.t("DocRowDocumentSuffix"),value:p,onchange:q})}else l=
$("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:this.getAutoNamingPreview(),disabled:"disabled"});else{var s="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",m=this.dm.docName?this.dm.docName:"";l=$("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:k.t("DocRowDocumentName"),value:m,onchange:s})}var g="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",y=this.dm.docDesc?this.dm.docDesc:
"",t=$("<input>",{type:"text","class":this.getSAHIHelperStr("docdescription")+" docname-input",placeholder:k.t("DocRowDocumentDescription"),value:y,onchange:g}),G=this.renderDocTemplateSelector("true"!=i.hideDocTemplate),F=this.renderDocFolderSelector("true"!=i.hideFolder);this.dm.isEditable||(l.prop("disabled",!0),t.prop("disabled",!0),this.enableFileInputField(!1));var B=$("<div>",{"class":""});B.append(b);var E=$("<div>",{style:"width: 100%"}),C=$("<div>",{style:"float: left; width: 100%;","class":"DocumentNameRow"}),
z=$("<div>",{style:"float: left; width: 100%","class":"DocumentNameRow"});C.append(l);z.append(t);E.append(C,z);var w=$("<div>",{style:"width: 100%",id:this.phElemID+"_docTempFolderSelPHID"}),A=$("<div>",{style:"float: left; width: 100%;"}),x=$("<div>",{style:"float: left; width: 100%"});G?A.append(G):A.hide();x.append(F);w.append(A,x);"true"==i.hideDescription&&z.hide();"true"==i.hideDocTemplate&&A.hide();"true"==i.hideFolder&&x.hide();this._nameColResizer=function(){if(E&&C.is(":visible")&&z.is(":visible")){var a=
E.width();360>a?(C.css("width","100%"),C.css("padding-right","0px"),z.css("width","100%")):(C.css("width","50%"),C.css("padding-right","2px"),z.css("width","50%"))}w&&(A.is(":visible")&&x.is(":visible"))&&(a=w.width(),360>a?(A.css("width","100%"),A.css("padding-right","0px"),x.css("width","100%")):(A.css("width","50%"),A.css("padding-right","2px"),x.css("width","50%")))};$(window).resize(this._nameColResizer);window.setTimeout(function(){this._nameColResizer()}.bind(this),1);f.append(B,E,w);d.append(f);
e.append(d)}catch(D){n.log("Problem in DocumentRowBrowseView.renderDocumentSpec:\n"+D)}};l.prototype.destroy=function(e){e||this.uploadInput&&this.uploadInput.detach()};return l});
define("doctablex/DocumentRowBrowse","doctablex/DocumentRow doctablex/DocumentRowBrowseView doctablex/AJAXDataCache doctablex/DocTableXUtils doctablex/DocumentTypeUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(h,n,k,l,e,i,d,f){var b=function(a){if(!a)return this;a.viewClass||(a.viewClass=n);h.call(this,a);this.fileInputName=this.getRowPrefix()+"_fileForm";this.dlsName=a.dlsName||"Upload";this.docOperation="Upload";this.newDocTmpID=a.newDocTmpID?a.newDocTmpID:"newID_"+
this.rowID;this.allowedFileExts=a.allowedFileExts||[];this.origFileExt=null;this._masterFileFormFieldName=a.fileFormFieldName||"";this.project={id:this.getParentDocTable().projectID};this.useDocTypeDefaultACat=!0;this.constructor==b.prototype.constructor&&this._initializeFromServer();return this};b.prototype=new h;b.prototype.constructor=b;b.prototype.parent=h.prototype;b.prototype._initializeFromServer=function(){this.setStatus("loading");if(this.copyOfExistingRowID)this.setStatus("ready");else if(!this.docTemplates&&
this.project.id){var a=k.getInstance().getDocTemplatesByProjID(this.project.id),c=k.getInstance().getFoldersByProjID(this.project.id);f.when(a,c).done(function(a,c){this.updateDocTemplates(a);this.preselectDocTemplate();this.defTaskDocAttrCatID&&(this.aCatID=this.defTaskDocAttrCatID);this.updateTargetFolders(c);this.preselectTargetFolder();this.setStatus("ready");this.updateOtherInfoFromServer(!0,!1);this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)).fail(function(a){this.setStatus("error");
alert("Problem with retrieving document templates:\n"+a)}.bind(this))}else this.docTemplates||this.getParentDocTable().isBlankProjectCreationContext()?this.setStatus("ready"):this.setStatus("error")};b.prototype.getDocRowInfo=function(){var a=b.prototype.parent.getDocRowInfo.call(this);_.extend(a,{newDocTmpID:this.newDocTmpID,allowedFileExts:this.allowedFileExts,fileFormFieldName:""});var c=this.getEffectiveFileInputObj();c&&(a.fileFormFieldName=c.attr("name"));return a};b.prototype.resetDocument=
function(a){f(a).removeClass("docTableFileInputToPreserve");this._masterFileFormFieldName="";this.docType=this.docTypeID=null;this.resetDocumentAttrCategory();b.prototype.parent.resetDocument.call(this,!1)};b.prototype.getFileInputObj=function(){return this.view.uploadInput?this.view.uploadInput:f()};b.prototype.getEffectiveFileInputObj=function(){var a=null;if(this.isIndirectlyClonedRow()){var c=this.getMasterOfIndirectlyClonedRow();c&&(a=c.getFileInputObj())}else a=this.copyOfExistingRowID&&this._masterFileFormFieldName?
f("input[name='"+this._masterFileFormFieldName+"']"):this.getFileInputObj();return a};b.prototype.isValidFileSelected=function(){var a=this.getEffectiveFileInputObj();return!!a&&!!a.val()};b.prototype.getSelectedFileName=function(){var a="",c=this.getEffectiveFileInputObj();0<c.length&&c.val()&&(a=this.getCurrentDocName(c[0]));return a};b.prototype.salvageValuablesFromDocRow=function(a){if(a&&a.isValidFileSelected()){var c=a.getFileInputObj(),b=c.parent(),d=this.getFileInputObj();c.attr("name",d.attr("name"));
c.attr("onchange",d.attr("onchange"));d.replaceWith(c);b.append(a.view.renderFileInputField())}};b.prototype.setIsChangedByUser=function(a){a||this._handleDependenciesOnChange();b.prototype.parent.setIsChangedByUser.call(this,!0)};b.prototype._handleDependenciesOnChange=function(){var a=this.getAllRowsCopiedFromRows([this]);if(0<a.length){var c=a[0];c.copyOfExistingRowID=this.copyOfExistingRowID;c.salvageValuablesFromDocRow(this);for(var b=1;b<a.length;b++)a[b].copyOfExistingRowID=c.rowID}};b.prototype.convertToXML=
function(){var a="";try{if(this.isInErrorStatus()||!this.isValidFileSelected())return a;var c="<ds>",c=c+d.ElementEncode("action",this.docOperation);this.newDocTmpID&&(c+=d.ElementEncode("new_doc_temp_id",this.newDocTmpID));var j=this.getEffectiveFileInputObj();j&&(c+=d.ElementEncode("file_form_field",j.attr("name")));this.project.id&&(c+=d.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(c+=d.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?
c+=d.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(c+=d.ElementEncode("doc_name",this.docName));this.docDesc&&(c+=d.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(c+=d.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(c+=d.ElementEncode("doc_temp_id",this.selDocTemplate.id),c+=d.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName));a=b.prototype.parent.convertToXML.call(this,c+"</ds>")}catch(f){l.log("Problem in DocumentRow.convertToXML:\n"+
f),a=""}return a};b.prototype.validateDocRow=function(a,c){var d=!0,f=this.getEffectiveFileInputObj();1==f.length&&!f.val()&&(d={isBlocking:!0,level:c,msg:i.t("DocRowFileNotChosen"),element:f.parent(),docRowObj:this},a.errors.push(d),d=!1);b.prototype.parent.validateDocRow.call(this,a,c)||(d=!1);return d};b.prototype.fileChangedByUser=function(a){this.fileChanged(a).done(function(){this.setIsChangedByUser(!0)}.bind(this)).fail(function(a){a&&!this.docName&&this.setIsChangedByUser(!0)}.bind(this))};
b.prototype.fileChanged=function(a){var c=f.Deferred();if(this.isInConfigPreview())return alert(i.t("DocSrcHdlNoProjectInConfig")),c.reject().promise();this.setStatus("loading");var b=this.docName,d=this.getCurrentDocName(a);this.resetDocument(a);if(!d)return this.displayRow(),c.reject(b).promise();this.origFileExt=l.getFileExtension(d,!0);if(this.allowedFileExts&&0<this.allowedFileExts.length&&-1==this.allowedFileExts.indexOf(this.origFileExt))return alert(i.t("notAllowedDocExtension")+this.allowedFileExts.toString()),
this.getFileInputObj().val(null),this.view.repaintRow(),c.reject(b).promise();this.docName=d;f(a).addClass("docTableFileInputToPreserve");var a=k.getInstance(),h=d=null;this.project.id?(d=a.getEffectiveDocTypesSettingsByProjID(this.project.id),h=a.getDocTemplatesByProjID(this.project.id)):d=a.getProjCreationSysDefaults();f.when(d,h).done(function(a,b){this.docTypeID=e.getDocTypeIDByExtension(this.origFileExt);this.updateDocumentType(a,!1);this.updateDocTemplates(b);this.isModifiedByUser("docTemplate")||
(this.preselectDocTemplate(),this.defTaskDocAttrCatID&&(this.aCatID=this.defTaskDocAttrCatID));this.preselectTargetFolder();this.updateOtherInfoFromServer(!0,!1);this.setStatus("ready");c.resolve();this.view.repaintRow();this.showDocAttributeCategory(!1,!0)}.bind(this)).fail(function(a){this.setStatus("error");c.reject(b);alert("Failed to process document configuration from the server.\n"+a)}.bind(this)).always(function(){this.setIsChanged()}.bind(this));return c.promise()};b.prototype.getCurrentDocName=
function(a){if(a=a.value)return-1!=a.lastIndexOf("\\")?a=a.substring(a.lastIndexOf("\\")+1):-1!=a.lastIndexOf("/")?a=a.substring(a.lastIndexOf("/")+1):-1!=a.lastIndexOf(":")&&(a=a.substring(a.lastIndexOf(":")+1)),a};b.prototype.getAttCatView=function(){var a=l.getRenderItem(this.renderOptions.columns,"AttributeFlapout");return a&&!1===a.useCreationView?this.aCatView||"Default":"Creation"};b.prototype.getFile=function(){f("#"+this.phElemID);var a=this.getFileInputObj();return 1==a.length&&(a=a[0].files)&&
1===a.length?a[0]:null};b.prototype.fakeBrowseButtonOnClickMethod=function(){this._handleDependenciesOnChange();this.getFileInputObj().click()};return b});
define("doctablex/DocumentRowFileView",["doctablex/DocumentRowBrowseView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(h,n,k){var l=function(e,i,d){if(!e&&!i&&!d)return this;h.call(this,e,i,d);return this};l.prototype=new h;l.prototype.constructor=l;l.prototype.parent=h.prototype;l.prototype.renderDocumentSpec=function(e,i){try{this._nameColResizer&&$(window).off("resize",this._nameColResizer);var d=$("<"+this.itemRootElemStr+">");i.width&&"auto"!=i.width&&
d.width(i.width);var f=$(this.addStartOfCustomWidthDiv(i,"150px")),b=$("<div>").addClass("FileRowLabel"),a=$("<span>").addClass("docname-label").html(this.dm.dlsName+": "+this.dm._file.name);b.append(a);var c=$('<input type="file" />').addClass("hidden-file-input").on("change",_.bind(function(){c[0].files&&1==c[0].files.length&&(this.dm.setFile(c[0].files.item(0)),a.html(this.dm.dlsName+": "+this.dm.getFile().name),this.dm.isAutonamingEnabled()||h.val(this.dm.docName),this.dm.fileChanged())},this)),
j=$('<a href="#" />').html(k.t("ChangeFile")).on("click",function(){c.click()});b.append(a).append(c).append(" ("+this.userFriendlySize(this.dm.getFile().size)+") ");this.dm.isEditable&&b.append(j);var h=$("<input>",{type:"text"}).addClass("docname-input "+this.getSAHIHelperStr("docname"));this.dm.isAutonamingEnabled()?this.dm.hasAutonameSuffix()?(h.attr("placeholder",k.t("DocRowDocumentSuffix")),h.val(this.dm.docNameSuffix),h.on("change",_.bind(function(){this.dm.docNameSuffixChanged(h.val())},this))):
(h.attr("placeholder",this.getAutoNamingPreview()),h.attr("disabled","disabled")):(h.attr("placeholder",k.t("DocRowDocumentName")),h.val(this.dm.docName),h.on("change",_.bind(function(){this.dm.docNameChanged(h.val())},this)));var l="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",q=this.dm.docDesc?this.dm.docDesc:"",p=$("<input>",{type:"text","class":this.getSAHIHelperStr("docdescription")+" docname-input",placeholder:k.t("DocRowDocumentDescription"),value:q,onchange:l}),s=this.renderDocTemplateSelector("true"!=
i.hideDocTemplate),m=this.renderDocFolderSelector("true"!=i.hideFolder);this.dm.isEditable||(h.attr("disabled","disabled"),p.attr("disabled","disabled"));var g=$("<div>",{style:"width: 100%"}),y=$("<div>",{style:"float: left; width: 100%;","class":"DocumentNameRow"}),t=$("<div>",{style:"float: left; width: 100%","class":"DocumentNameRow"});y.append(h);t.append(p);g.append(y,t);var G=$("<div>",{style:"width: 100%",id:this.phElemID+"_docTempFolderSelPHID"}),F=$("<div>",{style:"float: left; width: 100%;"}),
B=$("<div>",{style:"float: left; width: 100%"});s?F.append(s):F.hide();B.append(m);G.append(F,B);"true"==i.hideSource&&sourceFile.hide();"true"==i.hideDescription&&t.hide();"true"==i.hideDocTemplate&&F.hide();"true"==i.hideFolder&&B.hide();this._nameColResizer=function(){if(g&&y.is(":visible")&&t.is(":visible")){var a=g.width();450>a?(y.css("width","100%"),y.css("padding-right","0px"),t.css("width","100%")):(y.css("width","50%"),y.css("padding-right","2px"),t.css("width","50%"))}G&&(F.is(":visible")&&
B.is(":visible"))&&(a=G.width(),450>a?(F.css("width","100%"),F.css("padding-right","0px"),B.css("width","100%")):(F.css("width","50%"),F.css("padding-right","2px"),B.css("width","50%")))};$(window).resize(this._nameColResizer);window.setTimeout(function(){this._nameColResizer()}.bind(this),1);f.append(b,g,G);d.append(f);e.append(d)}catch(E){n.log("Problem in DocumentRowFileView.renderDocumentSpec:\n"+E)}};l.prototype.userFriendlySize=function(e){if(1024>e)return e+" B";e=Math.round(100*e/1024)/100;
if(1024>e)return e+" kB";e=Math.round(100*e/1024)/100;if(1024>e)return e+" MB";e=Math.round(100*e/1024)/100;return e+" GB"};return l});
define("doctablex/DocumentRowFile",["doctablex/DocumentRow","doctablex/DocumentRowBrowse","doctablex/DocumentRowFileView","doctablex/DocumentTypeUtils","jquery"],function(h,n,k,l,e){l=function(e){if(!e)return this;e.viewClass||(e.viewClass=k);n.call(this,e);this._initializeFromServer();this._file=e.file;this.docName=this._file.name;this.fileChanged();return this};l.prototype=new n;l.prototype.constructor=l;l.prototype.parent=n.prototype;l.prototype.getFile=function(){return this._file};l.prototype.setFile=
function(e){var d=this.docName==this._file.name;this._file=e;d&&(this.docName=this._file.name)};l.prototype.getCurrentDocName=function(){return this._file.name};l.prototype.isValidFileSelected=function(){return!0};l.prototype.getEffectiveFileInputObj=function(){return e("<input />").attr("name",this.fileInputName)};l.prototype.validateDocRow=function(e,d){var f=!0;h.prototype.validateDocRow.call(this,e,d)||(f=!1);return f};return l});
define("doctablex/DocumentRowExternalFileView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings"],function(h,n,k){var l=function(e,i,d){if(!e&&!i&&!d)return this;h.call(this,e,i,d);return this};l.prototype=new h;l.prototype.constructor=l;l.prototype.renderThumbnail=function(e,i){var d=i.thumbnailSize||50;e.append($("<td>",{"class":"td-narrow"}).append($("<img>",{src:this.dm.thumbnailURL||"thumbnails/other.gif"}).css("max-width",d+"px").css("max-height",d+"px")))};
l.prototype.renderDocumentSpec=function(e,i){try{var d;if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix()){var f="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",b=this.dm.docNameSuffix?this.dm.docNameSuffix:"";d=$("<input>",{type:"text","class":this.getSAHIHelperStr("docnamesuffix")+" docname-input",placeholder:k.t("DocRowDocumentSuffix"),value:b,onchange:f})}else d=$("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:this.getAutoNamingPreview(),
disabled:"disabled"});else{var a="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",c=this.dm.docName?this.dm.docName:"";d=$("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:k.t("DocRowDocumentName"),value:c,onchange:a})}var j=$("<div>",{style:"float: left; width: 100%;","class":"DocumentNameRow"}).append(d),h="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",l=this.dm.docDesc?this.dm.docDesc:"",q=$("<input>",{type:"text",
"class":this.getSAHIHelperStr("docdescription")+" docname-input",placeholder:k.t("DocRowDocumentDescription"),value:l,onchange:h}),p=$("<div>",{style:"float: left; width: 100%","class":"DocumentNameRow"}).append(q);this.dm.isEditable||(d.attr("disabled","disabled"),q.attr("disabled","disabled"));var s=this.renderDocTemplateSelector("true"!=i.hideDocTemplate),m=this.renderDocFolderSelector("true"!=i.hideFolder),g=$("<div>",{style:"width: 100%",id:this.phElemID+"_docTempFolderSelPHID"}),y=$("<div>",
{style:"float: left; width: 100%;"}),t=$("<div>",{style:"float: left; width: 100%"});s?y.append(s):y.hide();t.append(m);g.append(y,t);"true"==i.hideDescription&&p.hide();"true"==i.hideDocTemplate&&y.hide();"true"==i.hideFolder&&t.hide();e.append($("<td>").append(j,p,g))}catch(G){n.log("Problem in DocumentRowExternalFileView.renderDocumentSpec:\n"+G)}};return l});
define("doctablex/DocumentRowExternalFile","doctablex/DocumentRow doctablex/DocumentRowExternalFileView doctablex/AJAXDataCache doctablex/DocTableXUtils doctablex/DocumentTypeUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery underscore".split(" "),function(h,n,k,l,e,i,d,f,b){var a=function(c){if(!c)return this;c.viewClass||(c.viewClass=n);h.call(this,c);this.dlsName=c.dlsName||"Upload";this.docOperation="DAM";this.newDocTmpID=c.newDocTmpID?c.newDocTmpID:"newID_"+this.rowID;this.externalId=
c.externalId;this.allowedFileExts=c.allowedFileExts||[];this.project={id:this.getParentDocTable().projectID};this.DAM=c.DAM;this.DAMJS=c.DAMJS;this.DAMData=c.DAMData;this.externalDocumentMetadata=c.externalDocumentMetadata;this.areAttributesReplaced=!1;this.useDocTypeDefaultACat=!0;this.setStatus("loading");this.origFileExt=l.getFileExtension(this.docName,!0);if(this.allowedFileExts&&0<this.allowedFileExts.length&&-1==this.allowedFileExts.indexOf(this.origFileExt))return window.alert(i.t("notAllowedDocExtension")+
this.allowedFileExts.toString()),this.setStatus("error"),this;this.constructor==a.prototype.constructor&&this._initializeFromServer();return this};a.prototype=new h;a.prototype.constructor=a;a.prototype._initializeFromServer=function(){if(this.copyOfExistingRowID)this.setStatus("ready");else if(!this.docTemplates&&this.project.id){this.setStatus("loading");var a=k.getInstance().getDocTemplatesByProjID(this.project.id),b=k.getInstance().getFoldersByProjID(this.project.id),d=k.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id);
f.when(d,a,b).done(function(a,c,b){this.docTypeID=e.getDocTypeIDByExtension(this.origFileExt);this.updateDocumentType(a,!1);this.updateDocTemplates(c);this.preselectDocTemplate();this.defTaskDocAttrCatID&&(this.aCatID=this.defTaskDocAttrCatID);this.updateTargetFolders(b);this.preselectTargetFolder();this.setStatus("ready");this.updateOtherInfoFromServer(!0,!1);this.view.repaintRow();this.showDocAttributeCategory(!1,!0)}.bind(this)).fail(function(a){this.setStatus("error");window.alert("Problem with retrieving document templates:\n"+
a)}.bind(this)).always(function(){this.setIsChanged()}.bind(this))}else this.docTemplates||this.getParentDocTable().isBlankProjectCreationContext()?this.setStatus("ready"):this.setStatus("error")};a.prototype.getDocRowInfo=function(){var a=h.prototype.getDocRowInfo.call(this);b.extend(a,{newDocTmpID:this.newDocTmpID,allowedFileExts:this.allowedFileExts,externalId:this.externalId,DAM:this.DAM,DAMJS:this.DAMJS,DAMData:this.DAMData,externalDocumentMetadata:this.externalDocumentMetadata});return a};a.prototype._onAttrCategoryReady=
function(a){if(!this.areAttributesReplaced&&(this.areAttributesReplaced=!0,this.externalDocumentMetadata&&this.DAMJS.getAttributeValueMapping)){var d=this.DAMJS.getAttributeValueMapping(this.externalDocumentMetadata,this.DAMData);b.each(d,function(a){var c=this.aCatObj.findAttribute(a.id||-1,a.name);c&&c.setValue(a.value)}.bind(this));this.aCatObj.displayAttributeCategory()}h.prototype._onAttrCategoryReady.call(this,a)};a.prototype.convertToXML=function(){var a="";try{if(this.isInErrorStatus())return a;
var b="<ds>";this.docOperation&&(b+=d.ElementEncode("action",this.docOperation));this.newDocTmpID&&(b+=d.ElementEncode("new_doc_temp_id",this.newDocTmpID));this.selTargetFolder&&(b+=d.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()&&(b+=d.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""));this.project.id&&(b+=d.ElementEncode("project_id",this.project.id));this.docName&&(b+=d.ElementEncode("doc_name",this.docName));this.docDesc&&(b+=
d.ElementEncode("doc_description",this.docDesc));this.externalId&&(b+=d.ElementEncode("doc_external_id",this.externalId));this.DAM&&(b+=d.ElementEncode("doc_dam_provider",this.DAM.provider),b+=d.ElementEncode("doc_dam_id",this.DAM.id));a=h.prototype.convertToXML.call(this,b+"</ds>")}catch(f){l.log("Problem in DocumentRowExternalFile.convertToXML:\n"+f),a=""}return a};return a});
define("doctablex/DocumentRowSearchView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(h,n,k,l){var e=function(e,d,f){if(!e&&!d&&!f)return this;h.call(this,e,d,f);return this};e.prototype=new h;e.prototype.constructor=e;e.prototype.parent=h.prototype;e.prototype.renderDocumentSpec=function(e,d){try{this._nameColResizer&&$(window).off("resize",this._nameColResizer);var f=$("<"+this.itemRootElemStr+">");d.width&&"auto"!=d.width&&
f.width(d.width);var b=$(this.addStartOfCustomWidthDiv(d,"150px")),a="Copy"==this.dm.docOperation,c="Move"==this.dm.docOperation,j="Link"==this.dm.docOperation,h=this.renderDocDetails();b.append(h);var l=$("<input>").hide();if(a||c)if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var q="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",p=this.dm.docNameSuffix?this.dm.docNameSuffix:"",l=$("<input>",{type:"text","class":this.getSAHIHelperStr("docnamesuffix")+" docname-input",
placeholder:k.t("DocRowDocumentSuffix"),value:p,onchange:q});else l=$("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:this.getAutoNamingPreview(),disabled:"disabled"});else var s=this.dm.docName?this.dm.docName:"",m="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",l=$("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:k.t("DocRowDocumentName"),value:s,onchange:m});else l=$("<span>",{"class":"docname-text"}).text(this.dm.docName);
var g=$("<div>").hide(),y="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",t=this.dm.docDesc?this.dm.docDesc:"";if(a)g=$("<input>",{type:"text","class":this.getSAHIHelperStr("docdescription")+" docname-input",placeholder:k.t("DocRowDocumentDescription"),value:t,onchange:y});else if(t){g.show();var G=$("<span>",{"class":"docname-label"}).text(k.t("DocRowDocumentDescription")+":"),F=$("<span>",{"class":"docname-text"}).text(t);g.append(G,F)}var B=$("<div>").hide();a&&(B=this.renderDocTemplateSelector("true"!=
d.hideDocTemplate));var E=$("<div>").hide();if(a||c||j)E=this.renderDocFolderSelector("true"!=d.hideFolder);this.dm.isEditable||(l.attr("disabled","disabled"),g.attr("disabled","disabled"));var C=$("<div>",{style:"width: 100%"}),z=$("<div>",{style:"float: left; width: 100%;","class":"DocumentNameRow"}),w=$("<div>",{style:"float: left; width: 100%","class":"DocumentNameRow"});z.append(l);w.append(g);C.append(z,w);var A=$("<div>",{style:"width: 100%",id:this.phElemID+"_docTempFolderSelPHID"}),x=$("<div>",
{style:"float: left; width: 100%;"}),D=$("<div>",{style:"float: left; width: 100%"});B?x.append(B):x.hide();D.append(E);A.append(x,D);"true"==d.hideSource&&h.hide();("true"==d.hideDescription||"DIV"==g.prop("tagName").toUpperCase()&&0==t.length)&&w.hide();"true"==d.hideDocTemplate&&x.hide();"true"==d.hideFolder&&D.hide();this._nameColResizer=function(){if(C&&z.is(":visible")&&w.is(":visible")){var a=C.width();360>a?(z.css("width","100%"),z.css("padding-right","0px"),w.css("width","100%")):(z.css("width",
"50%"),z.css("padding-right","2px"),w.css("width","50%"));z.height()>w.height()?w.css("height",z.height()+"px"):z.css("height",w.height()+"px")}A&&(x.is(":visible")&&D.is(":visible"))&&(a=A.width(),360>a?(x.css("width","100%"),x.css("padding-right","0px"),D.css("width","100%")):(x.css("width","50%"),x.css("padding-right","2px"),D.css("width","50%")))};$(window).resize(this._nameColResizer);window.setTimeout(function(){this._nameColResizer()}.bind(this),1);b.append(h,C,A);f.append(b);e.append(f)}catch(H){n.log("Problem in DocumentRowSearchView.renderDocumentSpec:\n"+
H)}};e.prototype.renderLocalRemoteButton=function(i,d){try{if(this.dm.origDocRow){var f="",f=f+("<"+this.itemRootElemStr+' class="td-narrow">'),b="javascript: "+this.dm.getParentInDOM()+".localRemoteButtonClicked("+this.rowIndex+");",a=l.xmlencode(k.t("DocRowLocalRemoteResetButtonTooltip")),f=f+('<button class="btn btn-xs btn-default actionBtn" title="'+a+'" onclick="'+b+'">'),f=f+'<i class="icon icon-normal activIcon icon icon icon-WCR_Revert"/>',f=f+"</button>",f=f+("</"+this.itemRootElemStr+">");
i.append(f)}else e.prototype.parent.renderLocalRemoteButton.call(this,i,d)}catch(c){n.log("Problem in StaticDocumentRowView.renderLocalRemoteButton:\n"+c)}};e.prototype.renderCloneButton=function(i){e.prototype.parent.parent.renderCloneButton.call(this,i)};e.prototype.renderDocDetails=function(e){var d=$("<div>").hide(),e=this.dm.origDocRow&&-1==this.dm.dlsName.indexOf("Replace")?$("<span>",{"class":"docname-label"}).text(k.t("DocRowLocalRemoteMakeLocal")):e?$("<span>",{"class":"docname-label"}).text(this.dm.dlsName):
$("<span>",{"class":"docname-label"}).text(this.dm.dlsName+" ("+this.dm.docOperation+")");d.append(e);e=$("<span>",{"class":"docname-text"}).text(this.dm.selDocName);d.append(e);d.show();return d};return e});
define("doctablex/DocumentRowSearch","doctablex/StaticDocumentRow doctablex/DocumentRow doctablex/DocTableXUtils doctablex/DocumentRowSearchView doctablex/AJAXDataCache utils/webi18n!DocRefStrings wcr/webcenter_xml underscore jquery".split(" "),function(h,n,k,l,e,i,d,f,b){var a=function(c){if(!c)return this;c.viewClass||(c.viewClass=l);n.call(this,c);this.dlsName=c.dlsName||"Search";this.docOperation=c.docOperation?c.docOperation:"Copy";this.clonedFrom=c.clonedFrom;this.isCloneInitOngoing=this.isClone();
this.newDocTmpID=c.newDocTmpID||"";"Copy"==this.docOperation&&!c.newDocTmpID&&(this.newDocTmpID="newID_"+this.rowID);this.selDocName="";this.fileExt=k.getFileExtension(this.docName,!0);this.constructor==a.prototype.constructor&&(this._initFromServerState=this._initializeFromServer());return this};a.prototype=new n;a.prototype.constructor=a;a.prototype.parent=n.prototype;a.prototype._initializeFromServer=function(){this.setStatus("loading");var a=b.Deferred();if(this.copyOfExistingRowID)return this.setStatus("ready"),
a.resolve().promise();var d=this.updateDocInfoFromServer(!1);d.done(function(){var d=null,d=this.project.id?e.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id):e.getInstance().getProjCreationSysDefaults(),j=null;"Copy"==this.docOperation&&this.project.id&&(j=e.getInstance().getDocTemplatesByProjID(this.project.id));var i=null;"Reference"!=this.docOperation&&this.project.id&&(i=e.getInstance().getFoldersByProjID(this.project.id));b.when(d,j,i).done(function(b,d,j){this.useDocTypeDefaultACat=
this.hasNoAttrCat()&&"Copy"==this.docOperation;this.updateDocumentType(b,!1);d&&(this.updateDocTemplates(d),this.preselectDocTemplate());this.updateTargetFolders(j);this.isClone()?this.clonedFrom&&this.clonedFrom.selTargetFolder?(b=f.extend({},this.clonedFrom.selTargetFolder),this.setSelectedTargetFolder(b,!1)):this.folder&&null!=this.folder.name&&this.setTargetFolderByName(this.folder.name):this.preselectTargetFolder();a.resolve();this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!1,
!0)}.bind(this)).fail(function(b){a.reject();this.setStatus("error");k.log("Failed to load document configuration from the server.\n"+b)}.bind(this))}.bind(this));d.fail(function(b){a.reject();this.setStatus("error");k.log("Failed to process basic info about document loaded from the server.\n"+b)}.bind(this));return a.promise()};a.prototype._updateDocInfo=function(a){a=this._strippedUpdateDocInfo(a);this.isClone()&&(this.docName=this.getParentDocTable().getClonedDocName(this),a=!0);return a};a.prototype.getDocRowInfo=
function(){var c=a.prototype.parent.getDocRowInfo.call(this);f.extend(c,{dlsName:this.dlsName,clonedFrom:this.clonedFrom,newDocTmpID:this.newDocTmpID});return c};a.prototype.isClone=function(){return this.clonedFrom&&(this.clonedFrom.rowID||0===this.clonedFrom.rowID)?!0:!1};a.prototype.finishCloneInit=function(){this.isCloneInitOngoing=!1};a.prototype._onAttrCategoryReady=function(c){if("docCat"==c&&this.isAttrCatLoaded(this.aCatObj)&&this.isCloneInitOngoing){var b=this.clonedFrom.aCatObj;this.isAttrCatLoaded(b)?
this.aCatObj.copyAttrValuesFromCategory(b):this.clonedFrom.aCatNotExpandedYet||window.alert("Cloning document row with attribute category not loaded even if the cloned doc row already loaded its own category!?!?");this.finishCloneInit()}a.prototype.parent._onAttrCategoryReady.call(this,c)};a.prototype.validateDocRow=function(a,d){var f=!0;"Reference"==this.docOperation||"Link"==this.docOperation?(this.docName||(f={isBlocking:!0,level:d,msg:i.t("DocRowDocNameNotSelectable"),element:b("#"+this.getRowPrefix()),
docRowObj:this},a.errors.push(f),f=!1),h.prototype.validateDocRow.call(this,a,d)||(f=!1)):n.prototype.validateDocRow.call(this,a,d)||(f=!1);return f};a.prototype.validateDocRowUniqueName=function(c){"Link"==this.docOperation||"Reference"==this.docOperation||a.prototype.parent.validateDocRowUniqueName.call(this,c)};a.prototype.isAutonamingEnabled=function(){return null!=this.anPrefix&&0<this.anPrefix.length&&"Copy"==this.docOperation};a.prototype.canUserEditAttributes=function(){var a=!1,a=this.userPerms?
this.userPerms.change:!1,b=!1;this.selTargetFolder?b=this.selTargetFolder.changePropPerm:this.getParentDocTable().isBlankProjectCreationContext()&&(b=!0);a="Reference"==this.docOperation?a:"Link"==this.docOperation?a||b:b;return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&a};a.prototype.generateDocAttributeValuesAJAXURL=function(){var a=window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&k.isValidID(this.selDocTemplate.categoryID)?
(a=a+"GetAttributes.jsp?doctemplate=1"+("&projectid="+this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):this.hasOrigDocACat&&this.docVerID?a+="GetAttributes.jsp?docverid="+this.docVerID:k.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:k.log("Cannot generate URL in DocumentRowSearch.generateDocAttributeValuesAJAXURL().");return a};a.prototype.getAttCatView=function(){var a=
!1,b=k.getRenderItem(this.renderOptions.columns,"AttributeFlapout");b&&!1===b.useCreationView&&(a=!0);return!a&&"Copy"==this.docOperation?"Creation":this.aCatView||"Default"};a.prototype.convertToXML=function(){var c="";try{if(this.isInErrorStatus())return c;var b="<ds>",b=b+d.ElementEncode("action",this.docOperation);this.newDocTmpID&&(b+=d.ElementEncode("new_doc_temp_id",this.newDocTmpID));this.docVerID&&(b+=d.ElementEncode("source_dv_id",this.docVerID));this.project.id&&(b+=d.ElementEncode("project_id",
this.project.id));this.selTargetFolder&&(b+=d.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?b+=d.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(b+=d.ElementEncode("doc_name",this.docName));this.docDesc&&(b+=d.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(b+=d.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(b+=d.ElementEncode("doc_temp_id",this.selDocTemplate.id),b+=d.ElementEncode("doc_temp_folder_name",
this.selDocTemplate.folderName));c=a.prototype.parent.convertToXML.call(this,b+"</ds>")}catch(f){k.log("Problem in DocumentRowSearch.convertToXML:\n"+f),c=""}return c};return a});
define("doctablex/DocumentRowNewView","doctablex/DocumentRowView doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery component/modal/Modal".split(" "),function(h,n,k,l,e,i){var d=function(d,b,a){if(!d&&!b&&!a)return this;h.call(this,d,b,a);return this};d.prototype=new h;d.prototype.constructor=d;d.prototype.parent=h.prototype;d.prototype.getDocTemplateDialogPlaceholder=function(){if(!this._docTemplateDialog){this._docTemplateDialog=new i(e("<div>"),{customClass:"DocTemplateDialog"});
this._docTemplateDialog.setTitle(k.t("SELECTDOCTEMPLATE"));var d=e("<button>",{"class":"btn btn-default"}).text(k.t("CANCEL")),b=e("<button>",{"class":"btn btn-primary"}).text(k.t("OK")),a=e("<div>");a.append(d);a.append(b);this._docTemplateDialog.setFooter(a);this._docTemplateDialog.onClose(function(){this._docTemplateDialogSelectionConfirmed||this.dm.deleteItself(!1)}.bind(this));b.on("click",function(){void 0!==this._selectedDocTempIdx&&(this._docTemplateDialogSelectionConfirmed=!0,this._docTemplateDialog.close(),
this.dm.addDocTemplate(this._selectedDocTempIdx))}.bind(this));d.on("click",function(){this._docTemplateDialogSelectionConfirmed=!1;this._docTemplateDialog.close()}.bind(this))}return this._docTemplateDialog};d.prototype.renderDocTemplateDialog=function(){var d=this.getDocTemplateDialogPlaceholder();if(!this.dm.docTemplates||0==this.dm.docTemplates.length||!d)return null;for(var b=e("<div>",{style:"overflow: auto; height: 350px;"}),a=e("<div>",{"class":"wcr-table"}),c=e("<input>",{id:"docTemplateDialogFilter",
name:"docTemplateDialogFilter","class":"form-control"}),j=e("<div>",{"class":"input-group full-width add-padding-bottom"}).append(e("<label>",{"class":"input-group-addon","for":"docTemplateDialogFilter"}).text(k.t("FILTER")),c),i=e("<label>",{style:"margin-top: 5px;"}).append(e("<span>",{"class":"add-spacing-right"}).text(k.t("PROJDETAILSTOTALDOCS_TAG")+":"),e("<span>").text(this.dm.docTemplates.length)),j=e("<div>",{"class":"wcr-table-filter"}).append(e("<div>",{"class":"wcr-table-actions-row no-actions"}).append(e("<div>",
{"class":"col-xs-12 col-sm-9"}).append(j),e("<div>",{"class":"col-xs-12 col-sm-3"}).append(i))),i=e("<div>",{"class":"wcr-table-section"}),h=e("<table>",{"class":"ordtable DocTemplateDialogTable"}).attr({id:this.dm.parentDocTable.prefix+"_doctemplatedialogtable"}),l=e("<tbody>"),n=function(a,c){a.on("click",function(){this._selectedDocTempIdx=c;e(".docTemplateRow.activeRow").find("input").prop("checked",!1);l.find("> tr").removeClass("activeRow");a.addClass("activeRow");e("input",a).prop("checked",
!0)}.bind(this));a.dblclick(function(){this._selectedDocTempIdx=c;this._docTemplateDialogSelectionConfirmed=!0;this._docTemplateDialog.close();this.dm.addDocTemplate(this._selectedDocTempIdx)}.bind(this))}.bind(this),s=0;s<this.dm.docTemplates.length;s++){var m=this.dm.docTemplates[s],g=e("<tr>",{"class":"docTemplateRow",style:"cursor: pointer"}),y=e("<td>").addClass("td-narrow").append(e("<input>").attr({type:"radio",value:s,name:"docTemplateSelectOption"}));0==s&&e("input",y).prop("checked",!0);
var t=e("<td>",{style:"text-align: center;"}).addClass("td-narrow"),G=e("<img>",{src:m.thumbnailURL,width:50,height:50,align:"middle"}),F=e("<td>"),m=e("<span>",{"class":"docTemplateName"}).text(m.name);g.append(y,t);t.append(G);g.append(F);F.append(m);n(g,s);0==s&&(this._selectedDocTempIdx=0,g.addClass("activeRow"));l.append(g)}h.append(l);c.on("keyup",function(){var a=c.val().toLowerCase();0<a.length?e("tr",l).each(function(c,g){var b=e("td > span.docTemplateName",g).text().toLowerCase(),d=e(g);
-1!=b.indexOf(a)?d.show():d.hide()}):e("tr",l).show()}.bind(this));i.append(h);a.append(j);a.append(i);b.append(a);d.setContent(b);return d};d.prototype.renderDocumentSpec=function(d,b){try{this._nameColResizer&&e(window).off("resize",this._nameColResizer);var a=e("<"+this.itemRootElemStr+">");b.width&&"auto"!=b.width&&a.width(b.width);var c=e(this.addStartOfCustomWidthDiv(b,"150px"));if(this.dm.selDocTemplate){var j=e("<div>"),i=e("<span>",{"class":"docname-label"}).text(this.dm.dlsName),h=this.renderDocDetails();
j.append(i,h);var q;if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix()){var p="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",s=this.dm.docNameSuffix?this.dm.docNameSuffix:"";q=e("<input>",{type:"text","class":this.getSAHIHelperStr("docnamesuffix")+" docname-input",placeholder:k.t("DocRowDocumentSuffix"),value:s,onchange:p})}else q=e("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:this.getAutoNamingPreview(),disabled:"disabled"});
else{var m="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",g=this.dm.docName?this.dm.docName:"";q=e("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:k.t("DocRowDocumentName"),value:g,onchange:m})}var y="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",t=this.dm.docDesc?this.dm.docDesc:"",G=e("<input>",{type:"text","class":this.getSAHIHelperStr("docdescription")+" docname-input",placeholder:k.t("DocRowDocumentDescription"),
value:t,onchange:y}),F=this.renderDocFolderSelector("true"!=b.hideFolder);this.dm.isEditable||(q.attr("disabled","disabled"),G.attr("disabled","disabled"));var B=e("<div>",{style:"width: 100%"}),E=e("<div>",{style:"float: left; width: 100%;","class":"DocumentNameRow"}),C=e("<div>",{style:"float: left; width: 100%;","class":"DocumentNameRow"});E.append(q);C.append(G);B.append(E,C);var z=e("<div>",{style:"width: 100%",id:this.phElemID+"_folderSelPHID"});z.append(F);"true"==b.hideSource&&j.hide();"true"==
b.hideDescription&&C.hide();"true"==b.hideFolder&&z.hide();this._nameColResizer=function(){B&&(E.is(":visible")&&C.is(":visible"))&&(360>B.width()?(E.css("width","100%"),E.css("padding-right","0px"),C.css("width","100%")):(E.css("width","50%"),E.css("padding-right","2px"),C.css("width","50%")))};e(window).resize(this._nameColResizer);window.setTimeout(function(){this._nameColResizer()}.bind(this),1);c.append(j);c.append(B);c.append(z)}else{var w=e("<button>",{type:"button","class":"btn btn-default"}).text(l.xmlencode(k.t("DocRowSelectTemplate")));
w.on("click",function(){this.dm.showDocTemplateDialog()}.bind(this));var A=e("<input>",{type:"hidden","class":"docname-input "+this.getSAHIHelperStr("docname")});c.append(w);c.append(A)}a.append(c);d.append(a)}catch(x){n.log("Problem in DocumentRowNewView.renderDocumentSpec:\n"+x)}};d.prototype.renderDocDetails=function(){return e("<span>",{"class":"docname-text"}).text(this.dm.selDocTemplate.name)};d.prototype.renderCloneButton=function(f){try{d.prototype.parent.parent.renderCloneButton.call(this,
f)}catch(b){n.log("Problem in DocumentRowSearchView.renderCloneButton:\n"+b)}};return d});
define("doctablex/DocumentRowNew","doctablex/DocumentRow doctablex/DocumentRowNewView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml underscore jquery".split(" "),function(h,n,k,l,e,i,d,f){var b=function(a){if(!a)return this;a.viewClass||(a.viewClass=n);h.call(this,a);this.dlsName=a.dlsName||"New";this.docOperation="New";this.newDocTmpID=a.newDocTmpID?a.newDocTmpID:"newID_"+this.rowID;if(!this.project||!this.project.id)this.project={id:this.getParentDocTable().projectID};
this.isDocTempDialogInitialized=!1;this.constructor==b.prototype.constructor&&this._initializeFromServer();return this};b.prototype=new h;b.prototype.constructor=b;b.prototype.parent=h.prototype;b.prototype._initializeFromServer=function(){if(this.copyOfExistingRowID)this.setStatus("ready");else{this.setStatus("loading");var a=k.getInstance().getDocTemplatesByProjID(this.project.id,!0),c=k.getInstance().getFoldersByProjID(this.project.id);f.when(a,c).done(function(a,c){this.sourceProjID=a.tempProjID;
this.updateDocTemplates(a);this.updateTargetFolders(c);this.showDocTemplateDialog();this.updateOtherInfoFromServer(!0,!1)}.bind(this)).fail(function(a){this.isInConfigPreview()?alert(e.t("DocSrcHdlNoDocTempInConfig")):(this.setStatus("error"),alert("Failed to load document templates from the server.\n"+a))}.bind(this))}};b.prototype.getDocRowInfo=function(){var a=b.prototype.parent.getDocRowInfo.call(this);d.extend(a,{dlsName:this.dlsName,newDocTmpID:this.newDocTmpID});return a};b.prototype.addDocTemplate=
function(a){this.setStatus("loading");this.updateDocTemplateSelection(a);this.preselectTargetFolder();this.parentDocTable.addDocTemplateRow(this);this.setStatus("ready");this.showDocAttributeCategory(!1,!0)};b.prototype.showDocTemplateDialog=function(){if(!this.isModifiedElsewhere()&&this.docTemplates)if(0==this.docTemplates.length)alert(e.t("DocSrcHdlNoDocTempComplyFilter"));else if(1==this.docTemplates.length)this.updateDocTemplateSelection(0),this.preselectTargetFolder(),this.parentDocTable.addDocTemplateRow(this),
this.setStatus("ready"),this.showDocAttributeCategory(!1,!0);else{var a=this.view.getDocTemplateDialogPlaceholder();this.view.renderDocTemplateDialog();a.open();this.setStatus("wait4user")}};b.prototype.updateDocTemplateSelection=function(a){b.prototype.parent.updateDocTemplateSelection.call(this,a);this.selDocTemplate&&(this.docName=this.selDocTemplate.name,this.thumbnailURL=this.selDocTemplate.thumbnailURL,this.docTypeID=this.selDocTemplate.docTypeID);var a=k.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id),
c="resolved"==a.state();f.when(a).done(function(a){this.updateDocumentType(a,!c)}.bind(this)).fail(function(a){l.log("Failed to load document templates from the server.\n"+a)}.bind(this)).always(function(){this.setIsChanged()}.bind(this));return a.promise()};b.prototype.convertToXML=function(){var a="";try{if(this.isInErrorStatus())return a;var c="<ds>",c=c+i.ElementEncode("action",this.docOperation);this.newDocTmpID&&(c+=i.ElementEncode("new_doc_temp_id",this.newDocTmpID));c+=i.ElementEncode("template_dv_id",
this.selDocTemplate.docVerID);this.project.id&&(c+=i.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(c+=i.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?c+=i.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(c+=i.ElementEncode("doc_name",this.docName));this.docDesc&&(c+=i.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(c+=i.ElementEncode("doc_attr_cat_id",this.aCatID));c+=i.ElementEncode("doc_temp_id",
this.selDocTemplate.id);c+=i.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName);a=b.prototype.parent.convertToXML.call(this,c+"</ds>")}catch(d){l.log("Problem in DocumentRowNew.convertToXML:\n"+d),a=""}return a};b.prototype.getAttCatView=function(){var a=l.getRenderItem(this.renderOptions.columns,"AttributeFlapout");return a&&!1===a.useCreationView?this.aCatView||"Default":"Creation"};return b});
define("doctablex/DocumentRowLinkView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(h,n,k){var l=function(e,i,d){if(!e&&!i&&!d)return this;h.call(this,e,i,d);return this};l.prototype=new h;l.prototype.constructor=l;l.prototype.parent=h.prototype;l.prototype.renderDocumentSpec=function(e,i){try{var d=$("<"+this.itemRootElemStr+">");i.width&&"auto"!=i.width&&d.width(i.width);var f=$(this.addStartOfCustomWidthDiv(i,"150px"));if(this.dm.isInErrorStatus()){var b=
this.dm.isInConfigPreview()?$("<span>").text(k.t("DocSrcHdlNoProjectInConfig")):$("<span>").text(k.t("DocRowLoadingDocsError"));f.append(b)}else{var a=$("<div>",{"class":"DocumentNameRow"});if(this.dm.availableDocuments)if(0==this.dm.availableDocuments.length)b=$("<span>").text(k.t("DocRowNoDocsAvailable")),a.append(b);else if(this.dm.isModifiedElsewhere()){var c=$("<span>").text(this.dm.docName);a.append(c)}else{var j="javascript: "+this.dm.getThisInDOM()+".docVersionSelected(this.value);",h=$("<select>",
{"class":"docname-input "+this.getSAHIHelperStr("docname"),onChange:j}),l=$("<option>",{value:""}).text(k.t("DocRowPleaseSelect"));h.append(l);for(b=0;b<this.dm.availableDocuments.length;b++){var q=this.dm.availableDocuments[b].id,p=this.dm.availableDocuments[b].name,s=$("<option>",{value:q}).text(p);this.dm.docVerID==q&&s.attr("selected","selected");h.append(s)}a.append(this.renderDocDetails());a.append(h)}else b=$("<span>").text(k.t("DocRowLoadingDocs")),a.append(b);f.append(a)}d.append(f);e.append(d)}catch(m){n.log("Problem in DocumentRowLinkView.renderDocumentSpec:\n"+
m)}};l.prototype.renderDocDetails=function(){return $()};l.prototype.renderThumbnail=function(e,i){try{if(this.dm.docVerID)l.prototype.parent.renderThumbnail.call(this,e,i);else{var d="<"+this.itemRootElemStr+">",d=d+this.customThumbnailHTML("thumbnails/other.gif",i.thumbnailSize),d=d+("</"+this.itemRootElemStr+">");e.append(d)}}catch(f){n.log("Problem in DocumentRowLinkView.renderThumbnail:\n"+f)}};return l});
define("doctablex/DocumentRowLink","doctablex/StaticDocumentRow doctablex/DocumentRow doctablex/DocumentRowLinkView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml underscore jquery".split(" "),function(h,n,k,l,e,i,d,f,b){var a=function(c){if(!c)return this;c.viewClass||(c.viewClass=k);n.call(this,c);this.dlsName=c.dlsName||"Link";this.docOperation=c.docOperation;this.docOperation||(this.docOperation="Reference");this.project={id:this.getParentDocTable().projectID};
this.availableDocuments=c.availableDocuments||null;this.constructor==a.prototype.constructor&&this._initializeFromServer();return this};a.prototype=new n;a.prototype.constructor=a;a.prototype.parent=n.prototype;a.prototype._initializeFromServer=function(){if(this.copyOfExistingRowID)this.setStatus("ready");else if(this.project.id){this.setStatus("loading");this.sourceProjID=this.project.id;var a=l.getInstance().getDocVersionsByProjID(this.project.id);a.done(function(a){this.initDocsInCurrentProject(a);
this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this));a.fail(function(a){this.setStatus("error");alert(i.t("DocRowLoadingDocsError")+":\n"+a)}.bind(this))}else this.setStatus("error")};a.prototype.getDocRowInfo=function(){var c=a.prototype.parent.getDocRowInfo.call(this);f.extend(c,{dlsName:this.dlsName,availableDocuments:[]});f.each(this.availableDocuments,function(a){c.availableDocuments.push(f.extend({},a))},this);return c};a.prototype.resetDocument=function(){var c=
this.project;a.prototype.parent.resetDocument.call(this,!0);this.project=c};a.prototype.initDocsInCurrentProject=function(a){this.availableDocuments=[];if(a&&0<a.length)if("LinkToTask"==this.docOperation)for(var b=this.getParentDocTable().getAllDocumentsIDs(),d=0;d<a.length;d++)-1==b.indexOf(a[d].docID)&&this.availableDocuments.push(a[d]);else this.availableDocuments=a};a.prototype.canUserEditAttributes=function(){var a=this.userPerms?this.userPerms.change:!1;return!this.isInactive()&&!this.isInErrorStatus()&&
this.isLatestDocVersion()&&!this.dependsOnItself&&a};a.prototype.generateDocAttributeValuesAJAXURL=function(){return a.prototype.parent.parent.generateDocAttributeValuesAJAXURL.call(this)};a.prototype.convertToXML=function(){var c="";try{if(this.isInErrorStatus()||!this.docVerID)return c;var b="<ds>",b=b+d.ElementEncode("action",this.docOperation);this.docVerID&&(b+=d.ElementEncode("source_dv_id",this.docVerID));c=a.prototype.parent.convertToXML.call(this,b+"</ds>")}catch(f){e.log("Problem in DocumentRowLink.convertToXML:\n"+
f),c=""}return c};a.prototype.validateDocRow=function(c,d){var f=!0,e=b("#"+this.getRowPrefix()+" div.DocumentNameRow > select:first"),h=null;0==e.length?this.docName||(h={isBlocking:!0,level:d,msg:i.t("DocRowDocNameNotSelectable"),element:b("#"+this.getRowPrefix()),docRowObj:this}):1==e.length&&!e.val()&&(h={isBlocking:!0,level:d,msg:i.t("DocRowDocNotSelected"),element:e,docRowObj:this});null!=h&&(c.errors.push(h),f=!1);a.prototype.parent.parent.validateDocRow.call(this,c,d)||(f=!1);return f};a.prototype.validateDocRowUniqueName=
function(){};a.prototype.docVersionSelected=function(a){if(this.docVerID==a)return null;this.resetDocument();this.setStatus("loading");this.docVerID=a;this.getParentDocTable().isDocDependentOnItself(this)&&(confirm(i.t("DocRowDocDependentOnItself"))?this.setDependsOnItself(!0):this.docVerID="");if(""==this.docVerID)return this.setStatus("ready"),this.view.repaintRow(),this.hideDocAttributeCategory(),null;a=this.updateDocInfoFromServer(!1);a.done(function(){this.setStatus("ready");this.view.repaintRow();
this.showDocAttributeCategory(!1,!0)}.bind(this));a.fail(function(a){this.setStatus("error");e.error("Failed to load document information from the server:\n"+a)}.bind(this));a.always(function(){this.setIsChanged();this.setIsChangedByUser();this.setFieldModByUser("docName",!this.docName)}.bind(this));return a.promise()};return a});
define("doctablex/DocumentRowCopyView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","component/sdrop/SDrop","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(h,n,k,l){var e=function(e,d,f){if(!e&&!d&&!f)return this;h.call(this,e,d,f);this.documentSelector=this.projectSelector=this.documentSelectorElem=this.projectSelectorElem=null;return this};e.prototype=new h;e.prototype.constructor=e;e.prototype.parent=h.prototype;e.prototype.renderDocumentSpec=function(e,d){try{this._nameColResizer&&
$(window).off("resize",this._nameColResizer);var f=$("<"+this.itemRootElemStr+">");d.width&&"auto"!=d.width&&f.width(d.width);var b=$(this.addStartOfCustomWidthDiv(d,"150px"));if(this.dm.isInErrorStatus()){this.projectSelector&&this.projectSelector.destroy();this.documentSelector&&this.documentSelector.destroy();var a=$("<span>").text(l.t("DocRowLoadingDocsError"));b.append(a)}else{var c=$("<div>",{style:"float: left;","class":"docname-label inline-element"}).text(this.dm.dlsName+":"),j=$("<div>",
{style:"float: left; width: 100%;","class":"DocumentSelectorRow"}),h=$("<div>",{style:"float: left; width: 100%","class":"DocumentSelectorRow"});this.projectSelectorElem?this.projectSelector&&j.append(c,this.projectSelector.wrapper):(this.projectSelectorElem=$("<select>",{"class":"project-selector-SDrop"}),j.append(c,this.projectSelectorElem),(this.projectSelector=this.initializeProjectSelectorSDrop())&&this.dm._updateProjectSelector());this.documentSelectorElem?this.documentSelector&&h.append(this.documentSelector.wrapper):
(this.documentSelectorElem=$("<select>",{"class":"document-selector-SDrop"}),h.append(this.documentSelectorElem),(this.documentSelector=this.initializeDocumentSelectorSDrop())&&this.dm._updateDocumentSelector());this.projectSelector.setDisabled(!this.dm.isEditable);this.documentSelector.setDisabled(!this.dm.isEditable);var k=$("<input>").hide();if("Link"!=this.dm.docOperation)if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var q="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",
p=this.dm.docNameSuffix?this.dm.docNameSuffix:"",k=$("<input>",{type:"text","class":this.getSAHIHelperStr("docnamesuffix")+" docname-input",placeholder:l.t("DocRowDocumentSuffix"),value:p,onchange:q});else k=$("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+" docname-input",placeholder:this.getAutoNamingPreview(),disabled:"disabled"});else var s=this.dm.docName?this.dm.docName:"",m="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",k=$("<input>",{type:"text","class":this.getSAHIHelperStr("docname")+
" docname-input",placeholder:l.t("DocRowDocumentName"),value:s,onchange:m});else k=$("<span>",{"class":"docname-text"}).text(this.dm.docName);var g=$("<div>").hide(),y="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",t=this.dm.docDesc?this.dm.docDesc:"";if("Copy"==this.dm.docOperation)g=$("<input>",{type:"text","class":this.getSAHIHelperStr("docdescription")+" docname-input",placeholder:l.t("DocRowDocumentDescription"),value:t,onchange:y});else if(t){g.show();var G=$("<span>",
{"class":"docname-label"}).text(l.t("DocRowDocumentDescription")+":"),F=$("<span>",{"class":"docname-text"}).text(t);g.append(G,F)}var B=$("<div>").hide();"Copy"==this.dm.docOperation&&(B=this.renderDocTemplateSelector("true"!=d.hideDocTemplate));var E=this.renderDocFolderSelector("true"!=d.hideFolder);this.dm.isEditable||(k.prop("disabled",!0),g.prop("disabled",!0));var C=$("<div>",{style:"width: 100%"});C.append(j,h);var z=$("<div>",{style:"width: 100%"}),w=$("<div>",{style:"float: left; width: 100%;",
"class":"DocumentNameRow"}),A=$("<div>",{style:"float: left; width: 100%","class":"DocumentNameRow"});w.append(k);A.append(g);z.append(w,A);var x=$("<div>",{style:"width: 100%",id:this.phElemID+"_docTempFolderSelPHID"}),D=$("<div>",{style:"float: left; width: 100%;"}),H=$("<div>",{style:"float: left; width: 100%"});B?D.append(B):D.hide();H.append(E);x.append(D,H);"true"==d.hideDescription&&A.hide();"true"==d.hideDocTemplate&&D.hide();"true"==d.hideFolder&&H.hide();var I=null;this._nameColResizer=
function(){var a=0;if(C&&j.is(":visible")&&h.is(":visible")){a=C.width();360>a?(j.css("width","100%"),j.css("padding-right","0px"),h.css("width","100%")):(j.css("width","50%"),j.css("padding-right","2px"),h.css("width","50%"));null==I&&(I=c.width()+10);var a=j.width(),a=Math.ceil(100*(I/a)),g=100-a;this.projectSelector.wrapper.addClass("inline-element");c.css({width:a+"%","padding-top":"5px"});this.projectSelector.wrapper.css("width",g+"%")}z&&(w.is(":visible")&&A.is(":visible"))&&(a=z.width(),360>
a?(w.css("width","100%"),w.css("padding-right","0px"),A.css("width","100%")):(w.css("width","50%"),w.css("padding-right","2px"),A.css("width","50%")),w.height()>A.height()?A.css("height",w.height()+"px"):w.css("height",A.height()+"px"));x&&(D.is(":visible")&&H.is(":visible"))&&(a=x.width(),360>a?(D.css("width","100%"),D.css("padding-right","0px"),H.css("width","100%")):(D.css("width","50%"),D.css("padding-right","2px"),H.css("width","50%")))}.bind(this);$(window).resize(this._nameColResizer);window.setTimeout(function(){this._nameColResizer()}.bind(this),
1);b.append(C,z,x)}f.append(b);e.append(f)}catch(u){n.log("Problem in DocumentRowCopyView.renderDocumentSpec:\n"+u)}};e.prototype.initializeProjectSelectorSDrop=function(){if(!this.projectSelectorElem)return null;if(this.projectSelectorElem[0]&&this.projectSelectorElem[0].SDrop)return this.projectSelectorElem[0].SDrop;var e=new SDropDataProvider({dataSource:"GetNameIDList.jsp?list=VisibleProjects"}),d=new k(this.projectSelectorElem,null,e,{manageStyleAndWidth:!1,minWidth:400,maxWidth:600,autoload:!0});
d.options.i18n.startTyping=l.t("DocRowCopySelectProject");this.projectSelectorElem.change(function(){var f=d.getSelectedItemID();this.dm.projectSelected(d.dataProvider.getById(f))}.bind(this));return d};e.prototype.initializeDocumentSelectorSDrop=function(){if(!this.documentSelectorElem)return null;if(this.documentSelectorElem[0]&&this.documentSelectorElem[0].SDrop)return this.documentSelectorElem[0].SDrop;var e=new StaticSDropDataProvider,d=new k(this.documentSelectorElem,null,e,{manageStyleAndWidth:!1,
minWidth:400,maxWidth:600,autoload:!0});d.options.i18n.startTyping=l.t("DocRowCopySelectDocument");this.documentSelectorElem.change(function(){var f=d.getSelectedItemID(),b=d.dataProvider.getById(f).name;this.dm.documentSelected(f?{versionID:f,name:b}:null,!0)}.bind(this));return d};e.prototype.renderThumbnail=function(h,d){try{if(this.dm.docVerID)e.prototype.parent.renderThumbnail.call(this,h,d);else{var f="<"+this.itemRootElemStr+">",f=f+this.customThumbnailHTML("thumbnails/other.gif",d.thumbnailSize),
f=f+("</"+this.itemRootElemStr+">");h.append(f)}}catch(b){n.log("Problem in DocumentRowCopyView.renderThumbnail:\n"+b)}};e.prototype.destroy=function(e){e?(this.projectSelector&&this.projectSelector.destroy(),this.documentSelector&&this.documentSelector.destroy()):(this.projectSelector&&this.projectSelector.wrapper&&this.projectSelector.wrapper.detach(),this.documentSelector&&this.documentSelector.wrapper&&this.documentSelector.wrapper.detach())};return e});
define("doctablex/DocumentRowCopy","doctablex/StaticDocumentRow doctablex/DocumentRow doctablex/DocumentRowCopyView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml underscore jquery wcr/sdrop".split(" "),function(h,n,k,l,e,i,d,f,b){var a=function(c){if(!c)return this;c.viewClass||(c.viewClass=k);n.call(this,c);this.dlsName=c.dlsName||"Copy";this.docOperation=c.docOperation||"Copy";this.newDocTmpID=c.newDocTmpID||"";"Copy"==this.docOperation&&!c.newDocTmpID&&
(this.newDocTmpID="newID_"+this.rowID);this.selProject=c.selProject||this._emptySelProjectObj();this.selDocument=c.selDocument||this._emptySelDocumentObj();this.constructor==a.prototype.constructor&&this._initializeFromServer();return this};a.prototype=new n;a.prototype.constructor=a;a.prototype.parent=n.prototype;a.prototype._initializeFromServer=function(){this.setStatus("loading");var a=b.Deferred();if(this.copyOfExistingRowID)return this.setStatus("ready"),a.resolve().promise();var d=null;"Copy"==
this.docOperation&&this.project.id&&(d=l.getInstance().getDocTemplatesByProjID(this.project.id));var f=null;"Reference"!=this.docOperation&&this.project.id&&(f=l.getInstance().getFoldersByProjID(this.project.id));b.when(d,f).done(function(b,d){this.useDocTypeDefaultACat=this.hasNoAttrCat()&&"Copy"==this.docOperation;b&&(this.updateDocTemplates(b),this.preselectDocTemplate());this.updateTargetFolders(d);this.preselectTargetFolder();a.resolve();this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!1,
!0)}.bind(this)).fail(function(b){a.reject();this.setStatus("error");window.alert("Problem with retrieving document templates:\n"+b)}.bind(this));return a.promise()};a.prototype._updateDocInfo=function(a){return this._strippedUpdateDocInfo(a)};a.prototype.getDocRowInfo=function(){var c=a.prototype.parent.getDocRowInfo.call(this);f.extend(c,{dlsName:this.dlsName,selProject:this.selProject,selDocument:this.selDocument,newDocTmpID:this.newDocTmpID});return c};a.prototype._emptySelProjectObj=function(){return{id:"",
name:""}};a.prototype._emptySelDocumentObj=function(){return{versionID:"",name:""}};a.prototype.resetDocument=function(c){c&&(this.selProject=this._emptySelProjectObj(),this.selDocument=this._emptySelDocumentObj(),this.sourceProjID=null,this.folder={});a.prototype.parent.resetDocument.call(this,!1)};a.prototype.isAutonamingEnabled=function(){return null!=this.anPrefix&&0<this.anPrefix.length&&"Copy"==this.docOperation};a.prototype.canUserEditAttributes=function(){var a=!1,a=this.userPerms?this.userPerms.change:
!1,b=!1;this.selTargetFolder?b=this.selTargetFolder.changePropPerm:this.getParentDocTable().isBlankProjectCreationContext()&&(b=!0);a="Link"==this.docOperation?a||b:b;return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&a};a.prototype.generateDocAttributeValuesAJAXURL=function(){var a=window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&e.isValidID(this.selDocTemplate.categoryID)?(a=a+"GetAttributes.jsp?doctemplate=1"+
("&projectid="+this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):this.hasOrigDocACat&&this.docVerID?a+="GetAttributes.jsp?docverid="+this.docVerID:e.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:e.log("Cannot generate URL in DocumentRowCopy.generateDocAttributeValuesAJAXURL().");return a};a.prototype.getAttCatView=function(){var a=!1,b=e.getRenderItem(this.renderOptions.columns,
"AttributeFlapout");b&&!1===b.useCreationView&&(a=!0);return!a&&"Copy"==this.docOperation?"Creation":this.aCatView||"Default"};a.prototype.setSelectedProject=function(a){!a||!a.id?(this.selProject=this._emptySelProjectObj(),this.sourceProjID=null):(this.sourceProjID=this.selProject&&this.selProject.id!=a.id?null:a.id,this.selProject=a);this.setSelectedDocument(null)};a.prototype.setSelectedDocument=function(a){!a||!a.versionID?(this.selDocument=this._emptySelDocumentObj(),this.folder={}):(this.docVerID!=
a.versionID&&(this.folder={}),this.selDocument=a);this.docVerID=this.selDocument.versionID;this.docName=this.selDocument.name};a.prototype._updateProjectSelector=function(){this.view.projectSelector&&(this.selProject&&this.selProject.id)&&this.view.projectSelector.setSelectedItemByID(this.selProject.id)};a.prototype._updateDocumentSelector=function(){if(!this.view.documentSelector||!this.selProject||!this.selProject.id)return null;var a=l.getInstance().getDocVersionsByProjID(this.selProject.id);a.done(function(a){for(var c=
[],b=0;b<a.length;b++){var d=a[b];d&&d.id&&c.push({name:d.name,id:d.id})}a=new StaticSDropDataProvider;a.setData(c);this.view.documentSelector.setDataProvider(a,!0);this.selDocument&&this.selDocument.versionID&&this.view.documentSelector.setSelectedItemByID(this.selDocument.versionID);this.view.documentSelector.show();this.view.documentSelector.enable();this.setStatus("ready")}.bind(this));a.fail(function(a){this.setStatus("error");window.alert(i.t("DocRowLoadingDocsError")+":\n"+a);this.view.repaintRow();
this.hideDocAttributeCategory()}.bind(this));return a.promise()};a.prototype.convertToXML=function(){var c="";try{if(this.isInErrorStatus()||!this.docVerID)return c;var b="<ds>",b=b+d.ElementEncode("action",this.docOperation);this.newDocTmpID&&(b+=d.ElementEncode("new_doc_temp_id",this.newDocTmpID));this.docVerID&&(b+=d.ElementEncode("source_dv_id",this.docVerID));this.project.id&&(b+=d.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(b+=d.ElementEncode("target_folder_name",this.selTargetFolder.name));
this.isAutonamingEnabled()?b+=d.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(b+=d.ElementEncode("doc_name",this.docName));this.docDesc&&(b+=d.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(b+=d.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(b+=d.ElementEncode("doc_temp_id",this.selDocTemplate.id),b+=d.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName));c=a.prototype.parent.convertToXML.call(this,
b+"</ds>")}catch(f){e.log("Problem in DocumentRowCopy.convertToXML:\n"+f),c=""}return c};a.prototype.validateDocRow=function(a,d){var f=!0,e=null;this.docVerID||(f=b("#"+this.getRowPrefix()),this.view.documentSelector&&this.view.documentSelector.wrapper&&(f=this.view.documentSelector.wrapper.parent()),e={isBlocking:!0,level:d,msg:i.t("DocRowFileNotChosen"),element:f,docRowObj:this},a.errors.push(e),f=!1);"Link"==this.docOperation?(this.docName||(e={isBlocking:!0,level:d,msg:i.t("DocRowDocNameNotSelectable"),
element:b("#"+this.getRowPrefix()),docRowObj:this},a.errors.push(e),f=!1),h.prototype.validateDocRow.call(this,a,d)||(f=!1)):n.prototype.validateDocRow.call(this,a,d)||(f=!1);return f};a.prototype.validateDocRowUniqueName=function(b){"Link"!=this.docOperation&&a.prototype.parent.validateDocRowUniqueName.call(this,b)};a.prototype.projectSelected=function(a){!this.selProject.id&&!a||this.selProject.id==a.id||(this.setStatus("loading"),this.setSelectedProject(a),this.setIsChanged(),this.setIsChangedByUser(!1),
this.selProject.id?this.view.documentSelector&&this._updateDocumentSelector(!0):(this.resetDocument(!0),this.view.repaintRow(),this.hideDocAttributeCategory(),this.setStatus("ready")))};a.prototype.documentSelected=function(a,d){if(!this.docVerID&&!a||this.docVerID==a.versionID)return null;this.setStatus("loading");this.resetDocument(!1);this.setSelectedDocument(a);d||(this.setIsChanged(),this.setIsChangedByUser(!1));if(!this.docVerID)return this.view.repaintRow(),this.hideDocAttributeCategory(),
this.setStatus("ready"),null;var f=this.updateDocInfoFromServer(!1),h=null,h=this.project.id?l.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id):l.getInstance().getProjCreationSysDefaults();b.when(h,f).done(function(a){"Copy"==this.docOperation&&(this.docDesc="",this.updateDocumentType(a,!1));this.isModifiedByUser("docTemplate")?this.selDocTemplate&&(this.aCatID=this.selDocTemplate.categoryID):(this.preselectDocTemplate(),this.defTaskDocAttrCatID&&(this.aCatID=this.defTaskDocAttrCatID));
this.preselectTargetFolder();this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this));f.fail(function(a){this.setStatus("error");e.error("Failed to load document information from the server:\n"+a)}.bind(this));f.always(function(){d||this.setFieldModByUser("docName",!this.docName)}.bind(this));return f.promise()};return a});
define("doctablex/DocumentRowFactory","doctablex/DocTableXUtils doctablex/StaticDocumentRow doctablex/StaticDocumentRowView doctablex/DocumentRow doctablex/DocumentRowBrowse doctablex/DocumentRowFile doctablex/DocumentRowExternalFile doctablex/DocumentRowSearch doctablex/DocumentRowSearchView doctablex/DocumentRowNew doctablex/DocumentRowNewView doctablex/DocumentRowLink doctablex/DocumentRowLinkView doctablex/DocumentRowCopy require lib/PromisePolyfill".split(" "),function(h,n,k,l,e,i,d,f,b,a,c,
j,r,v,q){var p=function(d){this.isPCMEnabled=!1;void 0===d?window.webcenterConfig&&(this.isPCMEnabled=!!window.webcenterConfig.isPCMEnabled):this.isPCMEnabled=!!d;this.initialization=new Promise(function(d){this.isPCMEnabled?q("doctablex/TextContentRow doctablex/TextContentRowView doctablex/AddedTextContentRow doctablex/TextContentRowSearch doctablex/TextContentRowSearchView doctablex/TextContentRowNew doctablex/TextContentRowNewView doctablex/TextContentRowLink doctablex/TextContentRowLinkView".split(" "),
function(g,e,h,i,p,B,E,q,s){g.call(n.prototype);h.call(l.prototype);i.call(f.prototype);B.call(a.prototype);q.call(j.prototype);e.call(k.prototype);E.call(c.prototype);p.call(b.prototype);s.call(r.prototype);d({TextContentRow:g,TextContentRowView:e,AddedTextContentRow:h,TextContentRowSearch:i,TextContentRowSearchView:p,TextContentRowNew:B,TextContentRowNewView:E,TextContentRowLink:q,TextContentRowLinkView:s})}.bind(this)):d()}.bind(this));return this};p.prototype.createDocumentRow=function(b,c){return this.initialization.then(function(g){var y=
new b(c);if(this.isPCMEnabled){var t=[];b==n?t=[g.TextContentRow]:b==l?t=[g.TextContentRow,g.AddedTextContentRow]:b==e?t=[g.TextContentRow,g.AddedTextContentRow]:b==i?t=[g.TextContentRow,g.AddedTextContentRow]:b==f?t=[g.TextContentRow,g.AddedTextContentRow,g.TextContentRowSearch]:b==a?t=[g.TextContentRow,g.AddedTextContentRow,g.TextContentRowNew]:b==j?t=[g.TextContentRow,g.AddedTextContentRow,g.TextContentRowLink]:b==v?t=[g.TextContentRow,g.AddedTextContentRow]:b==d?t=[]:h.error("Class '"+b+"' is not supported in PCM context!");
for(g=0;g<t.length;g++){var k=t[g];k.__initMixin&&k.__initMixin.call(y,c)}}return y}.bind(this))};p.prototype.createStaticDocumentRow=function(a){return this.createDocumentRow(n,a)};return new p});define("utils/webcss-text!doctablex/style/doctablex-style.css",[],function(){return'.w .doctablex.table {\r\n}\r\n.w .doctablex-wrapper.wcr-table {\r\n\tborder: 0px;\r\n}\r\n.w .doctablex-wrapper .wcr-table-section {\r\n\tborder: 0px;\r\n\tborder-top: 1px solid #dddddd;\r\n\toverflow: visible;\r\n}\r\n.w .doctablex-wrapper .wcr-table-filter {\r\n\tborder: 1px solid #dddddd;\r\n\tborder-bottom: 0px;\r\n}\r\n.w .doctablex.table {\r\n\tborder: 0px;\r\n}\r\n.w .doctablex.table > thead {\r\n\tborder: 0px;\r\n\tborder-right: 1px solid #dddddd;\r\n\tborder-left: 1px solid #dddddd;\r\n}\r\n.w .doctablex.table > thead > tr > th {\r\n\twhite-space: nowrap;\r\n    font-weight: 500;\r\n    padding: 6px 3px;\r\n}\r\n.w .doctablex.table > thead > tr > th > .text-lang-selector {\r\n\twidth: auto;\r\n    height: auto;\r\n    padding: 2px;\r\n    font-size: inherit;\r\n    line-height: inherit;\r\n    color: inherit;\r\n    background-color: white;\r\n    background-image: none;\r\n    border: 1px solid #dddddd;\r\n    border-radius: 0px;\r\n    box-shadow: none;\r\n}\r\n.w .doctablex.table > tbody.DocEntry {\r\n\tborder: 0px;\r\n}\r\n.w .doctablex.table > tbody.DocEntry > tr {\r\n\tborder: 0px;\r\n}\r\n.w .doctablex.table > tbody.DocEntry > tr > td {\r\n\tborder: 0px;\r\n}\r\n.w .doctablex.table > tbody.DocEntry + tbody.DocEntry {\r\n\tborder-top: 1px solid #dddddd;\r\n}\r\n.w .doctablex.table > tbody.DocEntry > tr.newVersionRow > td {\r\n\tpadding: 0px;\r\n}\r\n.w .doctablex.table > tbody.DocEntry > tr > td {\r\n\tpadding: 3px;\t\r\n}\r\n.w .doctablex.table > tbody.DocEntry:last-child > tr > td {\r\n\tpadding-bottom: 5px;\t\r\n}\r\n.w .doctablex.table > tbody.DocEntry > tr > td > .LimitWidth {\r\n\twidth: 100%;\r\n    overflow: hidden;\r\n    text-overflow: ellipsis;\r\n    display: inline-block;\r\n    white-space: nowrap;\r\n}\r\n.w .doctablex.table .docname-input {\r\n\twidth: 100%;\r\n\theight: 20px;\r\n\tfont-size: 11px;\r\n\tdisplay: block;\r\n\tmargin: 0px;\r\n\tmargin-bottom: 2px;\r\n\tpadding: 1px;\r\n\tborder: 1px solid #ccc;\r\n\tbackground-color: white;\r\n}\r\n.w .doctablex.table .docname-upload {\r\n\tpadding-bottom: 2px;\t\r\n}\r\n.w .doctablex.table .docname-upload > .docname-upload-text {\r\n\tpadding-left: 5px;\t\r\n}\r\n.w .doctablex.table .docname-input[disabled="disabled"] {\r\n\tbackground-color: #F9F9F9;\r\n}\r\n.w .doctablex.table input[type="file"].docname-input {\r\n\theight: initial;\r\n}\r\n.w .doctablex.table input[type="text"].docname-input {\r\n\tpadding-left: 3px;\r\n}\r\n.w .doctablex.table .docname-label {\r\n\tpadding-right: 2px;\r\n\tfont-weight: bold;\r\n}\r\n.w .doctablex.table .docname-text {\r\n\tpadding-right: 2px;\r\n}\r\n.w .doctablex.table .file-input-selector {\r\n\theight: 22px;\r\n\tline-height: 20px;\r\n\tfont-size: 11px;\r\n}\r\n.w .doctablex.table .file-input-selector .feedback {\r\n\theight: 20px;\r\n\tline-height: 20px;\r\n\tfont-size: 11px;\r\n}\r\n.w .doctablex.table .file-input-selector .btn {\r\n\theight: 20px;\r\n\tline-height: 20px;\r\n\tfont-size: 11px;\r\n\tpadding: 0px 4px;\r\n}\r\n.w .doctablex.table .hidden-file-input {\r\n\t\r\n\tposition: fixed;\r\n\ttop: -100em;\r\n}\r\n.w .doctablex .FileRowLabel {\r\n\twhite-space: nowrap;\r\n}\r\n.w .doctablex.table .DocumentSelectorRow {\r\n\tmargin-bottom: 2px;\r\n}\r\n.w .doctablex.table .inline-element {\r\n\tfloat: left;\r\n}\r\n.w .doctablex td.attrCategoryColumn {\r\n\tpadding: 0px;\r\n}\r\n.w .doctablex td.uploadNewVersionColumn {\r\n\tpadding: 0px;\r\n}\r\n.w .DocTemplateDialog > .modal-dialog > .modal-content > .modal-body {\r\n\tpadding: 0px;\r\n}\r\n.w .DocTemplateDialog .DocTemplateDialogTable {\r\n\tmargin: 0px;\r\n\twidth: 100%;\r\n\tborder: 0px;\r\n}\r\n.w .DocTemplateDialog .DocTemplateDialogTable > thead > tr > th {\r\n\tborder: 0px;\r\n\tborder-bottom: 1px;\r\n}\r\n.w .DocTemplateDialog .DocTemplateDialogTable > tbody > tr.activeRow {\r\n\tbackground-color: #F5F5F5;\r\n}\r\n.w .taskdocs-section > tbody > tr > td > div > .doctablex-wrapper > .wcr-table-section {\r\n\tborder: 0px;\r\n}\r\n.w .taskdocs-section > tbody > tr > td > div > .doctablex-wrapper > .wcr-table-filter {\r\n\tborder: 0px;\r\n\tborder-bottom: 1px solid #dddddd;\r\n}\r\n.w .taskdocs-section > tbody > tr > td > div > .doctablex-wrapper > .wcr-table-section > .doctablex > thead {\r\n\tborder: 0px;\r\n}\r\n.w #documentsTableContainerDiv > .doctablex-wrapper > .wcr-table-section {\r\n\tborder: 0px;\r\n}\r\n.w #documentsTableContainerDiv > .doctablex-wrapper > .wcr-table-filter {\r\n\tborder: 0px;\r\n\tborder-bottom: 1px solid #dddddd;\r\n}\r\n.w #documentsTableContainerDiv > .doctablex-wrapper > .wcr-table-section > .doctablex > thead {\r\n\tborder: 0px;\r\n}\r\n.w .doctablex .projectStatus {\r\n\ttext-align: center;\r\n\tdisplay: block;\r\n}\r\n.w .doctablex .textcontent.elementypecolor {\r\n\tdisplay: inline-block;\r\n\twidth: 11px;\r\n\theight: 11px;\r\n\tborder: 1px solid #cccccc;\r\n\tmargin-right: 4px;\r\n\tmargin-bottom: -1px;\r\n}\r\n.w .doctablex td.referencePropertyCell > .form-entry {\r\n\tpadding: 0px;\r\n}\r\n.w .doctablex td.documentAttributeCell > .form-entry {\r\n\tpadding: 0px;\r\n}\r\n.w .doctablex .referencePropertyCell div.form-datetime, \r\n.w .doctablex .documentAttributeCell div.form-datetime {\r\n\tmargin-left: 0px;\r\n\tmargin-right: 0px;\r\n}\r\n\t\r\n.w .doctablex .referencePropertyCell div.form-datetime .form-date, \r\n.w .doctablex .documentAttributeCell div.form-datetime .form-date,\r\n.w .doctablex .referencePropertyCell div.form-datetime .form-time, \r\n.w .doctablex .documentAttributeCell div.form-datetime .form-time {\r\n\tfloat: left;\r\n\tpadding: 0px;\r\n\tpadding-right: 2px;\r\n\twidth: 50%;\r\n\tmargin-top: 1px;\r\n\tmargin-bottom: 1px;\r\n}\r\n \r\n.w .doctablex .documentAttributeCell div.form-datetime .form-time,\r\n.w .doctablex .referencePropertyCell div.form-datetime .form-time {\r\n\twidth: 47.3684%;\r\n    min-width: 9em;\r\n}\r\n.w .doctablex .documentAttributeCell div.form-datetime .form-date,\r\n.w .doctablex .referencePropertyCell div.form-datetime .form-date {\r\n\twidth: 52.631%;\r\n    min-width: 10em;\r\n}\r\n.w .doctablex-wrapper .action-menu-component .dropdown:hover .dropdown-menu {\r\n\tdisplay: none;\r\n}'});
define("doctablex/DocTableXView","doctablex/DocTableXUtils jquery wcr/webcenter_xml component/actionmenu/ActionMenu component/table/DropdownOverflowUtil utils/webi18n!DocRefStrings utils/webcss!./style/doctablex-style.css".split(" "),function(h,n,k,l,e,i){var d=function(d,b,a){if(!d&&!b&&!a)return this;this.dm=d;this.phElemID=b;this.renderMethodMap={AttributeFlapout:this.renderExpandCollapseButtonHeader,UpDownArrows:this.renderSortingArrowsHeader,SequenceNumber:this.renderSequenceNumberHeader,RowSelector:this.renderRowSelectorHeader,
DocumentName:this.renderDocumentSpecHeader,DocumentActions:this.renderDocumentActionsHeader,DocumentProperty_Thumbnail:this.renderThumbnailHeader,DocumentProperty_Description:this.renderDocumentDescriptionHeader,DocumentProperty_ApprovalStatus:this.renderApprovalStatusHeader,DocumentProperty_ApprovalStage:this.renderApprovalStageHeader,DocumentProperty_Project:this.renderDocProjectNameHeader,DocumentProperty_VersionRevision:this.renderDocumentVersionHeader,DocumentProperty_VersionAuthor:this.renderDocumentAuthorHeader,
DocumentProperty_ModifiedDate:this.renderDocumentModifiedDateHeader,ReferenceProperty:this.renderReferencePropertyHeader,DocumentAttribute:this.renderDocAttributeHeader,ProjectAttribute:this.renderProjectAttributeHeader,ProjectProperty_ProjectName:this.renderProjectNameHeader,ProjectProperty_ProjectStatus:this.renderProjectStatusHeader,ProjectProperty_ProjectDueDate:this.renderProjectDueDateHeader,LocalRemote:this.renderLocalRemoteButtonHeader,ReplaceButton:this.renderReplaceButtonHeader,CloneButton:this.renderCloneButtonHeader,
DeleteButton:this.renderDeleteButtonHeader};this.renderOptions=a;this.showDocActions=null!=h.getRenderItem(this.renderOptions.columns,"RowSelector")&&this.dm.isRootLevelTable();return this};d.prototype.render=function(d){var b=n("#"+this.phElemID);if(0===b.length)return b;this.dm.isInactive&&b.hide();var a=this.renderOptions;d&&(this.renderOptions=d);"list"==this.renderOptions.renderMethod?this.renderSimple(b):"table"==this.renderOptions.renderMethod?this.renderComplex(b):window.alert("Not supported render method: "+
this.renderOptions.renderMethod+".");for(d=0;d<this.dm.docRows.length;d++)this.dm.docRows[d].displayRow(!1);this.renderOptions=a;return b};d.prototype.repaintRemoteDocRows=function(){if(this.dm.docRows)for(var d=0;d<this.dm.docRows.length;d++){var b=this.dm.docRows[d];b.isRemoteDocument()&&b.view.repaintRow()}};d.prototype.repaintDocRows=function(){if(this.dm.docRows)for(var d=0;d<this.dm.docRows.length;d++)this.dm.docRows[d].view.repaintRow()};d.prototype.renderSimple=function(d){try{this.renderOptions.hideHeader=
!0,this.renderComplex(d)}catch(b){return h.log("Problem in DocTableXView.renderSimple:\n"+b),null}return d};d.prototype.renderComplex=function(d){try{this.dm.destroy();d.html("");e.cleanupDropdowns();this._root=d;this._tableWrapper=n("<div>",{"class":"wcr-table doctablex-wrapper"});var b="wcr-table-filter";this.dm.isModifiedElsewhere&&(b="alert alert-info");this._headerSection=n("<div>",{"class":b});this._tableSection=n("<div>",{"class":"wcr-table-section"});this._root.append(this._tableWrapper);
this._tableWrapper.append(this._headerSection);this._tableWrapper.append(this._tableSection);b=!0;if(this.dm.isModifiedElsewhere){var a=n("<span>").text(i.t("DocTableEditedElsewhere"));this._headerSection.append(a)}else{this._headerActionsHolder=n("<div>",{"class":"wcr-table-actions-row no-filter"});var c=n("<div>",{"class":"action-menu-component"});if(this.dm.isEditable)var j=this.dm.getDocumentSourceOptions(this.phElemID),c=this.dm.dshObj.getAsActions(j);c.attr("data-checkbox-selector","input[name='"+
this.dm.getRootLevelPrefix()+"_selectedDocs']");var k=this.dm.getExtraActions(this.phElemID);c.append(k);this._headerSection.append(this._headerActionsHolder);this._headerActionsHolder.append(c);l.wcrinit(c);0===c.children(":visible").length?(this._headerSection.hide(),b=!1):this._headerSection.show()}this._tableElem=n('<table id="'+this.phElemID+'_mainTable" class="table doctablex"></table>');this._tableSection.append(this._tableElem);this.renderTableHeader(this._tableElem);this.renderOptions.hideHeader?
this._tableElem.find("thead").hide():this._tableElem.find("thead").show();this.renderOptions.styleObj&&this.renderOptions.styleObj["background-color"]&&this._tableElem.css("background-color",this.renderOptions.styleObj["background-color"]);for(a=0;a<this.dm.docRows.length;a++){var v=this.dm.docRows[a],q=n("<tbody>",{"class":"DocEntry","data-docrow-id":v.view.phElemID}),p=n("<tr>",{id:v.view.phElemID});q.append(p);this._tableElem.append(q)}if(!this.dm.isInactive||this.dm.clearValues){var s=this.dm.getTablePrefix();
this._tableWrapper.append('<input type="hidden" id="'+s+'" name="'+s+'"/>')}e.repositionDropdowns(this._tableWrapper);0==this.dm.getNumberOfRows()&&!b?this._tableSection.hide():this._tableSection.show()}catch(m){return h.log("Problem in DocTableXView.renderComplex:\n"+m),null}return d};d.prototype.updateActions=function(){if(this._headerActionsHolder){this._headerActionsHolder.children().detach();var d=n("<div>",{"class":"action-menu-component"});this.dm.isEditable&&(d=this.dm.getDocumentSourceOptions(this.phElemID),
d=this.dm.dshObj.getAsActions(d));d.attr("data-checkbox-selector","input[name='"+this.dm.getRootLevelPrefix()+"_selectedDocs']");var b=this.dm.getExtraActions(this.phElemID);d.append(b);this._headerActionsHolder.append(d);0===d.children().length?this._headerSection.hide():this._headerSection.show();l.wcrinit(d)}};d.prototype.renderTableHeader=function(d){if(d&&0!==d.length)try{if(d.find("> thead").html(""),e.cleanupDropdowns(),0<this.dm.getNumberOfRows()){var b=d.find("> thead");0===b.length&&(b=
n("<thead/>"));d.append(b);var a=n("<tr/>");b.append(a);var c=this.renderOptions.columns;if(c)for(d=0;d<c.length;d++){var i=this.renderOptions.columns[d];if(i){var l=i.type;if("DocumentProperty"===l||"ProjectProperty"===l)l+="_"+i.typeDetail;var k=this.renderMethodMap[l];k?k.call(this,a,i):h.log("Not supported table header rendering method: "+l)}}}}catch(q){h.log("Problem in DocTableXView.renderTableHeader:\n"+q)}};d.prototype.repaintTableHeader=function(){var d=n("#"+this.phElemID+"_mainTable");
this.renderTableHeader(d)};d.prototype.renderExpandCollapseButtonHeader=function(d){var b=this.dm.getThisInDOM()+".expandCollapseAllClicked(this);return false;",b='<th class="docrefexpandcol td-narrow">'+('<i class="icon icon-normal activIcon icon-WCR_Plus-square12 expandAll" onclick="'+b+'"/>')+('<i class="icon icon-normal activIcon icon-WCR_Minus-square12 collapseAll" onclick="'+b+'"/>'),b=b+"</th>";d.append(b)};d.prototype.renderSortingArrowsHeader=function(d){this.dm.isEditable&&d.append('<th class="docrefsortcol td-narrow"></th>')};
d.prototype.renderSequenceNumberHeader=function(d,b){var a='<th class="docrefsortcol">'+k.xmlencode(b.label)+"</th>";d.append(a)};d.prototype.renderRowSelectorHeader=function(d){var b='<th class="docrefselectcol td-narrow">',a=this.dm.getThisInDOM()+".onSelectAllRowsClicked(this);",b=b+('<input type="checkbox" id="'+this.phElemID+'_allRowsSelector" onclick="'+a+'"');this.dm.isAllRowsSelected()&&(b+=' checked="checked"');b+="></th>";b=n(b);this.showDocActions&&null==h.getRenderItem(this.renderOptions.columns,
"DocumentName")&&(a=n("<a>",{"class":"action","data-name":"DocActionsDownload","data-icon":"icon icon-WCR_Actions-Download12","data-require-selection-min":"1"}),a.on("click",function(){this.dm.downloadActionClicked()}.bind(this)),a.text(i.t("DocActionsDownload")),this.dm.addExtraAction(a));d.append(b)};d.prototype.renderThumbnailHeader=function(d,b){if(this.renderOptions.showThumbnails){var a='<th class="docrefthumbcol td-narrow">'+h.getEncodedTranslatedLabel(b.label)+"</th>";d.append(a)}};d.prototype.renderDocumentSpecHeader=
function(d,b){var a=n('<th class="docrefdoccol">'+h.getEncodedTranslatedLabel(b.label)+"</th>");if(this.showDocActions){var c=n("<a>",{"class":"action","data-name":"DocActionsDownload","data-icon":"icon icon-WCR_Actions-Download12","data-require-selection-min":"1"});c.on("click",function(){this.dm.downloadActionClicked()}.bind(this));c.text(i.t("DocActionsDownload"));this.dm.addExtraAction(c)}d.append(a)};d.prototype.renderDocumentActionsHeader=function(d,b){var a='<th class="docrefactionscol td-narrow">'+
h.getEncodedTranslatedLabel(b.label)+"</th>";d.append(a)};d.prototype.renderDocumentDescriptionHeader=function(d,b){var a='<th class="docrefdoccol">'+h.getEncodedTranslatedLabel(b.label)+"</th>";d.append(a)};d.prototype.renderApprovalStatusHeader=function(d,b){var a='<th class="docrefApprovalStatus td-status">'+h.getEncodedTranslatedLabel(b.label)+"</th>";d.append(a)};d.prototype.renderApprovalStageHeader=function(d,b){var a='<th class="docrefdoccol">'+h.getEncodedTranslatedLabel(b.label)+"</th>";
d.append(a)};d.prototype.renderDocProjectNameHeader=function(d,b){var a='<th class="docrefdoccol">'+h.getEncodedTranslatedLabel(b.label)+"</th>";d.append(a)};d.prototype.renderProjectNameHeader=function(d,b){this.renderDocProjectNameHeader(d,b)};d.prototype.renderProjectStatusHeader=function(d,b){this.renderDocProjectNameHeader(d,b)};d.prototype.renderProjectDueDateHeader=function(d,b){this.renderDocProjectNameHeader(d,b)};d.prototype.renderProjectAttributeHeader=function(d,b){this.renderDocAttributeHeader(d,
b)};d.prototype.renderDocumentVersionHeader=function(d,b){var a='<th class="docrefversioncol td-centered">'+h.getEncodedTranslatedLabel(b.label)+"</th>";d.append(a)};d.prototype.renderDocumentAuthorHeader=function(d,b){var a='<th class="docrefdoccol">'+h.getEncodedTranslatedLabel(b.label)+"</th>";d.append(a)};d.prototype.renderDocumentModifiedDateHeader=function(d,b){var a='<th class="docrefdoccol">'+h.getEncodedTranslatedLabel(b.label)+"</th>";d.append(a)};d.prototype.renderLocalRemoteButtonHeader=
function(d){this.dm.isEditable&&d.append('<th class="docrefsortcol td-narrow"></th>')};d.prototype.renderReplaceButtonHeader=function(d){this.dm.isEditable&&d.append('<th class="docrefreplacecol td-narrow"></th>')};d.prototype.renderCloneButtonHeader=function(d){this.dm.isEditable&&d.append('<th class="docrefclonecol td-narrow"></th>')};d.prototype.renderDeleteButtonHeader=function(d){this.dm.isEditable&&d.append('<th class="docrefremovecol td-narrow"></th>')};d.prototype.renderReferencePropertyHeader=
function(d,b){if("Hidden"!=b.visibility){var a;a='<th class="docrefdoccol">'+k.xmlencode(b.label);"Required"==b.visibility&&(a+='&nbsp;<font color="red">*</font>');d.append(a+"</th>")}};d.prototype.renderDocAttributeHeader=function(d,b){var a;a='<th class="docrefdoccol">'+k.xmlencode(b.label);"Required"==b.visibility&&(a+='&nbsp;<font color="red">*</font>');d.append(a+"</th>")};return d});
define("doctablex/DocTableX","wcr/webcenter_xml doctablex/DocumentRowFactory doctablex/DocTableXView doctablex/DocTableXUtils doctablex/AJAXDataCache doctablex/StaticDocumentRow doctablex/DocumentRow doctablex/DocumentRowSearch doctablex/DocumentRowBrowse doctablex/DocumentRowFile doctablex/DocumentRowNew doctablex/DocumentRowLink doctablex/DocumentRowCopy doctablex/DocumentRowExternalFile utils/webi18n!DocRefStrings underscore jquery wcr/search wcr/extpopup lib/PromisePolyfill".split(" "),function(h,
n,k,l,e,i,d,f,b,a,c,j,r,v,q,p,s){var m=function(a){if(!a)return this;this.isInConfigPreview=a.isInConfigPreview||!1;this.currentUser=a.currentUser||null;this.onChangeCallback=a.onChangeCallback||null;this.onBeforeDownloadAction=a.onBeforeDownloadAction||null;this.pageActionForm=a.pageActionForm;this.pageActionForm||(this.pageActionForm=document.actionform);this.isModifiedElsewhere=!1;this.docRows=[];this._rowCreationIdx=0;this.keepCloneFileInfoMap={};this.isChanged=!1;this.parentDocVerIDs=a.parentDocVerIDs||
[];this._parentDocRow=a.parentDocRow||null;this.phElemID=a.phElemID;this.saveXMLRootTag="dtval";a.saveXMLRootTag&&(this.saveXMLRootTag=h.xmlencode(a.saveXMLRootTag));this.thisInDOM="document.getElementById('"+this.phElemID+"').docTable";this._extraActions=[];this.greenLinksPrefix;this._setPrefix(a.prefix);this.dshObj=a.dshObj;if(!this.dshObj)return alert("Document table cannot be created without DocumentSourceHandler reference!"),null;this.isEditable=a.isEditable||!1;this.currentUser&&!1==this.currentUser.canEditAttributes&&
(this.isEditable=!1);this.isInactive=a.isInactive||!1;this.isInjectedValue=a.isInjectedValue||!1;this.parentACatNotExpandedYet=a.parentACatNotExpandedYet||!1;this.autoExpandAllRows=a.autoExpandAllRows||!1;this.clearValues=a.clearValues||!1;this.allowMultiple=a.allowMultiple||!1;this.docReferenceMode=a.docReferenceMode||0;this.projectID=a.projectID||null;this.taskID=a.taskID||null;this.canUserAddDocuments=this.hasDocumentTemplates=this.isInConfigPreview;this.aCatView=a.aCatView;this.projectCreationContext=
a.projectCreationContext||!1;this.replaceDocRowAdded=!1;this.targetFolders=a.targetFolders||null;var b={renderMethod:"list",showGreenLinksOnTop:!0,showGreenLinksAtBottom:!1,showThumbnails:!0};this.renderOptions=a.renderOptions||b;void 0===this.renderOptions.showThumbnails&&(this.showThumbnails=!0);this.propsACatID=a.propsACatID||null;this.defTaskDocAttrCatID=a.defTaskDocAttrCatID||"";this.defTaskDocFolderName=a.defTaskDocFolderName||null;this._docRowsInsertedPromiseResolve;this._docRowsInsertedPromiseReject;
this.docRowsInsertedPromise=new Promise(function(a,b){this._docRowsInsertedPromiseResolve=a;this._docRowsInsertedPromiseReject=b}.bind(this));this.constructor==m.prototype.constructor&&(this.view=new k(this,this.phElemID,this.renderOptions),this._initializeFromServer());return this};m.prototype.dataLoadingFinished=function(){this._docRowsInsertedPromiseResolve();return this.docRowsInsertedPromise};m.prototype.dataLoadingFailed=function(){this._docRowsInsertedPromiseReject();return this.docRowsInsertedPromise};
m.prototype._initializeFromServer=function(){if(!this.isInConfigPreview)if(this.projectID){var a=e.getInstance().getDocTemplatesByProjID(this.projectID,!0),b=e.getInstance().getFoldersByProjID(this.projectID);s.when(a,b).done(function(a,b){var c=this.hasDocumentTemplates,g=this.canUserAddDocuments;this.hasDocumentTemplates=!!a&&0<a.length;this.canUserAddDocuments=!!b&&0<b.length;if(this.hasDocumentTemplates!=c||this.canUserAddDocuments!=g)this.view.updateActions(),this.canUserAddDocuments!=g&&this.view.repaintRemoteDocRows()}.bind(this)).fail(function(a){alert("Failed to load data needed to initialize DocTableX instance from the server.\n"+
a)})}else this.hasDocumentTemplates=!1,this.canUserAddDocuments=!0};m.prototype.getNextRowCreationIndex=function(){return this._rowCreationIdx++};m.prototype.setIsChanged=function(){if(this.onChangeCallback)this.onChangeCallback();this.isChanged=!0};m.prototype.getIsChanged=function(){if(this.isChanged)return!0;for(var a=0;a<this.docRows.length;a++){var b=this.docRows[a];if(b&&b.getIsChanged())return!0}return!1};m.prototype._setPrefix=function(a){a||(a="");this.prefix=a;this.greenLinksPrefix=a+"_greenLinks"};
m.prototype.getTablePrefix=function(){return this.prefix};m.prototype.getThisInDOM=function(){return this.thisInDOM};m.prototype.isBlankProjectCreationContext=function(){return this.projectCreationContext&&!this.projectID};m.prototype.isProjectCreationContext=function(){return this.projectCreationContext};m.prototype.getAllDocumentsIDs=function(){for(var a=[],b=0;b<this.docRows.length;b++){var c=this.docRows[b];c&&c.docID&&a.push(c.docID)}return a};m.prototype.getRowByID=function(a){for(var b=0;b<
this.docRows.length;b++){var c=this.docRows[b];if(c.rowID==a)return c}return null};m.prototype.getRowByIDRecursive=function(a,b){if(!(b&&0<b.length))for(var c=0;c<this.docRows.length;c++){var d=this.docRows[c];if(d)if(d.rowID==a){b.push(d);break}else d.aCatObj&&d.aCatObj.executeOnAllDocReferences(function(c){c.getRowByIDRecursive(a,b)},this)}};m.prototype.getRowsCopiedFromRowsRecursive=function(a,b){if(a&&b)for(var c=0;c<this.docRows.length;c++){var d=this.docRows[c];d&&(p.each(a,function(a){a.rowID==
d.copyOfExistingRowID&&-1==b.indexOf(a)&&b.push(d)}),d.aCatObj&&d.aCatObj.executeOnAllDocReferences(function(c){c.getRowsCopiedFromRowsRecursive(a,b)},this))}};m.prototype.getAllRowsClonedFrom=function(a){for(var b=[],c=0;c<this.docRows.length;c++){var d=this.docRows[c];d&&(d.clonedFrom&&d.clonedFrom.rowID==a.rowID)&&b.push(d)}return b};m.prototype.getDocumentSourceOptions=function(a){return{docTable:this,linksId:a,hasDocumentTemplates:this.hasDocumentTemplates,canUserAddDocuments:this.canUserAddDocuments,
blankProjectCreationContext:this.isBlankProjectCreationContext()}};m.prototype.addExtraAction=function(a){for(var b=a.attr("data-name"),c=[],d=0;d<this._extraActions.length;d++)c.push(this._extraActions[d].attr("data-name"));0>s.inArray(b,c)&&(this._extraActions.push(a),this.view.updateActions())};m.prototype.getExtraActions=function(){return this._extraActions};m.prototype.hasLocalRemoteButton=function(){return null!=l.getRenderItem(this.renderOptions.columns,"LocalRemote")};m.prototype.reset=function(a){if(a)for(var b=
0;b<this.docRows.length;b++)this.docRows[b].deleteItself();this.docRows=[];this.parentDocVerIDs=[];this.keepCloneFileInfoMap={};this._extraActions=[];a?this.setIsChanged():this.isChanged=!1};m.prototype.setCustomView=function(a,b){a&&(a.dm=this,a.phElemID||(a.phElemID=this.phElemID),a.renderOptions||(a.renderOptions=this.renderOptions),this.view=a,b&&this.displayTable())};m.prototype.setIsEditable=function(a,b){if(void 0!==a&&a!=this.isEditable){this.isEditable=a;for(var c=0;c<this.docRows.length;c++)this.docRows[c].setIsEditable(a)}b&&
this.displayTable()};m.prototype.getParentDocRow=function(){return this._parentDocRow};m.prototype.getParentDocTable=function(){return this.getParentDocRow()?this.getParentDocRow().getParentDocTable():null};m.prototype.isRootLevelTable=function(){return!this.getParentDocTable()};m.prototype.getRootLevelTable=function(){for(var a=this;a&&a.getParentDocTable();)a=a.getParentDocTable();return a};m.prototype.getRootLevelPrefix=function(){var a=this.getRootLevelTable();return a?a.prefix:""};m.prototype.setIsInactive=
function(a){void 0!==a&&a!=this.isInactive&&(this.isInactive=a)};m.prototype.setInjectedValue=function(a){this.isInjectedValue=!!a};m.prototype.isAllRowsSelected=function(){for(var a=0;a<this.docRows.length;a++)if(!this.docRows[a].isSelected)return!1;return!0};m.prototype.updateAllRowsSelector=function(){s("#"+this.phElemID+"_allRowsSelector").prop("checked",this.isAllRowsSelected())};m.prototype.hasSameContentAs=function(a){if(this.docRows&&!a||!this.docRows&&a||this.docRows&&this.docRows.length!=
a.length)return!1;for(var b=0;b<this.docRows.length;b++){var c=this.docRows[b],d=a[b];if(c&&!d||!c&&d||c&&c.docVerID!=d.docVerID)return!1;var e=c.props?c.props:[];if(e.length!=(d.props?d.props:[]).length)return!1;for(var f=0;f<e.length;f++){var h=e[f];if(h&&h.id){var i=d.findPropertyByID(h.id);if(!i)return!1;if(c.propsACatObj&&c.propsACatObj.loaded){if((h=c.propsACatObj.findAttribute(h.id,h.name))&&h.value!=i.value)return!1}else if(h.value!=i.value)return!1}}}return!0};m.prototype.copyDocumentRowsTo=
function(a,b){for(var c=[],d=0;d<this.docRows.length;d++)c.push(this.docRows[d].duplicateItselfTo(a));return Promise.all(c).then(function(){b&&a.displayTable()}.bind(this))};m.prototype.initWithDocRows=function(a,b){if(!a)return!1;for(var c=0;c<a.length;c++){var d=a[c];if(d){if(this!==d.getParentDocTable())return!1;this.isDocDependentOnItself(d)&&d.setDependsOnItself(!0);this.docRows.push(d)}}b&&this.displayTable();return!0};m.prototype._insertRow=function(a,b,c,d){this.isDocDependentOnItself(a)&&
a.setDependsOnItself(!0);var e=!0;if(this.allowMoreToAdd()||d)null!=b&&b<this.getNumberOfRows()?(0>b&&(b=0),this.docRows.splice(b,0,a)):this.docRows.push(a);else if(confirm(q.t("DocTableReplaceSingleValueQ"))){for(d=this.docRows.length;0<d;)d--,this.deleteDocumentRow(d);e=this._insertRow(a,b,!1)}else e=!1;c&&this.displayTable();return e};m.prototype.appendDocRow=function(a,b,c){a.parentDocTable=this;this.targetFolders&&(a.targetFolders=this.targetFolders);this.autoExpandAllRows&&(a.aCatExpanded=!0);
return n.createDocumentRow(b,a).then(function(a){return this._insertRow(a,null,c,!0)}.bind(this))};m.prototype.appendStaticDocRow=function(a,b){return this.appendDocRow(a,i,b)};m.prototype.addDocRow=function(a,b,c,d,e){a.parentDocTable=this;this.targetFolders&&(a.targetFolders=this.targetFolders);return n.createDocumentRow(b,a).then(function(a){if(d&&this.isDocDependentOnItself(a)&&!confirm(q.t("DocTableCycleDependencyWarning")))return a&&a.destroy(!0),null;e||(e=0);if(this._insertRow(a,e,c))return a;
a&&a.destroy(!0);return null}.bind(this))};m.prototype.addCloneRowAction=function(a){this.addCloneRow(this.docRows[a],a)};m.prototype.addCloneRow=function(a,b){a.updatePropertyValues();return this.createDocRowObj(a,"Clone").then(function(a){void 0!==b&&null!==b?0>b?b=0:b++:b=null;this._insertRow(a,b,!0)&&this.setIsChanged()}.bind(this))};m.prototype.getClonedDocName=function(a){if(a=a.docName){var b=this.keepCloneFileInfoMap[a],b=b?b+1:1;this.keepCloneFileInfoMap[a]=b;var c=0>a.indexOf(".")?"":a.slice(a.lastIndexOf(".")+
1),a=(0>a.indexOf(".")?a:a.slice(0,a.lastIndexOf(".")))+"-Duplicate-"+b+"."+c}return a};m.prototype.addDocRows=function(a,b,c){for(var d=!1,e=[],f=0;f<a.length;f++)e.push(this.addDocRow(a[f],b,f==a.length-1,c,f).then(function(a){a&&(d=!0)}.bind(this)));return Promise.all(e).then(function(){d&&c&&this.setIsChanged()}.bind(this))};m.prototype.addSearchDocRows=function(a,b){return this.addDocRows(a,f,b)};m.prototype.addBrowseRow=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),
targetFolderName:a.targetFolder,allowedFileExts:l._getFileExtensionsList(a.documentType),docTempType:a.docTemplateType,docTempNames:l._getDocTemplateNameList(a.docTemplateName),defaultTargetFolderName:a.targetFolderOriginal};return this.addDocRow(a,b,!0,!0).then(function(a){a&&this.setIsChanged()}.bind(this))};m.prototype.addFileRow=function(b,c,d){b={file:c,parentDocTable:this,dlsName:b.label.getLabel(),targetFolderName:b.targetFolder,allowedFileExts:l._getFileExtensionsList(b.documentType),docTempType:b.docTemplateType,
docTempNames:l._getDocTemplateNameList(b.docTemplateName),defaultTargetFolderName:b.targetFolderOriginal};return this.addDocRow(b,a,!1!==d,!0).then(function(a){a&&this.setIsChanged()}.bind(this))};m.prototype.addExternalFileRow=function(a,b){var c=a.dlsObj,c={parentDocTable:this,dlsName:c.label.getLabel(),targetFolderName:c.targetFolder,allowedFileExts:l._getFileExtensionsList(c.documentType),docTempType:c.docTemplateType,docTempNames:l._getDocTemplateNameList(c.docTemplateName),DAM:b.DAM,DAMJS:b.DAMJS,
DAMData:c.DAMMetadata,docName:b.docName,docDesc:b.docDesc,externalId:b.externalId,thumbnailURL:b.thumbnailUrl,externalDocumentMetadata:b.documentMetadata,defaultTargetFolderName:c.targetFolderOriginal};return this.addDocRow(c,v,!0,!0).then(function(a){a&&this.setIsChanged()}.bind(this))};m.prototype.addCopyRow=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),docOperation:a.operation,targetFolderName:a.targetFolder,docTempType:a.docTemplateType,docTempNames:l._getDocTemplateNameList(a.docTemplateName),
defaultTargetFolderName:a.targetFolderOriginal};return this.addDocRow(a,r,!0,!0).then(function(a){a&&this.setIsChanged()}.bind(this))};m.prototype.addLinkRow=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),docOperation:a.operation,defaultTargetFolderName:a.targetFolderOriginal};return this.addDocRow(a,j,!0,!0).then(function(a){a&&this.setIsChanged()}.bind(this))};m.prototype.addDocTemplateRow=function(a){a&&(this.replaceDocRowAdded?this.displayTable():this._insertRow(a,0,
!0)&&this.setIsChanged())};m.prototype.openDocTemplateDialog=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),targetFolderName:a.targetFolder,docTempType:a.docTemplateType,docTempNames:l._getDocTemplateNameList(a.docTemplateName),defaultTargetFolderName:a.targetFolderOriginal,targetFolders:this.targetFolders};return n.createDocumentRow(c,a)};m.prototype.getDocTemplateNameList=function(a){return l._getDocTemplateNameList(a)};m.prototype.isDocDependentOnItself=function(a){var b=
this.parentDocVerIDs;return a.docVerID&&b&&-1!=b.indexOf(a.docVerID)};m.prototype.getNumberOfRows=function(){return this.docRows.length};m.prototype.allowMoreToAdd=function(){return this.allowMultiple||1>this.getNumberOfRows()};m.prototype.displayTable=function(){this.isModifiedElsewhere&&this.setIsEditable(!1,!1);var a=this.view.render();a&&1==a.length&&(a[0].docTable=this)};m.prototype.convertToXML=function(){var a="";try{a+="<"+this.saveXMLRootTag+">";if(!this.isInjectedValue&&(!this.isModifiedElsewhere&&
!this.isEditable||this.isModifiedElsewhere&&!this.storedState.isEditable))a+=h.ElementEncode("readonly","1");for(var b=0;b<this.docRows.length;b++)a+=this.docRows[b].convertToXML();a+="</"+this.saveXMLRootTag+">"}catch(c){l.log("Problem in DocTableX.convertToXML:\n"+c),a=""}return a};m.prototype.getDocumentNames=function(){for(var a="",b=0;b<this.docRows.length;b++){var c=this.docRows[b];c&&c.docName&&(a+=c.docName+" | ")}return a.slice(0,a.length-3)};m.prototype.getHyperlinks=function(){for(var a=
"",b=0;b<this.docRows.length;b++){var c=this.docRows[b];c&&(c.docVerID&&c.docName)&&(a+='<a class="'+window.webcenterConfig.jspBaseUrl+'docrefdoclink darktext_darklink_11" href="docdetails.jsp?menu_file=myprojects&amp;docVerID='+c.docVerID+'" target="_blank">'+h.xmlencode(c.docName)+"</a> | ")}return a.slice(0,a.length-3)};m.prototype.validateDocTable=function(a,b){if(!this.isInactive&&!this.isModifiedElsewhere)for(var c=0;c<this.docRows.length;c++)this.docRows[c].validateDocRow(a,b)};m.prototype.onSubmit=
function(){s("form").each(function(a,b){if(0===s(b).find(".forceSubmit").length){s(b).append('<input type="submit" class="forceSubmit displayNone" />');var c=b.submit;b.submit=function(){b.submit=c;s(b).find(".forceSubmit").click()}}});this.clearValues&&(this.docRows=[]);if(!this.isInactive||this.clearValues){var a=this.getTablePrefix(),a=s("#"+a);if(0<a.length){var b=this.convertToXML();a.val(b)}}if(!this.isInactive)for(a=0;a<this.docRows.length;a++)this.docRows[a]._onSubmit()};m.prototype.localRemoteButtonClicked=
function(a,b,c,d,e){if(!(0>a)){var f=this.docRows[a];f.deleteItself(!0);f.origDocRow?(this.docRows[a]=f.origDocRow,this.docRows[a].displayRow()):this.createDocRowObj(f,c,d,e,b).then(function(b){this.docRows[a]=b;this.setIsChanged();this.docRows[a].displayRow()}.bind(this))}};m.prototype.createDocRowObj=function(a,d,e,h,i){var l=null,k={parentDocTable:this,docVerID:a.docVerID,docID:a.docID,targetFolderName:a.targetFolderName,projectID:this.projectID,docTempType:a.docTemplateType,docTempNames:a.docTemplateName,
operation:d,properties:a.props,origDocRow:a,flowType:i,targetFolders:this.targetFolders};h?(h.parentDocTable=this,h.dlsName=q.t("DocRowReplaceSearchAction"),h.origDocRow=a,h.properties=a.props,this.targetFolders&&(h.targetFolders=this.targetFolders),l=n.createDocumentRow(f,h)):"LocalRemote"==i?(k.dlsName=q.t("DocRowMakeLocalAction"),k.docName=a.docName,k.operation="Copy",l=n.createDocumentRow(f,k)):"Upload"==d?(k.dlsName=q.t("DocRowReplaceUploadAction"),l=n.createDocumentRow(b,k)):"Reference"==d||
"LinkToTask"==d?(k.dlsName=q.t("DocRowReplaceLinkAction"),l=n.createDocumentRow(j,k)):"Copy"==d?(k.dlsName=q.t("DocRowReplaceNewAction"),k.docTempNames=e,l=n.createDocumentRow(c,k),this.replaceDocRowAdded=!0):"Clone"==d&&(k.dlsName=q.t("DocRowCloneAction"),k.docName=a.docName,k.drID=null,k.origDocRow=null,k.clonedFrom=a,k.operation="Copy","New"===a.docOperation&&a.selDocTemplate&&(k.docVerID=a.selDocTemplate.docVerID,k.docTypeID=a.selDocTemplate.docTypeID,k.docName=a.selDocTemplate.name,k.selDocName=
null),l=n.createDocumentRow(f,k));return l};m.prototype.deleteButtonClicked=function(a){this.deleteDocumentRow(a)};m.prototype.deleteDocumentRow=function(a){if(!(0>a))if(this.docRows[a].deleteItself(),this.docRows.splice(a,1),this.setIsChanged(),0<this.getNumberOfRows())for(a=0>a-1?0:a-1;a<this.getNumberOfRows();a++)this.docRows[a].view.repaintRow();else this.displayTable()};m.prototype.moveUpButtonClicked=function(a){if(0<a){var b=this.docRows[a-1];this.docRows[a-1]=this.docRows[a];this.docRows[a]=
b;this.docRows[a].swapWith(this.docRows[a-1]);this.setIsChanged()}};m.prototype.moveDownButtonClicked=function(a){if(a<this.getNumberOfRows()-1){var b=this.docRows[a+1];this.docRows[a+1]=this.docRows[a];this.docRows[a]=b;this.docRows[a+1].swapWith(this.docRows[a]);this.setIsChanged()}};m.prototype.expandCollapseAllClicked=function(a){a=s(a);a.hasClass("expandAll")?this.expandAllRows():a.hasClass("collapseAll")&&this.collapseAllRows()};m.prototype.expandAllRows=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].showDocAttributeCategory(!1,
!0)};m.prototype.collapseAllRows=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].collapseAllDescendants()};m.prototype.onSelectAllRowsClicked=function(a){this.setSelectAllRows(a&&a.checked)};m.prototype.setSelectAllRows=function(a){for(var b=0;b<this.docRows.length;b++)this.docRows[b].selectAllDescendants(a);this.updateAllRowsSelector()};m.prototype.downloadActionClicked=function(){var a=this.validateDocDownloadAction();if(0<a.rowsToDownload.length){if(!a.lockedDocFound||confirm(q.t("DocTableLockedDocDownloadWarning"))){if(0<
a.noPermDocNames.length){var b=q.t("DocTableNoDownloadPermInfo")+":\n";alert(b+a.noPermDocNames.join("\n"))}a=s("#"+this.phElemID).closest("form");if(0<a.length){b=a.find('input[name="actionVal"]');0==b.length&&(b=s('<input type="hidden" name="actionVal"/>'),a.append(b));b.val("DocTableXDownloadDocuments");b=a.find('input[name="rootPrefixVal"]');0==b.length&&(b=s('<input type="hidden" name="rootPrefixVal"/>'),a.append(b));b.val(this.getTablePrefix());if(this.onBeforeDownloadAction)this.onBeforeDownloadAction();
this.pageActionForm.submit()}else window.alert("The corresponding form is not defined / cannot be found!")}}else 0<a.noPermDocNames.length?alert(q.t("DocTableNoDownloadPermError")):alert(q.t("DocTableSelectDoc"))};m.prototype.validateDocDownloadAction=function(a){a||(a={rowsToDownload:[],lockedDocFound:!1,noPermDocNames:[]});for(var b=0;b<this.docRows.length;b++)this.docRows[b].validateDocToDownload(a);return a};m.prototype.destroy=function(a){for(var b=0;b<this.docRows.length;b++)this.docRows[b].destroy(a);
this._extraActions=[]};m.prototype.reconstruct=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].reconstruct()};m.prototype.replaceRowWithNewStaticRow=function(a,b){var c=a.getIndexInTable();return this.addDocRow(b,i,!1,!1,c).then(function(b){this.allowMultiple&&this.deleteDocumentRow(a.getIndexInTable());return b}.bind(this))};m.prototype.processReplaceRequest=function(a,b){try{for(var c=this.dshObj.docSources.length,d=0;d<c;d++){var e=this.dshObj.docSources[d];if(e&&a.operation===
e.operation&&a.sourceType===e.sourceType){var f=e.sourceType;if("Browse"===f){this.renderReplaceContent(e.operation,null,null,b);break}else if("CurrentProject"===f){this.renderReplaceContent(e.operation,null,null,b);break}else if("DocumentTemplates"===f){this.renderReplaceContent(e.operation,e.docTemplateName,null,b);break}else if("SavedSearch"===f){this.renderReplaceContent(e.operation,null,e,b);break}else l.log("Unknown Source Type ("+f+")")}}}catch(h){alert("Problem in DocTableX.processReplaceRequest at line "+
h.lineNumber+" : "+h.message)}};m.prototype.renderReplaceContent=function(a,b,c,d){c?this.dshObj.loadSavedSearchDialog({dlsObj:c,docTableObj:this},"DocReference",!0,d):this.localRemoteButtonClicked(d,"Replace",a,b)};m.prototype.getDocSrcLinks=function(){var a=[],b=!0,c=this.getDocumentSourceOptions(this.greenLinksPrefix);!1===c.canUserAddDocuments&&(b=!1);for(var d=this.dshObj.docSources,e=0;e<d.length;e++){var f=!0,h=d[e];if(h){"DocumentTemplates"==h.sourceType&&!1===c.hasDocumentTemplates&&(f=!1);
"CurrentProject"==h.sourceType&&!0===c.blankProjectCreationContext&&(f=!1);if(b)"SavedSearch"==h.sourceType&&h.origOperations&&(h.operation=h.origOperations,h.origOperations=null);else switch(h.sourceType){case "Browse":case "DocumentTemplates":case "ProjectFolder":f=!1;break;case "SavedSearch":-1==h.operation.indexOf("Reference")?f=!1:(h.origOperations||(h.origOperations=h.operation),h.operation="Reference")}f&&a.push(h)}}return a};m.prototype.checkIfPasswordRequired=function(){return!1};m.prototype.modifiedElsewhere=
function(a){this.isModifiedElsewhere||(this.isModifiedElsewhere=!0,this.storedState={isEditable:this.isEditable},!1!=this.isEditable&&this.setIsEditable(!1,a))};m.prototype.updateTargetProject=function(a){this.projectID=a;this._initializeFromServer()};m.prototype.updateTargetFolders=function(){s.when(e.getInstance().getFoldersByProjID(this.projectID)).done(function(a){for(var b=0;b<this.docRows.length;b++)this.docRows[b].updateTargetFolders(a,!0),this.docRows[b].selTargetFolder=null;this.view.repaintDocRows()}.bind(this)).fail(function(a){this.setStatus("error");
alert("Problem with retrieving project folders:\n"+a)}.bind(this))};m.prototype.updateSelectedTargetFolder=function(a){for(var b=0;b<this.docRows.length;b++){var c=this.docRows[b];"undefined"===typeof a?c.setTargetFolderByName(c.defaultTargetFolderName):""===a?c.setSelectedTargetFolder(null,!1):c.setTargetFolderByName(a,!1)}this.view.repaintDocRows()};m.prototype.updateDefaultTargetFolder=function(a){for(var b=0;b<this.dshObj.docSources.length;b++){var c=this.dshObj.docSources[b];"undefined"===typeof a&&
(c.targetFolder=c.targetFolderOriginal);c.targetFolder=a}};return m});