/**
		 * Check licenses for barcode and braille
		 * @returns {$.Deferred.<Boolean, Boolean>} Two parameters where the first one if true indicates has barcode license 
		 *                                          and second one if true indicates has braille license
		 */

/**
		 * Get the ServerInfo flags (can be used for checking licenses)
		 * @return {$.Deferred.<Number>} Flags number. 0 if something went wrong.
		 */

define("web-viewer/measure/Ruler","web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/utils/DrawUtils web-viewer/measure/MeasureConstants underscore".split(" "),function(c,b,d,f,i,g){var a=function(b){this.f=b;this.rulerType=1;this.endPoint=this.startPoint=null};a.prototype.reset=function(){this.endPoint=this.startPoint=null};a.prototype.snapToClosestAngle=function(b){if(0===this.rulerType){var e=this.getLength(),a=f.closestAngle(this.getAngle(),
8);b?(this.startPoint.x=this.endPoint.x-e*Math.cos(a*Math.PI/180),this.startPoint.y=this.endPoint.y-e*Math.sin(a*Math.PI/180)):(this.endPoint.x=e*Math.cos(a*Math.PI/180)+this.startPoint.x,this.endPoint.y=e*Math.sin(a*Math.PI/180)+this.startPoint.y)}};a.prototype.getLength=function(){if(this.endPoint&&this.startPoint){var b=Math.abs(this.endPoint.x-this.startPoint.x),e=Math.abs(this.endPoint.y-this.startPoint.y);return Math.sqrt(b*b+e*e)}return 0};a.prototype.getAngle=function(){return 180*Math.atan2(this.endPoint.y-
this.startPoint.y,this.endPoint.x-this.startPoint.x)/Math.PI};a.prototype.getLinework=function(){return this.endPoint&&this.startPoint?0===this.rulerType?this.getRulerLinework():this.getSquareLinework():[]};a.prototype.getSquareLinework=function(){var a=[];if(this.startPoint&&this.endPoint){var e=new c;e.fillcolor="rgba(0, 0, 0, 0.30)";e.color="rgba(0, 0, 0, 1.00)";e.linewidth=1;e.type=i.LWTYPE_RECT;var j=new b;j.makeMoveTo(this.startPoint.x,this.startPoint.y);e.pointArray[0]=j;j=new b;j.makeLineTo(this.endPoint.x,
this.endPoint.y);e.pointArray[1]=j;e.rect=new d.Rect(this.startPoint,this.startPoint.sizeTo(this.endPoint));a.push(e);e=new c;e.fillcolor="rgba(0, 0, 0, 0.0)";e.color="rgba(220, 220, 220, 0.9)";e.linewidth=1;e.type=i.LWTYPE_DASHEDBOX;e.dash=[4,3];j=new b;j.makeMoveTo(this.startPoint.x,this.startPoint.y);e.pointArray[0]=j;j=new b;j.makeLineTo(this.endPoint.x,this.endPoint.y);e.pointArray[1]=j;e.rect=new d.Rect(this.startPoint,this.startPoint.sizeTo(this.endPoint));a.push(e)}return a};a.prototype.getRulerLinework=
function(){var a="black";this.f&&(a=this.f.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"));if(this.startPoint&&this.endPoint)return this._cachedRulerLinework&&this._cachedRulerLinework.startPoint.equals(this.startPoint)&&this._cachedRulerLinework.endPoint.equals(this.endPoint)&&this._cachedRulerLinework.color==a?this._cachedRulerLinework.linework:this.generateRulerLinework(this.startPoint,this.endPoint,a)};a.prototype.generateRulerLinework=function(a,e,j){var d=[],l=new b;l.makeMoveTo(a.x,
a.y);var n=new b;n.makeLineTo(e.x,e.y);var p=new c;p.pointArray.push(l);p.pointArray.push(n);p.color="white";p.type=i.LWTYPE_LINE;d.push(p);p=new c;p.pointArray.push(l);p.pointArray.push(n);p.color=j;p.dash=[10,10];p.type=i.LWTYPE_LINE;d.push(p);l=this.getCursor(a);n=this.getCursor(e);d.push(l);d.push(n);this._cachedRulerLinework={startPoint:a.copy(),endPoint:e.copy(),color:j,linework:d};return d};a.prototype.getCursor=function(a){var e=new c;e.type=i.LWTYPE_IMAGE;e.linewidth=1;e.imageRef=g.RulerPoint.DEFAULT;
e.staticsize=!0;e.setRect(new d.Rect(new d.Point(a.x,a.y)));e.imageOffset=new d.Size(g.RulerPoint.OFFSET.width,g.RulerPoint.OFFSET.height);return e};return a});
define("web-viewer/utils/SnapIndicator",["web-viewer/utils/LineworkWrapper","web-viewer/utils/DrawUtils","utils/ShapeUtils"],function(c,b,d){var f=new d.Size(7,7),i=function(d){c.call(this);this.type=b.LWTYPE_IMAGE;this.linewidth=0;this.imageRef="/wcr-static/web-viewer/layout/img/crosshair.png";this.staticsize=!0;this.imageOffset=f;d&&this.setCenter(d)};i.prototype=Object.create(c.prototype);i.prototype.constructor=i;i.prototype.setCenter=function(b){this.setRect(new d.Rect(new d.Point(b.x,b.y)))};
return i});
define("tpl!web-viewer/measure/RulerPopoverTemplate",function(){return function(c){var b,d;d="<table>\r\n";c.showXY&&(d+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(b=c.i18n("InfoX"))?"":_.escape(b))+'</strong></td>\r\n\t\t<td align="right">'+(null==(b=c.x)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(b=c.i18n("InfoY"))?"":_.escape(b))+'</strong></td>\r\n\t\t<td align="right">'+(null==(b=c.y)?"":_.escape(b))+" "+(null==(b=
c.i18n(c.unitsloc))?"":_.escape(b))+"</td>\r\n\t</tr>\r\n");d+="\r\n";c.showDA&&(d+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(b=c.i18n("InfoDist"))?"":_.escape(b))+'</strong></td>\r\n\t\t<td align="right">'+(null==(b=c.distance)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(b=c.i18n("InfoAngle"))?"":_.escape(b))+'</strong></td>\r\n\t\t<td align="right">'+(null==(b=c.angle)?"":_.escape(b))+"&#176;</td>\r\n\t</tr>\r\n");d+=
"\r\n";c.showWH&&(d+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(b=c.i18n("InfoWidth"))?"":_.escape(b))+'</strong></td>\r\n\t\t<td align="right">'+(null==(b=c.width)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(b=c.i18n("InfoHeight"))?"":_.escape(b))+'</strong></td>\r\n\t\t<td align="right">'+(null==(b=c.height)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"</td>\r\n\t</tr>\r\n");d+="\r\n\r\n</table>\r\n";
c.createAnnotation&&(d+='\r\n    <a class="addAnnotation">\r\n        <i class="icon-WCR_Annotation-Arrow12"></i>\r\n        <span>'+(null==(b=c.i18n("AnnFromReadout"))?"":_.escape(b))+"</span>\r\n    </a>\r\n");return d+""}});
define("web-viewer/measure/RulerSnapIndicatorPopoverModel","underscore web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel utils/ShapeUtils Template tpl!web-viewer/measure/RulerPopoverTemplate web-viewer/core/CoreConstants".split(" "),function(c,b,d,f,i,g,a){var h=function(a,b,k,l){d.call(this,a,b);var n=$("<div/>");this.fix=3;this.f=a;this.snapIndicator=k;this.t=new i(a.i18n,g);a.i18n.loadBundle("viewer",c.bind(function(){this.t.render()},this));this.t.setContext(n);this.t.render();
this.getFrame=function(){return this.snapIndicator?this.snapIndicator.rect:new f.Rect};this.getContent=function(){return n};this.getRestrictBorder=function(){return 0};this.getClass=function(){return l};this.getContext=c.bind(function(){return this.f.getContext().find(".viewport")},this)};h.prototype=Object.create(d.prototype);h.prototype.constructor=h;h.prototype.setPoint=function(a){this.point=a;this.render()};h.prototype.render=function(){if(this.snapIndicator){var e=this.snapIndicator.rect.center(),
c=null,d=null;this.f.getUnits()===a.SizeUnits.PIXELS&&(d=this.f.getActivePage(),c=d.getParam("resolutionx"),d=d.getParam("resolutiony"));this.t.d.showXY=!0;this.t.d.unitsloc=this.f.getUnitsLocName();e=new f.Point(e.x,e.y);e=this._coordinates.getTransformedPoint(e);this.t.d.x=b.convertFromMmValue(e.x,this.f.getUnits(),this.f.getUnitsFix(),b.parseFloat(c));this.t.d.y=b.convertFromMmValue(e.y,this.f.getUnits(),this.f.getUnitsFix(),b.parseFloat(d));this.t.render()}};return h});
define("web-viewer/measure/MeasureLayerModel","underscore jquery web-viewer/viewport/model/ViewportLayerModel web-viewer/measure/Ruler utils/XMLUtils utils/ShapeUtils web-viewer/measure/MeasureConstants web-viewer/utils/SnapIndicator web-viewer/measure/RulerSnapIndicatorPopoverModel".split(" "),function(c,b,d,f,i,g,a,h,e){b=function(b,c){d.call(this,b,c);this.f=b;this.ruler=new f(b);this._drawType=a.MeasureDrawType.RECTANGLE;this._allowStartPointSnapping=!1;this.snapIndicator=null;this.snapIndicatorModel=
new e(b,"RulerSnapIndicatorPopover",this.snapIndicator)};b.prototype=Object.create(d.prototype);b.prototype.constructor=b;b.prototype.getLinework=function(){var a=c.clone(this.ruler.getLinework());this.snapIndicator&&a.push(this.snapIndicator);return a};b.prototype.setStartPoint=function(a,b){this.snapIndicator=null;this.ruler.startPoint=a;b&&this._allowStartPointSnapping&&this.ruler.snapToClosestAngle(!0);this.repaint();this.modelChanged()};b.prototype.setEndPoint=function(b,e){var c=this.ruler.endPoint?
this.ruler.endPoint.copy():null;this.ruler.endPoint=b;e&&this.ruler.snapToClosestAngle();if(!c||!c.equals(this.ruler.endPoint))this.repaint(),this.ruler.rulerType==a.MeasureType.Ruler&&this.calculate();this.modelChanged()};b.prototype.getStartPoint=function(){return this.ruler.startPoint};b.prototype.getEndPoint=function(){return this.ruler.endPoint};b.prototype.repaint=function(){this.modelChanged()};b.prototype.reset=function(){this.ruler.reset();this.modelChanged()};b.prototype.hidePopover=function(){this.removePopover(this.name)};
b.prototype.calculate=function(){this.ruler.endPoint&&this.ruler.startPoint&&this.ruler.rulerType==a.MeasureType.Ruler&&(this.ruler.getLength(),this.ruler.getAngle(),this.ruler.startPoint.sizeTo(this.ruler.endPoint))};b.prototype.setRulerType=function(a){this.ruler.rulerType=a;this.reset()};b.prototype.setSnapIndicatorPoint=function(a){var b=!1;a?!this._allowStartPointSnapping&&this.ruler.startPoint&&a.equals(this.ruler.startPoint)?this.snapIndicator&&(this.snapIndicator=null,b=!0):this.snapIndicator?
a.equals(this.snapIndicator.rect.center())||(this.snapIndicator.setCenter(a),b=!0):(this.snapIndicator=new h(a),b=!0):this.snapIndicator&&(this.snapIndicator=null,b=!0);b&&(b=a=!1,this.ruler&&this.snapIndicator&&(this.ruler.endPoint&&this.snapIndicator.rect.center().equals(this.ruler.endPoint)&&(a=!0),this.ruler.startPoint&&this.snapIndicator.rect.center().equals(this.ruler.startPoint)&&(b=!0)),(a=null!==this.snapIndicator&&!a&&!b)&&!this.getPopoverModel(this.snapIndicatorModel.getID())?(this.snapIndicatorModel.snapIndicator=
this.snapIndicator,this.addPopoverModel(this.snapIndicatorModel)):!a&&this.getPopoverModel(this.snapIndicatorModel.getID())&&this.removePopoverModel(this.snapIndicatorModel.getID()),this.snapIndicatorModel.render(),this.modelChanged())};b.prototype.clearSnapIndicator=function(){this.setSnapIndicatorPoint(null)};b.prototype.setAllowStartPointSnapping=function(a){this._allowStartPointSnapping=a};b.prototype.setDrawType=function(a){this._drawType=a};b.prototype.modelChanged=function(b){var e=null;!b&&
(this.ruler&&this.ruler.startPoint&&this.ruler.endPoint)&&(b=this.ruler.startPoint.sizeTo(this.ruler.endPoint),e={mode:this._drawType,w:b.width,h:b.height},this._drawType===a.MeasureDrawType.RECTANGLE?(e.x=this.ruler.startPoint.x,e.y=this.ruler.startPoint.y):this._drawType===a.MeasureDrawType.LINE&&(e.d=this.ruler.getLength(),e.a=this.ruler.getAngle()));this.f.emit("selection.changed",e);d.prototype.modelChanged.call(this)};return b});
define("tpl!web-viewer/measure/MeasurePopoverTemplate",function(){return function(c){var b,d="",d=d+"<ul>\r\n\t";_.each(c.channels,function(c){c&&(d+='\r\n\t\t<li><span class="colorBlock" style="background-color: #'+(null==(b=c.getHexRGB())?"":_.escape(b))+';"></span><span>'+(null==(b=c.value)?"":_.escape(b))+"</span></li>\r\n\t")});d+="\r\n</ul>\r\n";c.makeTotalCount&&(d+='\r\n<ul>\r\n\t<li><div style="text-align:right">'+(null==(b=c.totalCount)?"":_.escape(b))+"</div></li>\r\n</ul>\r\n");return d+=
'\r\n<ul>\r\n\t<li class="addAnnotation"><a><i class="icon-WCR_Annotation-Rect12"></i><span>'+(null==(b=c.i18n("AnnFromReadout"))?"":_.escape(b))+"</span></a></li>\r\n</ul>"}});
define("web-viewer/measure/MeasurePopoverModel","web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel tpl!web-viewer/measure/MeasurePopoverTemplate Template underscore jquery".split(" "),function(c,b,d,f,i,g){c=function(a,c,e,j,k,l,n){b.call(this,a,e);this._content=g("<div/>").addClass("measureInfo");this._header=g("<div />").addClass("measureInfoHeader");this._headerTitle=g("<div />").addClass("headerTitle").html(j);this._headerExtra=g("<div />").addClass("headerExtra").html(n);
this._header.append(this._headerTitle).append(this._headerExtra);this._content.append(this._header);this._body=g("<div />");this._content.append(this._body);this.t=new f(a.i18n,d);this.t.setContext(this._body);this.makeTotalCount=l;this._channelsInfo=k;this.channels=[];this.t.bind("click",".addAnnotation",i.bind(function(){var a="<p>";i.each(this.channels,function(b,e){a+=(0<e?"<br />":"")+"<b>"+b.name+"</b>: "+b.value},this);a+="</p>";this.f.emit("module.annotation.createAnnotation",this.area.rect,
a);this.f.emit("toolManager.deactivateTool")},this));this.f.i18n.loadBundle("viewer",i.bind(function(){this.t.render()},this));this.t.d.channels=[];this.t.d.makeTotalCount=l;this.area=c;this.update();this.getFrame=function(){return this.area?this.area.rect:null};this.getContent=function(){return this._content};this.getRestrictBorder=function(){return 0};this.isInteractive=function(){return!0}};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype.getChannelsInformation=function(){return this._channelsInfo};
c.prototype.update=function(){this.f.requestModule("graphics",i.bind(function(a){var b=a.getGraphicsModel();this.channels=[];this.t.d.channels=[];a=b.getParsedChannelsInfo(this._channelsInfo);i.each(a.channels,function(a){if(!b.isInDifferenceCompareMode()||!a.isInPreviousAndMatchedWithCurrent())this.channels.push(a),this.t.d.channels.push(a)},this);this.t.d.totalCount=this.makeTotalCount?a.total:"";this.t.render()},this))};c.prototype.setChannelsInfo=function(a){this._channelsInfo=a;this.update()};
c.prototype.setArea=function(a){this.area=a};c.prototype.setHeaderExtra=function(a){this._headerExtra.html(a)};c.prototype.setHeader=function(a){this._headerTitle.html(a)};return c});
define("web-viewer/measure/AbstractMeasureTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/utils/ViewerUtils web-viewer/measure/MeasureLayerModel web-viewer/measure/MeasureConstants web-viewer/measure/MeasurePopoverModel utils/XMLUtils web-viewer/utils/ConversionConstants utils/Cache".split(" "),function(c,b,d,f,i,g,a,h,e,j,k,l){f=function(e,d){b.call(this,e,d);this.f=e;this.popover=null;this.defaultState="default";
this.drawingState="drawing";this.clickState="click";this.model=new a(e,d);this.touchPoint=null;this.snapDistance=this.minimum=16;this.infoFetchedFor=null;this.isPopoverShown=!1;this._infoCache=new l(4,!0);this._infoCache._loadItem=c.bind(function(a){this.f.ajax(a,{success:c.bind(function(b){(b=j.xml2obj(b))&&(b.status&&"-1"==b.status.value)&&this.f.emit("userMessage","warn",b.status.message);this._infoCache._registerItem(a,b)},this),error:c.bind(function(b,e,c){this._infoCache._registerItem(a);this.f.i18n.loadBundle("viewer",
function(){this.f.emit("error.SEVERE",this.f.i18n.t("MeasurementInfoError"),b,e,c)},this)},this)})},this);this.registerState(this.defaultState,function(a){return{enterState:function(){},mousedown:function(b){a.removePopover();a.model.reset();a.didReset();a.touchPoint=a.keepPointWithinWorldBounds(a.getWorldPoint(b),!0);var e=a.getPointToSnapTo(b,a.snapDistance);e||(e=a.keepPointWithinWorldBounds(a.getWorldPoint(b),!1));a.model.setStartPoint(e);a.model.hidePopover();a.changeState(a.drawingState);b.originalEvent.preventDefault()},
mouseup:function(){a.model.ruler.startPoint&&!a.model.ruler.endPoint?a.changeState(a.clickState):(a.changeState(a.defaultState),a.model.ruler.startPoint&&a.model.ruler.endPoint&&a.calculate())},mousemove:function(b){a.checkForSnapPoint(b)},mouseout:function(){},contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1},mouseleave:function(){}}}(this));this.registerState(this.drawingState,c.defaults(function(a){return{enterState:function(){e.emit("layout.disableTextSelection");e.emit("viewport.startInteractive")},
leaveState:function(){setTimeout(function(){e.emit("layout.enableTextSelection")},500);e.emit("viewport.stopInteractive")},mousemove:function(b){var e=a.keepPointWithinWorldBounds(a.getWorldPoint(b),!0).sizeTo(a.touchPoint);(a.model.ruler.endPoint||Math.abs(e.width)>=a.minimum||Math.abs(e.height)>a.minimum)&&a.registerEndPoint(b);a.checkForSnapPoint(b)}}}(this),this.getState(this.defaultState)));this.registerState(this.clickState,c.defaults(function(a){return{enterState:function(){a.changeState(a.defaultState)}}}(this),
this.getState(this.drawingState)));this.getDefaultCursor=function(){return"rulerCursor"};this._override("initialize",function(a,b){this._super(a,b);this.changeState(this.defaultState);this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu".split(" "))});this._override("activate",function(a){this._super(a);a||(this.f.getModule("viewport").addLayer(this.getIID(),this.model),this.model.ruler.startPoint&&this.model.ruler.endPoint&&this.popover&&(this.model.addPopoverModel(this.popover),
this.f.emit("channels.informationAdded",this.popover.getChannelsInformation())))});this._override("deactivate",function(a){this._super(a);a||(this.model.modelChanged(!0),this.removePopover(),this.f.getModule("viewport").removeLayer(this.getIID()),e.emit("channels.informationNotVisible"))})};f.prototype=new b;f.prototype.constructor=f;f.prototype.calculate=function(){};f.prototype.endPointSet=function(){};f.prototype.didReset=function(){};f.prototype.registerEndPoint=function(a){var b=this.getPointToSnapTo(a,
this.snapDistance);b||(b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1));this.model.setEndPoint(b,a.shiftKey);this.endPointSet()};f.prototype.registerStartPoint=function(a){var b=this.getPointToSnapTo(a,this.snapDistance);b||(b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1));this.model.setStartPoint(b,a.shiftKey);this.endPointSet()};f.prototype.getPointToSnapTo=function(){return null};f.prototype.checkForSnapPoint=function(a){a=this.getPointToSnapTo(a,this.snapDistance);this.model.setSnapIndicatorPoint(a)};
f.prototype.showInfo=function(){};f.prototype.getInfo=function(a){var b=this._generateParameters(),e=c.clone(b);null!=b&&(c.each(a,function(a,e){b[e]=a}),a=this.f.getActivePage().getInfoURL(b),this._infoCache.get(a,c.bind(function(a){a&&(this.infoFetchedFor=e,this.showInfo(a,b))},this)))};f.prototype._generateParameters=function(){if(this.model.ruler.startPoint&&this.model.ruler.endPoint){var a=new d.Rect(this.model.ruler.startPoint.copy(),this.model.ruler.startPoint.sizeTo(this.model.ruler.endPoint));
a.normalize();var b=k.FIXED_BARCODE_DPMM,a={rectangle:a,servlet:"",params:{x1:0,y1:0,x2:0,y2:0}};this.f.emit("intercept.fragmentURL",a);a=a.params;a.res=b;return a}return null};f.prototype.canBeInterrupted=function(){return this.getCurrentStateName()!=this.drawingState};f.prototype.canBeUsedOnActivePage=function(){return!0};f.prototype.updateIfNeeded=function(a){(a||this.infoFetchedFor&&this.infoFetchedFor!=this._generateParameters())&&this.calculate();this.popover&&this.isPopoverShown&&(this.popover.update(),
this.model.modelChanged())};f.prototype.showPopover=function(a,b,e,c){b||(b=this.model.ruler.getSquareLinework()[0]);this.popover?(this.popover.setArea(b),this.popover.setChannelsInfo(a),this.popover.setHeader(e),this.popover.setHeaderExtra(c)):this.popover=this.createPopoverModel(a,b,e,c);this.model.addPopoverModel(this.popover);this.isPopoverShown=!0;this.model.modelChanged()};f.prototype.createPopoverModel=function(a,b,c,d){return new e(this.f,b,"Channels",c?c:this.f.i18n.t("ChannelsTitle"),a,
this._needsTotalCount(),d)};f.prototype.removePopover=function(){this.popover&&this.model.removePopoverModel(this.popover.getID());this.isPopoverShown=!1};f.prototype._needsTotalCount=function(){return!1};f.prototype.getToolState=function(){return{startPoint:this.model.getStartPoint(),endPoint:this.model.getEndPoint(),isActive:this.isActive()}};f.prototype.setToolState=function(a){null!==a.startPoint&&this.model.setStartPoint(a.startPoint);null!==a.endPoint&&(this.model.setEndPoint(a.endPoint),this.endPointSet())};
f.prototype.doActivation=function(){this.model.modelChanged();b.prototype.doActivation.call(this)};return f});
define("web-viewer/measure/RulerPopoverModel","underscore web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel utils/ShapeUtils Template tpl!web-viewer/measure/RulerPopoverTemplate web-viewer/core/CoreConstants".split(" "),function(c,b,d,f,i,g,a){var h=function(a,b,k,l,n){d.call(this,a,b);var h=$("<div/>").addClass("rulerMeasurement");this.ruler=k;this.end=l;this.fix=3;this.f=a;k&&(this.point=k.startPoint);this.t=new i(a.i18n,g);a.i18n.loadBundle("viewer",c.bind(function(){this.t.render()},
this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",c.bind(this.render,this));this.t.setContext(h);this.t.bind("mousedown",".addAnnotation",function(a,b){b.preventDefault();b.stopPropagation()},this);this.t.bind("click",".addAnnotation",function(a,b){this._emit("createRulerAnnotation");b.preventDefault();b.stopPropagation()},this);this.t.render();this.getFrame=function(){if(this.ruler){if(this.end&&k.endPoint)return new f.Rect(k.endPoint.copy(),null);if(k.startPoint)return new f.Rect(k.startPoint.copy(),
null)}else if(this.point)return new f.Rect(this.point.copy(),null);return null};this.getContent=function(){return h};this.getPreferredPosition=function(){return this.ruler.startPoint&&this.ruler.endPoint?this.ruler.startPoint.x.toFixed(this.fix)==this.ruler.endPoint.x.toFixed(this.fix)?this.ruler.startPoint.y<=this.ruler.endPoint.y?!this.end?"top":"bottom":!this.end?"bottom":"top":this.ruler.startPoint.x<=this.ruler.endPoint.x?this.end?"right":"left":this.end?"left":"right":"bottom"};this.getRestrictBorder=
function(){return 0};this.getContext=c.bind(function(){return this.f.getContext().find(".viewport")},this);this.getClass=function(){return n};this.isInteractive=function(){return!0}};h.prototype=Object.create(d.prototype);h.prototype.constructor=h;h.prototype.isEmpty=function(){return this.end?!(this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA")||this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH")):!(this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||
this.point)};h.prototype.render=function(){if(this.ruler){if(!this.ruler.startPoint||!this.ruler.endPoint)return}else if(!this.point)return;c.extend(this.t.d,this.getMeasureData());this.t.render()};h.prototype.getMeasureData=function(){var e={};e.unitsloc=this.f.getUnitsLocName();this.fix=this.f.getUnitsFix();var c=this.f.getUnits(),d,l=null,n=null,h=null;this.ruler?(d=new f.Rect(this.ruler.startPoint.copy(),this.ruler.startPoint.sizeTo(this.ruler.endPoint)),c===a.SizeUnits.PIXELS&&(n=this.f.getActivePage(),
l=b.parseFloat(n.getParam("resolutionx")),n=b.parseFloat(n.getParam("resolutiony")))):d=this.point?new f.Rect(this.point):new f.Rect;if(e.end=this.end){if(!this.ruler.endPoint)return;e.createAnnotation=!0;e.showDA=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA");e.showXY=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY");e.showWH=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH");var g=new f.Point(d.right(),d.bottom()),g=this._coordinates.getTransformedPoint(g);e.x=b.convertFromMmValue(g.x,
c,this.fix,l);e.y=b.convertFromMmValue(g.y,c,this.fix,n);c===a.SizeUnits.PIXELS&&(h=this.ruler.getAngle()*Math.PI/180,h=Math.sqrt(Math.cos(h)*Math.cos(h)*l*l+Math.sin(h)*Math.sin(h)*n*n));e.distance=b.convertFromMmValue(this.ruler.getLength(),c,this.fix,h);e.angle=this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?-this.ruler.getAngle().toFixed(2):this.ruler.getAngle().toFixed(2);e.width=b.convertFromMmValue(d.size.width,c,this.fix,l);e.height=b.convertFromMmValue(d.size.height,c,this.fix,n)}else{if(this.ruler&&
!this.ruler.startPoint)return;e.showXY=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||(this.point?!0:!1);e.showDA=!1;e.showWH=!1;d=new f.Point(d.origin.x,d.origin.y);d=this._coordinates.getTransformedPoint(d);e.x=b.convertFromMmValue(d.x,c,this.fix,l);e.y=b.convertFromMmValue(d.y,c,this.fix,n)}return e};return h});
define("tpl!web-viewer/measure/RulerToAnnotationText",function(){return function(c){var b,d;d="";c.showXY&&(d+="\r\n    <b>"+(null==(b=c.i18n("RulerAnnotationFrom"))?"":_.escape(b))+"</b><br/>\r\n        &nbsp;"+(null==(b=c.i18n("InfoX"))?"":_.escape(b))+" "+(null==(b=c.fromX)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"<br/>\r\n        &nbsp;"+(null==(b=c.i18n("InfoY"))?"":_.escape(b))+" "+(null==(b=c.fromY)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+
"<br/>\r\n    <b>"+(null==(b=c.i18n("RulerAnnotationTo"))?"":_.escape(b))+"</b><br/>\r\n        &nbsp;"+(null==(b=c.i18n("InfoX"))?"":_.escape(b))+" "+(null==(b=c.x)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"<br/>\r\n        &nbsp;"+(null==(b=c.i18n("InfoY"))?"":_.escape(b))+" "+(null==(b=c.y)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"<br/><br/>\r\n");d+="\r\n";c.showDA&&(d+="\r\n    <b>"+(null==(b=c.i18n("InfoDist"))?"":_.escape(b))+"</b> "+(null==
(b=c.distance)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"<br/>\r\n    <b>"+(null==(b=c.i18n("InfoAngle"))?"":_.escape(b))+"</b> "+(null==(b=c.angle)?"":_.escape(b))+"&#176;<br/>\r\n");d+="\r\n";c.showWH&&(d+="\r\n    <b>"+(null==(b=c.i18n("InfoWidth"))?"":_.escape(b))+"</b> "+(null==(b=c.width)?"":_.escape(b))+" "+(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"<br/>\r\n    <b>"+(null==(b=c.i18n("InfoHeight"))?"":_.escape(b))+"</b> "+(null==(b=c.height)?"":_.escape(b))+" "+
(null==(b=c.i18n(c.unitsloc))?"":_.escape(b))+"<br/>\r\n");return d+""}});
define("web-viewer/measure/RulerTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/utils/ListenerUtil web-viewer/measure/RulerPopoverModel Template tpl!web-viewer/measure/RulerToAnnotationText web-viewer/annotation/AnnotationConstants utils/ShapeUtils web-viewer/core/CoreConstants".split(" "),function(c,b,d,f,i,g,a,h,e,j){var k=function(e){b.call(this,e,j.TOOLS.MEASURE_RULER);f.mixin(this,e);this.hoverState="hover";this.draggingState="dragging";
this.drawnState="drawn";this.t=new g(e.i18n,a);this.model.setRulerType(d.MeasureType.Ruler);this.model.setAllowStartPointSnapping(!0);this.model.setDrawType(d.MeasureDrawType.LINE);this.startPopover=new i(e,"startRulerPopover",this.model.ruler,!1,"transparent");this.endPopover=new i(e,"endRulerPopover",this.model.ruler,!0,"transparent");this._registerListener("createRulerAnnotation",this._createAnnotation,this,this.endPopover);this.getState(this.defaultState).canBeInterrupted=!0;this.registerState(this.drawnState,
c.defaults({mousemove:c.bind(function(a){this._isHovering(a)&&this.changeState(this.hoverState);this.checkForSnapPoint(a)},this),mouseup:c.bind(function(){this.model.ruler.startPoint&&!this.model.ruler.endPoint?this.changeState(this.clickState):(this.changeState(this.drawnState),this.model.ruler.startPoint&&this.model.ruler.endPoint&&this.calculate())},this),mouseleave:c.bind(function(){this.changeState(this.drawnState)},this),canBeInterrupted:!0},this.getState(this.defaultState)));this.registerState(this.hoverState,
c.defaults({mousedown:c.bind(function(a){if(a=this._getDistanceToPoints(a))this._isMovingStartPoint=a.toStartPoint<a.toEndPoint,this.changeState("dragging")},this),mousemove:c.bind(function(a){this._isHovering(a)||this.changeState(this.drawnState);this.checkForSnapPoint(a)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.draggingState,c.defaults({enterState:c.bind(function(){this.setCursor("cursor-none")},this),mousemove:c.bind(function(a){this.setCursor("cursor-none");
this._isMovingStartPoint?this.registerStartPoint(a):this.registerEndPoint(a);this.checkForSnapPoint(a)},this),mouseup:c.bind(function(){this.changeState(this.hoverState)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.drawingState,c.defaults({enterState:function(){e.emit("layout.disableTextSelection");e.emit("viewport.startInteractive")},leaveState:function(){setTimeout(function(){e.emit("layout.enableTextSelection")},500);e.emit("viewport.stopInteractive")},
mousemove:c.bind(function(a){this.model.ruler.endPoint&&this.setCursor("cursor-none");var b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!0).sizeTo(this.touchPoint);(this.model.ruler.endPoint||Math.abs(b.width)>=this.minimum||Math.abs(b.height)>this.minimum)&&this.registerEndPoint(a);this.checkForSnapPoint(a)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.clickState,c.defaults({enterState:function(){},mousedown:c.bind(function(a){this.registerEndPoint(a);
this.changeState(this.drawnState)},this)},this.getState(this.drawingState)));this._override("activate",function(a){this._super(a);this.endPointSet()});e.getCurrentUser().on("options.changed.PREFERENCES_RULER_ANGLE_MODE",c.bind(function(){this.startPopover.render();this.endPopover.render();this.model.repaint()},this));e.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_MODE",c.bind(function(){this.startPopover.isEmpty()?this.model.removePopoverModel(this.startPopover.getID()):(void 0===
this.model.getPopoverModel(this.startPopover.getID())&&this.model.addPopoverModel(this.startPopover),this.startPopover.render());this.endPopover.isEmpty()?this.model.removePopoverModel(this.endPopover.getID()):(void 0===this.model.getPopoverModel(this.endPopover.getID())&&this.model.addPopoverModel(this.endPopover),this.endPopover.render());this.model.repaint()},this));e.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_COLOR",c.bind(function(){this.startPopover.render();this.endPopover.render();
this.model.repaint()},this))};k.prototype=Object.create(b.prototype);k.prototype.constructor=k;k.prototype.endPointSet=c.throttle(function(){this.model.ruler.startPoint&&(!this.model.getPopoverModel(this.startPopover.getID())&&!this.startPopover.isEmpty())&&this.model.addPopoverModel(this.startPopover);this.model.ruler.endPoint&&(!this.model.getPopoverModel(this.endPopover.getID())&&!this.endPopover.isEmpty())&&this.model.addPopoverModel(this.endPopover);this.startPopover.render();this.endPopover.render()},
100);k.prototype.didReset=function(){this.model.removePopoverModel(this.startPopover.getID());this.model.removePopoverModel(this.endPopover.getID())};k.prototype.removePopover=function(){this.didReset()};k.prototype.getPointToSnapTo=function(a,b){if(!this.f.getActivePage().hasCad()&&!this.f.getActivePage().hasLinkedPage())return null;var e=this._widget.requestView(a);if(e){var c=this.getScenePoint(a);(e=e.getClosestLineworkPointFromPoint(c,b))&&(e=this.sceneToWorld(e));return e}return null};k.prototype._isHovering=
function(a){if((a=this._getDistanceToPoints(a))&&(a.toStartPoint<d.RulerPoint.CLOSETODISTANCE||a.toEndPoint<d.RulerPoint.CLOSETODISTANCE))return this.setCursor("cursor-moveObject"),!0;this.setCursor(this.getDefaultCursor());return!1};k.prototype._getDistanceToPoints=function(a){var a=this.getScenePoint(a),b=this.model.ruler.startPoint,e=this.model.ruler.endPoint;if(b&&e)return b=this._widget.getWorld().getScenePointFromWorld(b),e=this._widget.getWorld().getScenePointFromWorld(e),b=a.sizeTo(b),b=Math.sqrt(Math.abs(b.width*
b.width+b.height*b.height)),a=a.sizeTo(e),a=Math.sqrt(Math.abs(a.width*a.width+a.height*a.height)),{toStartPoint:b,toEndPoint:a}};k.prototype._createAnnotation=function(){var a=this.startPopover.getMeasureData();this.t.d.fromX=a.x;this.t.d.fromY=a.y;c.extend(this.t.d,this.endPopover.getMeasureData());var a=this.t.getRenderedHtml(),b=new e.Rect(this.model.ruler.startPoint,this.model.ruler.startPoint.sizeTo(this.model.ruler.endPoint));this.f.emit("module.annotation.createAnnotation",b,a,h.AnnotationType.ANNOT_ARROW);
this.f.emit("toolManager.deactivateTool")};k.prototype.canBeInterrupted=function(a){return this.getCurrentState().canBeInterrupted||this.getCurrentState().canBeInterruptedForNavigation&&a&&(a.getIID()===j.TOOLS.PAN||a.getIID()===j.TOOLS.NAVIGATIONPAN||a.getIID()===j.TOOLS.TOUCH||a.getIID()===j.TOOLS.ZOOM)};return k});
define("web-viewer/measure/BarcodeMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/measure/MeasurePopoverModel web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(c,b,d,f,i,g){var a=function(a,e){b.call(this,a,g.TOOLS.MEASURE_BARCODE);this.f=a;this.measureModule=e;this.model.setRulerType(d.MeasureType.Barcode)};a.prototype=Object.create(b.prototype);a.prototype.constructor=a;a.prototype.showInfo=function(a){var b=
[];a&&(a.status.info&&(c.isArray(a.status.info.barcodegv)||(a.status.info.barcodegv=[a.status.info.barcodegv]),this.f.i18n.loadBundle("viewer",c.bind(function(){c.each(a.status.info.barcodegv,c.bind(function(a){var d=a.xml.Barcodes.Barcode;c.isArray(d)||(d=[d]);b[a.color]="";c.each(d,c.bind(function(c,d){0<d&&(b[a.color]+=" | ");b[a.color]+=c.attributes.Type+": "+c.Decoded;c.Decoded_reverse_dir&&(b[a.color]+=" (--\>) "+c.Decoded_reverse_dir+" (<--)");void 0!==c.Magnification&&(100!==parseInt(c.Magnification,
10)&&999!==parseInt(c.Magnification,10))&&(b[a.color]+=" "+c.Magnification+"%");var h=i.parseFloat(c.BWR);999>h&&0!==h&&(b[a.color]+=" ["+h+" "+this.f.i18n.t("Unitmm")+"] ")},this))},this))},this))),this.f.emit("channels.informationAdded",b));this.showPopover(b)};a.prototype.removePopover=function(){this.popover&&this.model.removePopoverModel(this.popover.getID())};a.prototype.calculate=function(){this.getInfo({opmask:6})};a.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();
return a&&a.hasGraphics()};a.prototype.createPopoverModel=function(a,b){return new f(this.f,b,"Channels",$("<i>").addClass("icon icon-normal icon-WCR_Measure-Barcode"),a,this._needsTotalCount())};return a});
define("web-viewer/measure/BrailleMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants component/tooltip/Tooltip".split(" "),function(c,b,d,f,i,g){f=function(a,h){b.call(this,a,i.TOOLS.MEASURE_BRAILLE);this.model.setRulerType(d.MeasureType.Braille);this.language=d.BrailleLanguage[a.getOption("PREFERENCES_BRAILLE_LANGUAGE")]?d.BrailleLanguage[a.getOption("PREFERENCES_BRAILLE_LANGUAGE")].url:d.BrailleLanguage[d.LanguageDefault].url;
this.f=a;this.measureModule=h;a.getCurrentUser().on("options.changed.PREFERENCES_BRAILLE_LANGUAGE",c.bind(function(a,b){this.language=d.BrailleLanguage[b].url;this.removePopover();this.calculate()},this))};f.prototype=Object.create(b.prototype);f.prototype.constructor=f;f.prototype.showInfo=function(a,b){var e=!0,d=!1,g=[];if(a){if(a.status.info){var l=a.status.info.braille;l instanceof Array||(l=[l]);c.each(l,function(a){var b=a.xml.Regions.Braille;b instanceof Array||(b=[b]);c.each(b,function(n,
h){d=!0;"Pass"!==n.attributes.Status&&(e=!1);var l="";1<b.length&&(l=h+1+",");void 0===g[a.color]&&(g[a.color]="");n.Line instanceof Array?c.each(n.Line,function(b,e){1<=e&&(g[a.color]+=" ");g[a.color]+="["+l+(e+1)+"] "+b}):g[a.color]=1<b.length?g[a.color]+("["+l+"1] "+n.Line+" "):g[a.color]+n.Line},this)},this)}this.f.emit("channels.informationAdded",g)}l=null;d&&(l=e?this._createPassIcon():this._createFailIcon());var n=$("<span>").append($("<i>").addClass("icon icon-normal icon-WCR_Measure-Braille")).append($("<span>").addClass("titleText").text(b.brlang));
this.showPopover(g,null,n,l)};f.prototype.calculate=function(){var a=this.language;if(void 0===a||a===d.BrailleLanguage[d.LanguageAutomatic].url)a=d.BrailleLanguage[d.LanguageLocales[this.f.getCurrentUser().getLocale()]].url,void 0===a&&(a=d.BrailleLanguage[d.LanguageDefault].url);this.getInfo({opmask:5,brlang:a})};f.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()};f.prototype._createPassIcon=function(){var a=$("<i>").addClass("icon icon-normal icon icon-WCR_Msg-Success-round"),
b=$("<div>").append(a);new g(this.f.i18n,a,b,this.f.getContext(),!1,"viewer","BraillePass");return b};f.prototype._createFailIcon=function(){var a=$("<i>").addClass("icon icon-normal icon icon-WCR_Msg-Warning"),b=$("<div>").append(a);new g(this.f.i18n,a,b,this.f.getContext(),!1,"viewer","BrailleFail");return b};return f});
define("web-viewer/measure/EyeDropperUnitSelector",["web-viewer/layout/component/DropdownMiniButton","web-viewer/core/CoreConstants","underscore"],function(c,b,d){var f=function(i){this.f=i;this._optionButton=new c(this.f,"eyeDropperUnitSettings","icon-WCR_Settings-submenu");this._optionButton.setTooltip("viewer","UnitSettings");this.f.i18n.loadBundle("viewer",function(){this._optionButton.addOption({name:"eyeDropperUnitPixels",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.PIXELS]),
onchange:d.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.PIXELS),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQMM",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.SQMM]),onchange:d.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.SQMM),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQCM",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.SQCM]),onchange:d.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.SQCM),
userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQINCH",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.SQINCH]),onchange:d.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.SQINCH),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitPercent",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.PERCENT]),onchange:d.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.PERCENT),userCannotUncheck:!0});this._updateOptions();
this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_EYEDROPPER",d.bind(this._updateOptions,this))},this)};f.prototype.getButtonElement=function(){return this._optionButton.element};f.prototype._toggleEyeDropperUnit=function(c,d){d&&(this.f.setOption("PREFERENCES_UNIT_EYEDROPPER",c,!0),c!==b.EyeDropperUnits.PERCENT&&this.f.setOption("PREFERENCES_UNIT_SIZE",c,!0))};f.prototype._updateOptions=function(){var c=this.f.getOption("PREFERENCES_UNIT_EYEDROPPER");this._optionButton.toggleOption("eyeDropperUnitPixels",
c===b.EyeDropperUnits.PIXELS);this._optionButton.toggleOption("eyeDropperUnitSQMM",c===b.EyeDropperUnits.SQMM);this._optionButton.toggleOption("eyeDropperUnitSQCM",c===b.EyeDropperUnits.SQCM);this._optionButton.toggleOption("eyeDropperUnitSQINCH",c===b.EyeDropperUnits.SQINCH);this._optionButton.toggleOption("eyeDropperUnitPercent",c===b.EyeDropperUnits.PERCENT)};return f});
define("web-viewer/measure/EyeDropperPopoverModel",["web-viewer/measure/MeasurePopoverModel","web-viewer/measure/EyeDropperUnitSelector","underscore","jquery"],function(c,b){var d=function(b,d,g,a,h,e,j){c.call(this,b,d,g,a,h,e,j);this._eyeDropperUnitSelector=null;this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(this._updateEyeDropperUnitSelectorButton,this)};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype._updateEyeDropperUnitSelectorButton=
function(){this.f.getActivePage().isDigitalFilmPage()?null===this._eyeDropperUnitSelector?(this._eyeDropperUnitSelector=new b(this.f),this._headerExtra.append(this._eyeDropperUnitSelector.getButtonElement())):this._eyeDropperUnitSelector.getButtonElement().show():null!==this._eyeDropperUnitSelector&&this._eyeDropperUnitSelector.getButtonElement().hide()};return d});
define("web-viewer/measure/EyeDropperMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/measure/EyeDropperPopoverModel utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(c,b,d,f,i,g,a){var h=function(e){b.call(this,e,a.TOOLS.MEASURE_EYEDROPPER);this.model.setRulerType(d.MeasureType.EyeDropper);this.registerState(this.clickState,c.defaults({enterState:c.bind(function(){var a=this.getWorldResolution();
if(null!==a){var b=d.ClickSize.NORMAL;this.f.getActivePage().isDigitalFilmPage()&&(b=d.ClickSize.DIGITAL_FILM);var c=b/a.x,a=b/a.y;this.model.setStartPoint(new i.Point(this.model.ruler.startPoint.x-c/2,this.model.ruler.startPoint.y-a/2));this.model.setEndPoint(new i.Point(this.model.ruler.startPoint.x+c,this.model.ruler.startPoint.y+a));this.calculate();this.changeState(this.defaultState)}},this)},this.getState(this.drawingState)));this._channels=[];this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_EYEDROPPER",
c.bind(this._onEyeDropperUnitChanged,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",c.bind(function(){var b=this.f.getOption("PREFERENCES_UNIT_SIZE");b!==a.SizeUnits.POINTS&&this.f.setOption("PREFERENCES_UNIT_EYEDROPPER",b,!0)},this))};h.prototype=Object.create(b.prototype);h.prototype.constructor=h;h.prototype.showInfo=function(a){this._channels=[];a&&a.status.info.dotpercentage&&(c.isArray(a.status.info.dotpercentage)||(a.status.info.dotpercentage=[a.status.info.dotpercentage]),
c.each(a.status.info.dotpercentage,function(a){this._channels[a.color]=g.parseFloat(a.dotvalue)},this));this._onEyeDropperUnitChanged(!0)};h.prototype._onEyeDropperUnitChanged=function(b){if(this.popover&&this.isPopoverShown||b)if((b=this.model.ruler)&&b.startPoint&&b.endPoint){var d=b.startPoint.sizeTo(b.endPoint),b=a.EyeDropperUnits.PERCENT;this.f.getActivePage().isDigitalFilmPage()&&(b=this.f.getOption("PREFERENCES_UNIT_EYEDROPPER"));var h=d.width,d=d.height,l=0;switch(b){case a.EyeDropperUnits.SQMM:l=
h*d;break;case a.EyeDropperUnits.SQCM:l=g.parseFloat(g.convertFromMmValue(h,a.SizeUnits.CM))*g.parseFloat(g.convertFromMmValue(d,a.SizeUnits.CM));break;case a.EyeDropperUnits.SQINCH:l=g.parseFloat(g.convertFromMmValue(h,a.SizeUnits.INCH))*g.parseFloat(g.convertFromMmValue(d,a.SizeUnits.INCH));break;case a.EyeDropperUnits.PIXELS:var n=this.getWorldResolution();null!==n&&(l=h*n.x*d*n.y);break;case a.EyeDropperUnits.PERCENT:l=100}var f=[];c.each(this._channels,function(a,b){a&&(f[b]=""+a/100*l)},this);
f.makeTotalCount=!0;f.unit=this.f.i18n.t(a.EyeDropperUnitsShortLocNames[b]);f.unitFix=a.EyeDropperUnitsFixes[b];this.f.emit("channels.informationAdded",f);this.showPopover(f)}};h.prototype.calculate=function(){this.getInfo({opmask:1})};h.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()};h.prototype._needsTotalCount=function(){return!0};h.prototype.createPopoverModel=function(a,b){return new f(this.f,b,"Channels",$("<i>").addClass("icon icon-normal icon-WCR_Measure-Colorpicker"),
a,this._needsTotalCount())};return h});define("tpl!web-viewer/measure/CaliperPopoverTemplate",function(){return function(c){var b;return c=""+("<table>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(b=c.endPointLabel)?"":_.escape(b))+": </strong></td>\r\n\t\t<td>"+(null==(b=c.endPointValue)?"":_.escape(b))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(b=c.i18n("GapSize"))?"":_.escape(b))+": </strong></td>\r\n\t\t<td>"+(null==(b=c.gap)?"":_.escape(b))+"</td>\r\n\t</tr>\r\n</table>")}});
define("web-viewer/measure/CaliperPopoverModel","web-viewer/viewport/model/ViewportPopoverModel tpl!web-viewer/measure/CaliperPopoverTemplate utils/ShapeUtils web-viewer/utils/ViewerUtils Template web-viewer/core/CoreConstants underscore".split(" "),function(c,b,d,f,i,g,a){var h=function(e,g,h){c.call(this,e,h);this.div=$("<div/>").addClass("measureInfo caliperPopover");this.t=new i(e.i18n,b);this.t.setContext(this.div);this.t.d.isMeasuringHeight=!0;this._endPoint=new d.Point;this._gapinMm=this._endPointValueInMm=
null;e.i18n.loadBundle("viewer",a.bind(function(){this.t.render()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",a.bind(this.recalculateGap,this));this.frame=null;this.getFrame=function(){return this.frame?this.frame:new d.Rect(new d.Point(0,0),new d.Size(1,1))};this.getContent=function(){return this.div};this.getPreferredPosition=function(){return this.t.d.isMeasuringHeight?"bottom":"right"};this.getRestrictBorder=function(){return 0};this.isInteractive=function(){return!0};
this.getContext=function(){return this.f.getContext().find(".viewport")};this.render=a.throttle(a.bind(function(){this.t.render()},this),100);this.getClass=function(){return"transparent"}};h.prototype=Object.create(c.prototype);h.prototype.constructor=h;h.prototype.getChannelsInformation=function(){return this._channelsInfo};h.prototype.setGap=function(a){this._gapinMm=a.getVector().getLength();this.t.d.gap=this._convertToCorrectUnits(this._gapinMm);this.render()};h.prototype.recalculateGap=function(){null!==
this._gapinMm&&null!==this._endPointValueInMm&&(this.t.d.endPointValue=this._convertToCorrectUnits(this._endPointValueInMm),this.t.d.gap=this._convertToCorrectUnits(this._gapinMm),this.render())};h.prototype.setEndPoint=function(a){if(this._endPoint=a)this.t.d.endPointValue=this._convertToCorrectUnits(this.t.d.isMeasuringHeight?this._endPoint.y:this._endPoint.x)};h.prototype._convertToCorrectUnits=function(a){var b=null;this.f.getUnits()===g.SizeUnits.PIXELS&&(b=this.f.getActivePage(),b=this.t.d.isMeasuringHeight?
b.getParam("resolutiony"):b.getParam("resolutionx"));a=f.convertFromMmValue(a,this.f.getUnits(),this.f.getUnitsFix(),f.parseFloat(b));b=this.f.i18n.t(this.f.getUnitsLocName());return a+" "+b};h.prototype.setFrame=function(a){this.frame=a};h.prototype.setMeasuringHeight=function(a){this.t.d.isMeasuringHeight=a;this._endPoint&&(this.t.d.isMeasuringHeight?(this.t.d.endPointLabel="Y",a=this._endPoint.copy(),a=this._coordinates.getTransformedPoint(a),this.t.d.endPointValue=this._convertToCorrectUnits(a.y),
this._endPointValueInMm=a.y):(this.t.d.endPointLabel="X",a=this._endPoint.copy(),a=this._coordinates.getTransformedPoint(a),this.t.d.endPointValue=this._convertToCorrectUnits(a.x),this._endPointValueInMm=a.x));this.render()};return h});
define("web-viewer/measure/CaliperLayerModel","underscore web-viewer/viewport/model/ViewportLayerModel web-viewer/measure/CaliperPopoverModel web-viewer/utils/DrawUtils utils/ShapeUtils web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint web-viewer/utils/ListenerUtil web-viewer/measure/MeasureConstants".split(" "),function(c,b,d,f,i,g,a,h,e){var j=function(a,c,e){b.call(this,a,c);h.mixin(this,a);this._caliperModel=e;this._caliperPopover=null;this._popoverFrame=new i.Rect;this._startPoint=
null;this._registerListener("changed.currentGap",this.modelChanged,this,this._caliperModel);this._registerListener("changed.currentGap.vector",this.modelChanged,this,this._caliperModel)};j.prototype=Object.create(b.prototype);j.prototype.constructor=j;j.prototype.setStartPoint=function(a){this._startPoint=a;this.modelChanged()};j.prototype.getStartPoint=function(){return this._startPoint};j.prototype.getLinework=function(b,c,e){if(this._startPoint){var b=new g,c=new g,d=new g,h=new g,m=this._caliperModel.getCurrentGap().getVector(),
j=m.getLength(),t=m.getAngleInDegrees();if(this._caliperModel.isMeasuringHeight(m)){if(0===t||90===t)j=-j;m=new i.Rect(new i.Point(e.left(),e.top()),new i.Size(e.right()-e.left(),Math.min(this._startPoint.y,this._startPoint.y+j)-e.top()));m.normalize();d.rect=m;m=Math.max(this._startPoint.y,this._startPoint.y+j);m=new i.Rect(new i.Point(e.left(),m),new i.Size(e.right()-e.left(),e.bottom()-m));m.normalize();h.rect=m;m=new a;m.makeMoveTo(e.left(),this._startPoint.y);b.pointArray.push(m);m=new a;m.makeLineTo(e.right(),
this._startPoint.y);b.pointArray.push(m);m=new a;m.makeMoveTo(e.left(),this._startPoint.y+j);c.pointArray.push(m);m=new a;m.makeLineTo(e.right(),this._startPoint.y+j);c.pointArray.push(m);this._popoverFrame.origin.x=e.left();this._popoverFrame.origin.y=this._startPoint.y+j;this._popoverFrame.size.width=e.size.width;this._popoverFrame.size.height=1E-8}else this._caliperModel.isMeasuringWidth(m)&&(180===t&&(j=-j),m=new i.Rect(new i.Point(e.left(),e.top()),new i.Size(Math.min(this._startPoint.x,this._startPoint.x+
j)-e.left(),e.bottom()-e.top())),m.normalize(),d.rect=m,m=Math.max(this._startPoint.x,this._startPoint.x+j),m=new i.Rect(new i.Point(m,e.top()),new i.Size(e.right()-m,e.bottom()-e.top())),m.normalize(),h.rect=m,m=new a,m.makeMoveTo(this._startPoint.x,e.top()),b.pointArray.push(m),m=new a,m.makeLineTo(this._startPoint.x,e.bottom()),b.pointArray.push(m),m=new a,m.makeMoveTo(this._startPoint.x+j,e.top()),c.pointArray.push(m),m=new a,m.makeLineTo(this._startPoint.x+j,e.bottom()),c.pointArray.push(m),
this._popoverFrame.origin.x=this._startPoint.x+j,this._popoverFrame.origin.y=e.top(),this._popoverFrame.size.width=1E-8,this._popoverFrame.size.height=e.size.height);b.dash=[4,3];b.color="rgba(210,210,210,0.9)";b.type=f.LWTYPE_LINE;c.dash=[4,3];c.color="rgba(210,210,210,0.9)";c.type=f.LWTYPE_LINE;d.type=f.LWTYPE_RECT;d.fillcolor="rgba(0, 0, 0, 0.40)";d.color="rgba(0, 0, 0, 1.00)";d.linewidth=1;h.type=f.LWTYPE_RECT;h.fillcolor="rgba(0, 0, 0, 0.40)";h.color="rgba(0, 0, 0, 1.00)";h.linewidth=1;return[d,
h,b,c]}};j.prototype.getEndPoint=function(){if(this._startPoint){var a=this._caliperModel.getCurrentGap().getVector(),b=a.getLength(),c=a.getAngleInDegrees();if(this._caliperModel.isMeasuringHeight(a)){if(0===c||90===c)b=-b;return new i.Point(this._startPoint.x,this._startPoint.y+b)}if(this._caliperModel.isMeasuringWidth(a))return 180===c&&(b=-b),new i.Point(this._startPoint.x+b,this._startPoint.y)}else return null};j.prototype.setPoints=function(a,b,c,e){var d=this.getStartPoint(),h=this.getEndPoint(),
g=this._caliperModel.getCurrentGap().getVector();if(c)e=b.y-h.y,b=b.x-h.x,0!==e?a=new i.Point(d.x,d.y+e):0!==b&&(a=new i.Point(d.x+b,d.y));else{var c=h=0,h=b.x-a.x,f=b.y-a.y,b=Math.abs(h),c=Math.abs(f),j=b>c;e&&(j=this._caliperModel.isMeasuringWidth(g));j?(h=0>h?180:0,c=b):h=0>f?90:-90;g.setAngleInDegrees(h);g.setLength(c)}a.equals(d)||(this._startPoint=a);this._caliperModel.setCurrentGapVector(g);this.modelChanged()};j.prototype.showPopover=function(){this._caliperPopover||(this._caliperPopover=
new d(this.f,null,"CaliperPopover",this),this.modelChanged(),this.addPopoverModel(this._caliperPopover))};j.prototype.hidePopover=function(){this._caliperPopover&&(this.removePopoverModel(this._caliperPopover.getID()),this.removePopover(this._caliperPopover.getID()),this._caliperPopover=null)};j.prototype.modelChanged=function(a){var d=null;if(!c.isBoolean(a)||c.isBoolean(a)&&!a)this._caliperPopover&&(this._caliperPopover.setGap(this._caliperModel.getCurrentGap()),this._caliperPopover.setEndPoint(this.getEndPoint()),
this._caliperPopover.setMeasuringHeight(this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())),this._caliperPopover.setFrame(this._popoverFrame)),this._startPoint&&(this._caliperModel.getCurrentGap()&&0!==this._caliperModel.getCurrentGap().getVector().getLength())&&(d=this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())?{mode:e.MeasureDrawType.HEIGHT,y:this._startPoint.y,h:this._caliperModel.getCurrentGap().getVector().getLength()}:{mode:e.MeasureDrawType.WIDTH,
x:this._startPoint.x,w:this._caliperModel.getCurrentGap().getVector().getLength()});this.f.emit("selection.changed",d);b.prototype.modelChanged.call(this)};return j});
define("web-viewer/measure/CaliperTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/measure/CaliperLayerModel web-viewer/measure/MeasureConstants web-viewer/core/CoreConstants".split(" "),function(c,b,d,f,i,g){d=function(a,d){b.call(this,a,g.TOOLS.MEASURE_CALIPER);this.CLOSETODISTANCE=16;this._caliperModel=d;this._caliperLayerModel=new f(a,this.getIID(),d);this.registerState("default",{enterState:c.bind(function(){this._caliperLayerModel.hidePopover();this._caliperLayerModel.setStartPoint(null);
this._caliperModel.resetFreeformVector()},this),mousedown:c.bind(function(a){var b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1);this._caliperLayerModel.setStartPoint(b);this._caliperLayerModel.getEndPoint()||this._moveEndLine(a);this.changeState("dragging")},this),mouseup:function(){},mousemove:function(){},mouseout:function(){},mouseleave:function(){},contextmenu:c.bind(function(a){a.preventDefault();a.stopPropagation()},this),canBeInterrupted:!0});this.registerState("dragging",c.defaults({enterState:c.bind(function(){this._caliperLayerModel.showPopover();
this.f.emit("viewport.startInteractive")},this),leaveState:c.bind(function(){this.f.emit("viewport.stopInteractive")},this),mousedown:function(){},mouseup:c.bind(function(){var a=this._caliperModel.getCurrentGap(),b=a.getStyle();(b===i.CaliperStyle.Fixed||b===i.CaliperStyle.Preset||0<a.getVector().getLength())&&this.changeState("drawn")},this),mousemove:c.bind(function(a){var b=this._caliperModel.getCurrentGap().getStyle();b===i.CaliperStyle.Fixed||b===i.CaliperStyle.Preset?this._moveStartLine(a):
this._moveEndLine(a)},this),canBeInterrupted:!1},this.getState("default")));this.registerState("drawn",c.defaults({enterState:function(){},mousemove:c.bind(function(a){this._isHovering(a)&&this.changeState("hover")},this),canBeInterrupted:!0},this.getState("default")));this.registerState("hover",c.defaults({enterState:function(){},mousedown:c.bind(function(a){var a=this.getWorldPoint(a),b=this._caliperLayerModel.getStartPoint(),c=this._caliperLayerModel.getEndPoint();this._isCloseToLine(b,a)?this.changeState("movingStartLine"):
this._isCloseToLine(c,a)&&this.changeState("movingEndLine")},this),mousemove:c.bind(function(a){this._isHovering(a)||this.changeState("drawn")},this),mouseleave:c.bind(function(){this.changeState("drawn")},this),canBeInterrupted:!0},this.getState("default")));this.registerState("movingEndLine",c.defaults({enterState:c.bind(function(){this.f.emit("viewport.startInteractive")},this),leaveState:c.bind(function(){this.f.emit("viewport.stopInteractive")},this),mouseleave:c.bind(function(){this.changeState("drawn")},
this),mouseup:c.bind(function(){this.changeState("drawn")},this),mousemove:c.bind(function(a){this._moveEndLine(a,!0)},this),canBeInterrupted:!1},this.getState("default")));this.registerState("movingStartLine",c.defaults({enterState:c.bind(function(){this.f.emit("viewport.startInteractive")},this),leaveState:c.bind(function(){this.f.emit("viewport.stopInteractive")},this),mouseleave:c.bind(function(){this.changeState("drawn")},this),mouseup:c.bind(function(){this.changeState("drawn")},this),mousemove:c.bind(function(a){this._moveStartLine(a)},
this),canBeInterrupted:!1},this.getState("default")));this.registerActiveEvents(["mousedown","mousemove","mouseup","mouseleave","contextmenu"]);this.activeKeyEvents.push(["esc",c.bind(function(a){this.changeState("default");a.preventDefault();a.stopPropagation()},this),"keyup"]);this._override("initialize",function(a,b){this._super(a,b);this.changeState("default")});this._override("activate",function(a){this._super(a);a||this.f.getModule("viewport").addLayer(this.getIID(),this._caliperLayerModel)});
this._override("deactivate",function(a){this._super(a);a||(this._caliperLayerModel.modelChanged(!0),this.f.getModule("viewport").removeLayer(this.getIID()));(!a||c.contains(["movingStartLine","movingEndLine","dragging"],this.getCurrentStateName()))&&this.changeState("default")})};d.prototype=Object.create(b.prototype);d.prototype.constructor=d;d.prototype._moveEndLine=function(a,b){var c=this._caliperModel.getCurrentGap().getStyle(),d=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1),g=this._caliperLayerModel.getStartPoint();
c===i.CaliperStyle.Freeform?this._caliperLayerModel.setPoints(g,d,!1,b):(c===i.CaliperStyle.Fixed||c===i.CaliperStyle.Preset)&&this._caliperLayerModel.setPoints(g,d,!0,b)};d.prototype._moveStartLine=function(a){var b=this._caliperModel.getCurrentGap().getStyle(),a=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1);b===i.CaliperStyle.Freeform?(b=this._caliperLayerModel.getEndPoint(),this._caliperLayerModel.setPoints(a,b,!1,!0)):(b===i.CaliperStyle.Fixed||b===i.CaliperStyle.Preset)&&this._caliperLayerModel.setStartPoint(a)};
d.prototype._isHovering=function(a){var a=this.getWorldPoint(a),b=this._caliperLayerModel.getStartPoint(),c=this._caliperLayerModel.getEndPoint();if(this._isCloseToLine(b,a)||this._isCloseToLine(c,a))return a=this._widget.getWorld().getRotation(),this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())?90===a%180?this.setCursor("cursor-resizeE"):this.setCursor("cursor-resizeN"):this._caliperModel.isMeasuringWidth(this._caliperModel.getCurrentGap().getVector())&&(90===a%
180?this.setCursor("cursor-resizeN"):this.setCursor("cursor-resizeE")),!0;this.setCursor(this.getDefaultCursor());return!1};d.prototype._isCloseToLine=function(a,b){var c=this._widget.getWorld().getZoom();return Math.abs(this._getDistanceToLine(a,b))<this.CLOSETODISTANCE/c};d.prototype._getDistanceToLine=function(a,b){var c=this._caliperModel.getCurrentGap().getVector();if(this._caliperModel.isMeasuringHeight(c))return a.y-b.y;if(this._caliperModel.isMeasuringWidth(c))return a.x-b.x};d.prototype.canBeInterrupted=
function(){return this.getCurrentState().canBeInterrupted};d.prototype.getCaliperModel=function(){return this._caliperModel};d.prototype.canBeUsedOnActivePage=function(){return!0};d.prototype.updateIfNeeded=function(){};d.prototype.getDefaultCursor=function(){return"rulerCursor"};d.prototype.doActivation=function(){this._caliperLayerModel.modelChanged(!1);b.prototype.doActivation.call(this)};d.prototype.getToolState=function(){var a=this._caliperModel.getCurrentGap();return{caliperStyle:a.getStyle(),
caliperGapVector:a.getVector(),startPoint:this._caliperLayerModel.getStartPoint(),isActive:this.isActive()}};d.prototype.setToolState=function(a){if(a.isActive){this.f.emit("toolManager.activateTool",this);this.f.emit("toolManager.interruptTools",!0);var b=a.caliperStyle,d=a.caliperGapVector;if(void 0!==b&&void 0!==d&&void 0!==a.startPoint){var g=c.bind(function(a,b){this._caliperModel.setCurrentGapById(a);this._caliperModel.setCurrentGapVector(b)},this);if(b===i.CaliperStyle.Freeform){var f=this._caliperModel.getFreeformGap();
g(f.getId(),d)}else f=this._caliperModel.getFixedGap(),g(f.getId(),d),b===i.CaliperStyle.Preset&&(b=this._caliperModel.getSimilarPreset(this._caliperModel.getCurrentGap()),void 0!==b&&this._caliperModel.setCurrentGapById(b.getId()));this._caliperLayerModel.setStartPoint(a.startPoint);this._caliperLayerModel.showPopover()}}};return d});
define("web-viewer/measure/CaliperGap",["utils/ShapeUtils","underscore"],function(){var c=function(b,c,f){this._id=b;this._style=c;this._vector=f};c.prototype.getId=function(){return this._id};c.prototype.getStyle=function(){return this._style};c.prototype.getVector=function(){return this._vector.copy()};c.prototype.setVector=function(b){this._vector=b};c.prototype.isSimilarTo=function(b){return this._vector.equals(b.getVector())};return c});
define("web-viewer/measure/CaliperModel",["web-viewer/core/AbstractModel","web-viewer/measure/CaliperGap","web-viewer/measure/MeasureConstants","utils/ShapeUtils","underscore"],function(c,b,d,f,i){var g=function(a,g){c.call(this,a,g);this._nextId=0;this._freeformVector=new f.Vector(0,0,-Math.PI/2);this._freeform=new b(this._getNextId(),d.CaliperStyle.Freeform,this._freeformVector);var e=new f.Vector(0,0.8);this._fixed=new b(this._getNextId(),d.CaliperStyle.Fixed,e);this._presetGaps=[];this._readPresets();
this._currentGap=null};g.prototype=Object.create(c.prototype);g.prototype.constructor=g;g.prototype.resetFreeformVector=function(){var a=this.getCurrentGap();a&&a.getStyle()===d.CaliperStyle.Freeform&&this.setCurrentGapVector(this._freeformVector)};g.prototype._getNextId=function(){var a=this._nextId;this._nextId++;return""+a};g.prototype.getFreeformGap=function(){return this._freeform};g.prototype.getFixedGap=function(){return this._fixed};g.prototype.getAllGaps=function(){var a=[this._freeform,
this._fixed],b=i.sortBy(this._presetGaps,function(a){return 1E4*Math.abs(a.getVector().getAngleInDegrees())+a.getVector().getLength()});return i.union(a,b)};g.prototype.getCurrentGap=function(){return this._currentGap};g.prototype.getGapById=function(a){return i.find(this.getAllGaps(),function(b){return b.getId()===a})};g.prototype.setCurrentGapById=function(a){var b=this.getGapById(a);b?(a=this._currentGap,this._currentGap=b,this._fireChange(!1,["currentGap"],a,this._currentGap)):this.f.debug.error("Gap with id "+
a+" not found")};g.prototype.setCurrentGapVector=function(a){var b=this._currentGap.getVector();this._currentGap.setVector(a);this._fireChange(!1,["currentGap","vector"],b,a)};g.prototype.saveCurrentGapAsPreset=function(){var a=new b(this._getNextId(),d.CaliperStyle.Preset,this._currentGap.getVector());this._presetGaps.push(a);this._persistPresets();this._fireChange(!1,["presetGaps","new"],null,a)};g.prototype._readPresets=function(){var a=this.f.getOption("CALIPER_PRESETS");a&&(a=JSON.parse(a),this._presetGaps=
i.map(a,function(a){return new b(this._getNextId(),d.CaliperStyle.Preset,new f.Vector(a.x,a.y))},this))};g.prototype._persistPresets=function(){var a=i.map(this._presetGaps,function(a){return a.getVector()}),a=JSON.stringify(a);this.f.setOption("CALIPER_PRESETS",a)};g.prototype.deleteCurrentGapFromPresets=function(){this._currentGap.getStyle()!==d.CaliperStyle.Preset&&this.f.debug.error("Cannot delete a non-preset style");this._presetGaps=i.without(this._presetGaps,this._currentGap);this._persistPresets();
this._fireChange(!1,["presetGaps","deleted"],this._currentGap,null)};g.prototype.getSimilarPreset=function(a){return i.find(this._presetGaps,function(b){return b.isSimilarTo(a)})};g.prototype.isMeasuringHeight=function(a){a=a.getAngleInDegrees();return 90===a||-90===a};g.prototype.isMeasuringWidth=function(a){a=a.getAngleInDegrees();return 0===a||180===a};return g});
define("web-viewer/measure/ScreenRulingUnitSelector",["web-viewer/layout/component/DropdownMiniButton","web-viewer/core/CoreConstants","web-viewer/measure/MeasureConstants","underscore"],function(c,b,d,f){var i=function(g){this.f=g;this._optionButton=new c(g,"screenRulingUnitSettings","icon-WCR_Settings-submenu");g.i18n.loadBundle("viewer",function(){function a(a,b,c){c&&this.setUnitAndMode(a,b)}function c(a,b){b&&this.setOrientation(a)}this._optionButton.addOption({name:"unitLpmm",content:this.f.i18n.t("UnitScreenmm"),
onchange:f.bind(a,this,b.ResolutionUnits.PPMM,d.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpcm",content:this.f.i18n.t("UnitScreencm"),onchange:f.bind(a,this,b.ResolutionUnits.PPCM,d.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpi",content:this.f.i18n.t("UnitScreenInch"),onchange:f.bind(a,this,b.ResolutionUnits.PPI,d.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitDeg",content:this.f.i18n.t("UnitDegree"),
onchange:f.bind(a,this,0,d.ScreenRulingMode.ANGLE),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpmmDeg",content:this.f.i18n.t("UnitDegreemm"),onchange:f.bind(a,this,b.ResolutionUnits.PPMM,d.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpcmDeg",content:this.f.i18n.t("UnitDegreecm"),onchange:f.bind(a,this,b.ResolutionUnits.PPCM,d.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpiDeg",content:this.f.i18n.t("UnitDegreeInch"),
onchange:f.bind(a,this,b.ResolutionUnits.PPI,d.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addDivider();this._optionButton.addOption({name:"scrOrientationCW",content:this.f.i18n.t("ScreenCW"),onchange:f.bind(c,this,d.ScreenRulingOrientation.CW),userCannotUncheck:!0});this._optionButton.addOption({name:"scrOrientationCCW",content:this.f.i18n.t("ScreenCCW"),onchange:f.bind(c,this,d.ScreenRulingOrientation.CCW),userCannotUncheck:!0});this._updateUnitOptions();this._updateOrientationOptions();
this._optionButton.setTooltip("viewer","UnitSettings");this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREENRULING",f.bind(this._updateUnitOptions,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREEN",f.bind(this._updateUnitOptions,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_SCREEN_ORIENTATION",f.bind(this._updateOrientationOptions,this))},this)};i.prototype.getButtonElement=function(){return this._optionButton.element};i.prototype.setUnitAndMode=
function(b,a){this.f.getOption("PREFERENCES_UNIT_SCREENRULING")!==b&&this.f.setOption("PREFERENCES_UNIT_SCREENRULING",b,!0);this.f.getOption("PREFERENCES_UNIT_SCREEN")!==a&&this.f.setOption("PREFERENCES_UNIT_SCREEN",a,!1)};i.prototype._updateUnitOptions=function(){var c=this.f.getOption("PREFERENCES_UNIT_SCREENRULING"),a=this.f.getOption("PREFERENCES_UNIT_SCREEN");this._optionButton.toggleOption("unitLpmm",c===b.ResolutionUnits.PPMM&&a===d.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitLpcm",
c===b.ResolutionUnits.PPCM&&a===d.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitLpi",c===b.ResolutionUnits.PPI&&a===d.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitDeg",a===d.ScreenRulingMode.ANGLE);this._optionButton.toggleOption("unitLpmmDeg",c===b.ResolutionUnits.PPMM&&a===d.ScreenRulingMode.BOTH);this._optionButton.toggleOption("unitLpcmDeg",c===b.ResolutionUnits.PPCM&&a===d.ScreenRulingMode.BOTH);this._optionButton.toggleOption("unitLpiDeg",c===b.ResolutionUnits.PPI&&
a===d.ScreenRulingMode.BOTH)};i.prototype.setOrientation=function(b){this.f.setOption("PREFERENCES_SCREEN_ORIENTATION",b,!1)};i.prototype._updateOrientationOptions=function(){var b=this.f.getOption("PREFERENCES_SCREEN_ORIENTATION");this._optionButton.toggleOption("scrOrientationCW",b===d.ScreenRulingOrientation.CW);this._optionButton.toggleOption("scrOrientationCCW",b===d.ScreenRulingOrientation.CCW)};return i});
define("web-viewer/measure/ScreenRulingPopoverModel",["web-viewer/measure/MeasurePopoverModel","web-viewer/measure/ScreenRulingUnitSelector","underscore","jquery"],function(c,b){var d=function(b,d,g,a,h,e,j){c.call(this,b,d,g,a,h,e,j);this._screenRulingUnitSelector=null;this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(this._updateScreenRulingUnitSelectorButton,this)};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype._updateScreenRulingUnitSelectorButton=
function(){this.f.getActivePage().isDigitalFilmPage()?null===this._screenRulingUnitSelector?(this._screenRulingUnitSelector=new b(this.f),this._headerExtra.append(this._screenRulingUnitSelector.getButtonElement())):this._screenRulingUnitSelector.getButtonElement().show():null!==this._screenRulingUnitSelector&&this._screenRulingUnitSelector.getButtonElement().hide()};return d});
define("web-viewer/measure/ScreenRulingMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/measure/ScreenRulingPopoverModel utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(c,b,d,f,i,g,a){var h=function(e){b.call(this,e,a.TOOLS.MEASURE_SCREEN_RULING);this.model.setRulerType(d.MeasureType.ScreenRuling);this._storedResults=null;this.registerState(this.clickState,c.defaults({enterState:c.bind(function(){var a=
this.getWorldResolution();if(null!==a){var b=d.ClickSize.DIGITAL_FILM/a.x,a=d.ClickSize.DIGITAL_FILM/a.y;this.model.setStartPoint(new i.Point(this.model.ruler.startPoint.x-b/2,this.model.ruler.startPoint.y-a/2));this.model.setEndPoint(new i.Point(this.model.ruler.startPoint.x+b,this.model.ruler.startPoint.y+a));this.calculate();this.changeState(this.defaultState)}},this)},this.getState(this.drawingState)));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREENRULING",c.bind(this.showInfo,
this,null));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREEN",c.bind(this.showInfo,this,null));this.f.getCurrentUser().on("options.changed.PREFERENCES_SCREEN_ORIENTATION",c.bind(this.showInfo,this,null))};h.prototype=Object.create(b.prototype);h.prototype.constructor=h;h.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()&&a.isDigitalFilmPage()};h.prototype._needsTotalCount=function(){return!1};h.prototype.calculate=function(){this.getInfo({scrmode:1})};
h.prototype.showInfo=function(a){var b=[];a?this._storedResults=a:a=this._storedResults;var f=this.f.getOption("PREFERENCES_UNIT_SCREEN"),h=this.f.getOption("PREFERENCES_SCREEN_ORIENTATION");a&&(a.status.info.screen&&(c.isArray(a.status.info.screen)||(a.status.info.screen=[a.status.info.screen]),c.each(a.status.info.screen,c.bind(function(a){var c="";if("1"===a.found){if(f===d.ScreenRulingMode.LINES||f===d.ScreenRulingMode.BOTH)c+=g.convertResolutionFromPpmmValue(g.parseFloat(a.ruling),this.f.getScreenUnits(),
this.f.getScreenUnitsFix()),c+=" "+this.f.i18n.t(this.f.getScreenUnitsLocName());f===d.ScreenRulingMode.BOTH&&(c+=" / ");if(f===d.ScreenRulingMode.ANGLE||f===d.ScreenRulingMode.BOTH){var e=g.parseFloat(a.angle);h===d.ScreenRulingOrientation.CCW&&(e=90-e);c+=e.toFixed(2)+"\u00b0"}}b[a.color]=c},this))),this.f.emit("channels.informationAdded",b));this.showPopover(b)};h.prototype.createPopoverModel=function(a,b){return new f(this.f,b,"Channels",$("<i>").addClass("icon icon-normal icon-WCR_Measure-Screen"),
a,this._needsTotalCount())};return h});
define("web-viewer/layout/component/Spinner",["component/tooltip/Tooltip","web-viewer/utils/ViewerUtils","underscore","jquery","jqueryUI"],function(c,b,d,f){var i=function(b,a){this.f=b;this._min=void 0===a.min?0:a.min;this._max=void 0===a.max?100:a.max;this._step=void 0===a.step?1:a.step;this._page=void 0===a.page?10:a.page;this._onSpinnerChanged=a.onSpinnerChanged;this._inputUnit=void 0===a.inputUnit?"%":a.inputUnit;this.element=f("<div />").addClass("spinnerWrapper");this._input=f("<input />").attr("size",
(""+this._max).length).addClass("input");this._input.on("keydown",d.bind(this._valueChanged,this));this._input.on("blur",d.bind(this._valueChanged,this));this._labelUnit=f("<span>"+this._inputUnit+"</span>");this._label=f("<label />").addClass("unit").append(this._input).append(this._labelUnit);this.element.append(this._label);this._input.spinner({min:this._min,max:this._max,step:this._step,page:this._page,spin:d.bind(function(a,b){this._fireSpinnerChanged(b.value)},this)});this.setValue(this._min);
void 0!==a.tooltip&&(this._tooltip=new c(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),a.tooltip))};i.prototype._valueChanged=function(c){if((13==c.which||13==c.keyCode)&&"keydown"===c.type)this._input.blur();else if("keydown"!==c.type){var a=b.parseFloat(f(c.target).val());isNaN(a)&&(a=this._min);a=Math.max(Math.min(a,this._max),this._min);f(c.target).val(a);this._fireSpinnerChanged(a)}};i.prototype._fireSpinnerChanged=function(b){this._onSpinnerChanged(b)};i.prototype.setValue=
function(b){this.getValue()!==b&&this._input.spinner("value",b)};i.prototype.getValue=function(){return this._input.spinner("value")};i.prototype.isDisabled=function(){return this._input.spinner("option","disabled")};i.prototype.setDisabled=function(b){this._input.spinner("option","disabled",b)};i.prototype.setTooltip=function(b){void 0===this._tooltip?this._tooltip=new c(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),b):this._tooltip.setTooltipContent(b)};i.prototype.setOption=
function(b,a){var c=this["_"+b];void 0!==c&&c!==a&&(this["_"+b]=a,this._input.spinner("option",b,a))};i.prototype.setInputUnit=function(b){this._inputUnit=b;this._labelUnit.empty();this._labelUnit.append(this._inputUnit)};return i});
define("web-viewer/measure/CaliperSubtoolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/Spinner web-viewer/core/CoreConstants web-viewer/measure/MeasureConstants web-viewer/utils/ViewerUtils web-viewer/utils/ListenerUtil jquery underscore".split(" "),function(c,b,d,f,i,g,a,h,e,j){var k=function(a,g){c.call(this,"CaliperSubtoolbar",a);h.mixin(this,a);this.f=a;this._caliperModel=g;this.f.i18n.loadBundle("viewer",
function(){this._stylesLabel=e("<span />").addClass("styleLabel").text(this.f.i18n.t("GapStyle")+":");this._styles=e("<select />").addClass("styleSelect mousetrap");this._refreshGaps();this._styles.on("change",j.bind(this._styleSelectorChanged,this));this.element.append(e("<div class='caliperStyle'/>").append(this._stylesLabel).append(this._styles));this._gapLabel=e("<span />").addClass("gapLabel").text(this.f.i18n.t("GapSize")+":");this._gapSpinner=new f(this.f,{min:0,max:9999,step:0.01,page:10,
onSpinnerChanged:j.bind(this._spinnerChanged,this),inputUnit:this.f.i18n.t(this.f.getUnitsLocName())});this.element.append(e("<div class='caliperGap'/>").append(this._gapLabel).append(this._gapSpinner.element.addClass("mousetrap")));this._heightWidthButtonGroup=new b("heightWidthButtonGroup");this._heightWidthButtonGroup.element.addClass("heightWidthButtonGroup");this._heightButton=new d(this.f,"checkHeight","icon-WCR_Height",!0,j.bind(this._heightButtonClicked,this));this._heightButton.element.append(this.f.i18n.t("GapHeight"));
this._heightWidthButtonGroup.addButton(this._heightButton);this._widthButton=new d(this.f,"checkWidth","icon-WCR_Width",!0,j.bind(this._widthButtonClicked,this));this._widthButton.element.append(this.f.i18n.t("GapWidth"));this._heightWidthButtonGroup.addButton(this._widthButton);this.addButtonGroup(this._heightWidthButtonGroup);this._saveButtonGroup=new b("saveButtonGroup");this._saveGapButton=new d(this.f,"SaveGap","icon-WCR_Save",!0,j.bind(this._saveClicked,this));this._saveGapButton.setTooltip("viewer",
"SaveGapTT");this._saveButtonGroup.addButton(this._saveGapButton);this._deleteGapButton=new d(this.f,"DeleteGap","icon-WCR_Actions-Delete12",!0,j.bind(this._deleteClicked,this));this._deleteGapButton.setTooltip("viewer","DeleteGapTT");this._saveButtonGroup.addButton(this._deleteGapButton);this.addButtonGroup(this._saveButtonGroup);this._registerListener("changed.currentGap",this._gapChanged,this,this._caliperModel);this._registerListener("changed.currentGap.vector",this._gapVectorChanged,this,this._caliperModel);
this._registerListener("changed.presetGaps.new",this._refreshGaps,this,this._caliperModel);this._registerListener("changed.presetGaps.deleted",this._deletedPresetGap,this,this._caliperModel);this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",j.bind(this._unitsUpdated,this));this._caliperModel.setCurrentGapById(this._caliperModel.getFreeformGap().getId())},this)};k.prototype=Object.create(c.prototype);k.prototype.constructor=k;k.prototype._styleSelectorChanged=function(a){var b=this._caliperModel.getCurrentGap(),
c=this._caliperModel.getGapById(a.target.value);(c.getStyle()===g.CaliperStyle.Fixed&&b.getStyle()===g.CaliperStyle.Freeform||c.getStyle()===g.CaliperStyle.Freeform&&b.getStyle()===g.CaliperStyle.Fixed)&&c.setVector(b.getVector());this._caliperModel.setCurrentGapById(a.target.value)};k.prototype._spinnerChanged=function(b){var c=null;this.f.getUnits()===i.SizeUnits.PIXELS&&(c=this._getResolution(this._caliperModel.getCurrentGap().getVector()));b=a.convertToMmValue(b,this.f.getUnits(),this.f.getUnitsFix(i.SizeUnits.MM),
a.parseFloat(c));this._caliperModel.getCurrentGap().getStyle()===g.CaliperStyle.Preset&&(c=this._caliperModel.getCurrentGap(),this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId()),this._caliperModel.setCurrentGapVector(c.getVector()));c=this._caliperModel.getCurrentGap().getVector();c.setLength(b);this._caliperModel.setCurrentGapVector(c)};k.prototype._heightButtonClicked=function(a){if(this._caliperModel.getCurrentGap().getStyle()===g.CaliperStyle.Preset){var b=this._caliperModel.getCurrentGap();
this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());this._caliperModel.setCurrentGapVector(b.getVector())}b=this._caliperModel.getCurrentGap().getVector();b.setAngleInDegrees(-90);this._caliperModel.setCurrentGapVector(b);a.stopPropagation()};k.prototype._widthButtonClicked=function(a){if(this._caliperModel.getCurrentGap().getStyle()===g.CaliperStyle.Preset){var b=this._caliperModel.getCurrentGap();this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());
this._caliperModel.setCurrentGapVector(b.getVector())}b=this._caliperModel.getCurrentGap().getVector();b.setAngleInDegrees(0);this._caliperModel.setCurrentGapVector(b);a.stopPropagation()};k.prototype._gapChanged=function(a,b){this._styles.find('option[value="'+b.getId()+'"]').prop("selected",!0);this._gapVectorChanged(null,b.getVector());this._updateButtons()};k.prototype._gapVectorChanged=function(b,c){this._caliperModel.isMeasuringHeight(c)?(this._heightButton.setActive(!0),this._widthButton.setActive(!1)):
this._caliperModel.isMeasuringWidth(c)&&(this._widthButton.setActive(!0),this._heightButton.setActive(!1));var d=null;this.f.getUnits()===i.SizeUnits.PIXELS&&(d=this._getResolution(c));var e=c.getLength(),e=a.convertFromMmValue(e,this.f.getUnits(),this.f.getUnitsFix(),a.parseFloat(d));this._gapSpinner.setValue(e)};k.prototype._refreshGaps=function(a,b){this._styles.empty();j.each(this._caliperModel.getAllGaps(),function(a){this._newGap(a)},this);void 0!==b&&this._caliperModel.setCurrentGapById(b.getId())};
k.prototype._unitsUpdated=function(){this._gapSpinner.setInputUnit(this.f.i18n.t(this.f.getUnitsLocName()));this._gapChanged(this._caliperModel.getCurrentGap(),this._caliperModel.getCurrentGap());this._refreshGaps()};k.prototype._newGap=function(a){a=e("<option />").html(this._toString(a)).val(a.getId());this._styles.append(a)};k.prototype._deletedPresetGap=function(a){this._styles.find('option[value="'+a.getId()+'"]').remove();this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());
this._caliperModel.setCurrentGapVector(a.getVector())};k.prototype._saveClicked=function(){var a=this._caliperModel.getSimilarPreset(this._caliperModel.getCurrentGap());a?this._caliperModel.setCurrentGapById(a.getId()):this._caliperModel.saveCurrentGapAsPreset()};k.prototype._deleteClicked=function(){this._caliperModel.deleteCurrentGapFromPresets()};k.prototype._updateButtons=function(){switch(this._caliperModel.getCurrentGap().getStyle()){case g.CaliperStyle.Freeform:this._deleteGapButton.element.addClass("hiddenElement");
this._saveGapButton.element.removeClass("hiddenElement");break;case g.CaliperStyle.Fixed:this._deleteGapButton.element.addClass("hiddenElement");this._saveGapButton.element.removeClass("hiddenElement");break;case g.CaliperStyle.Preset:this._saveGapButton.element.addClass("hiddenElement"),this._deleteGapButton.element.removeClass("hiddenElement")}};k.prototype._toString=function(b){switch(b.getStyle()){case g.CaliperStyle.Freeform:return this.f.i18n.t("GapStyleFreeform");case g.CaliperStyle.Fixed:return this.f.i18n.t("GapStyleFixed");
case g.CaliperStyle.Preset:var c=null;this.f.getUnits()===i.SizeUnits.PIXELS&&(c=this._getResolution(b.getVector()));var c=a.convertFromMmValue(b.getVector().getLength(),this.f.getUnits(),this.f.getUnitsFix(),a.parseFloat(c)),d=this.f.i18n.t(this.f.getUnitsLocName()),e="";this._caliperModel.isMeasuringHeight(b.getVector())?e=this.f.i18n.t("GapHeight"):this._caliperModel.isMeasuringWidth(b.getVector())&&(e=this.f.i18n.t("GapWidth"));return c+" "+d+" ("+e+")"}};k.prototype._getResolution=function(a){var b=
this.f.getActivePage(),c=null;this._caliperModel.isMeasuringHeight(a)?c=b.getParam("resolutiony"):this._caliperModel.isMeasuringWidth(a)&&(c=b.getParam("resolutionx"));return c};return k});
define("web-viewer/measure/MeasureToolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/SubtoolbarButton component/button/Button web-viewer/layout/component/ColorPicker web-viewer/layout/LayoutConstants web-viewer/measure/MeasureConstants web-viewer/measure/CaliperSubtoolbarComponent utils/OrderedObject jquery".split(" "),function(c,b,d,f,i,g,a,h,e,j,k){var l=function(d,e,f,g,h,i,j){c.call(this,
a.ToolbarComponent.MEASURE,d);this.f=d;this.rulerTool=e;this.eyedropperTool=f;this.barcodeTool=g;this.brailleTool=h;this.caliperTool=i;this.screenRulingTool=j;this.screenRulingButton=this.caliperButton=this.brailleButton=this.barcodeButton=this.eyeDropperButton=this.rulerButton=null;this.measureGroup=new b("MeasureGroup");this.measureGroup.setTitle(d.i18n,"viewer","MeasurementToolsTitle");this.addButtonGroup(this.measureGroup);this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(_.bind(function(){this.updateTools()},
this))};l.prototype=Object.create(c.prototype);l.prototype.constructor=l;l.toolbarName=a.ToolbarComponent.MEASURE;l.prototype.initializeRulerButton=function(a){if(!this.rulerButton){this.rulerButton=new d(this.f,"RulerButton","icon icon-WCR_Measure-Ruler",!0);this.rulerButton.listenToTool(a,!0);this.rulerButton.setTooltip("viewer","RulerTT");a=new c("RulerSubtoolbar",this.f);this.rulerButton.addSubtoolbarComponent(a);var e=new b("RulerSubGroup");a.addButtonGroup(e);var h=new f(this.f,"DAButton","icon-WCR_Measure-Ruler-DA-cont",
!0,_.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_DA",a.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",1<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?0:1)},this.f));h.setIcon("icon-WCR_Measure-Ruler-DA-cont",["icon-WCR_Measure-Ruler-DA-sub icon-red"]);h.setTooltip("viewer","RulerDATT");e.addButton(h);var i=new f(this.f,"XYButton","icon-WCR_Measure-Ruler-XY-cont",!0,_.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_XY",
a.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",2<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?1:2)},this.f));i.setIcon("icon-WCR_Measure-Ruler-XY-cont",["icon-WCR_Measure-Ruler-XY-sub icon-red"]);i.setTooltip("viewer","RulerXYTT");e.addButton(i);var j=new f(this.f,"WHButton","icon-WCR_Measure-Ruler-WH-cont",!0,_.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_WH",a.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",
3<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?2:3)},this.f));j.setIcon("icon-WCR_Measure-Ruler-WH-cont",["icon-WCR_Measure-Ruler-WH-sub icon-red"]);j.setTooltip("viewer","RulerWHTT");e.addButton(j);var k=_.partial(function(a){h.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA"));i.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY"));j.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH"))},this.f);this.f.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_MODE",
function(){k()});k();var l=new g(_.partial(function(a,b){a.getCurrentUser().setColor("PREFERENCES_RULER_DISPLAY_COLOR",b)},this.f));this.f.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_COLOR",_.partial(function(a){l.setColor(a.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"))},this.f));l.setColor(this.f.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"));e=new f(this.f,"ColorSelector",l.element,!0);e.setTooltip("viewer","RulerDisplayColorChange");var u=new f(this.f,
"ColorReset","icon-WCR_Revert",!0,_.partial(function(a){a.resetOption("PREFERENCES_RULER_DISPLAY_COLOR")},this.f));u.setTooltip("viewer","RulerDisplayColorReset");var r=new f(this.f,"angleButton",this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?"measureCCW":"measureCW",!0,_.partial(function(a){a.setOption("PREFERENCES_RULER_ANGLE_MODE",a.getOption("PREFERENCES_RULER_ANGLE_MODE")?0:1);a.getOption("PREFERENCES_RULER_ANGLE_MODE")?(this.setTooltip("viewer","RulerAngleToCW"),this.setIcon("icon-WCR_Measure-Ruler-CCW-cont",
["icon-WCR_Measure-Ruler-CCW-sub icon-red"])):(this.setTooltip("viewer","RulerAngleToCCW"),this.setIcon("icon-WCR_Measure-Ruler-CW-cont",["icon-WCR_Measure-Ruler-CW-sub icon-red"]))},this.f));this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?(r.setTooltip("viewer","RulerAngleToCW"),r.setIcon("icon-WCR_Measure-Ruler-CCW-cont",["icon-WCR_Measure-Ruler-CCW-sub icon-red"])):(r.setTooltip("viewer","RulerAngleToCCW"),r.setIcon("icon-WCR_Measure-Ruler-CW-cont",["icon-WCR_Measure-Ruler-CW-sub icon-red"]));
var s=new b("RulerSubGroupOptions");a.addButtonGroup(s);s.addButton(r);s.addButton(e);s.addButton(u)}};l.prototype.initializeEyeDropperButton=function(a){this.eyeDropperButton||(this.eyeDropperButton=new d(this.f,"EyeDropperButton","icon icon-WCR_Measure-Colorpicker",!1),this.eyeDropperButton.listenToTool(a,!0),this.eyeDropperButton.setTooltip("viewer","ToolPercentageTT"))};l.prototype.initializeBarCodeButton=function(a){this.barcodeButton||(this.barcodeButton=new d(this.f,"BarcodeButton","icon icon-WCR_Measure-Barcode",
!1),this.barcodeButton.listenToTool(a,!0),this.barcodeButton.setTooltip("viewer","ToolBarcodeTT"))};l.prototype.initializeBrailleButton=function(a){if(!this.brailleButton){this.brailleButton=new d(this.f,"BrailleButton","icon icon-WCR_Measure-Braille",!1);this.brailleButton.listenToTool(a,!0);this.brailleButton.setTooltip("viewer","ToolBrailleTT");var b=new j;_.each(h.BrailleLanguage,function(a,c){c!==h.LanguageAutomatic&&b.addItem(this.f.i18n.t(h.LanguageTranslationPrefix+a.lang),c)},this);b.setOrder(_.sortBy(b.getKeys()));
b.addItemAtIndex(this.f.i18n.t(h.LanguageTranslationPrefix+h.BrailleLanguage[h.LanguageAutomatic].lang),h.LanguageAutomatic);a=new c("BrailleSubToolbar",this.f);this.brailleButton.addSubtoolbarComponent(a);var e=k("<div/>").addClass("brailleLanguages"),f=k("<span/>").addClass("currentlang").append(b.getKeyByValue(this.f.getOption("PREFERENCES_BRAILLE_LANGUAGE").toString())),g=k("<ul/>").addClass("languagelist").hide(),l=new i(this.f.i18n,this.f.getContext(),this.f.isMobile(),"language",f,!1,function(){g.toggle()});
_.each(b.getKeys(),function(a){var c=new i(this.f.i18n,this.f.getContext(),this.f.isMobile(),"brailleLang"+b.getItemByKey(a),a,!1,_.partial(function(c){var d=parseInt(b.getItemByKey(a),10);isNaN(d)&&(d=0);c.setOption("PREFERENCES_BRAILLE_LANGUAGE",d);g.hide()},this.f));g.append(k("<li/>").append(c.element))},this);l.element.append(k("<b/>").addClass("caret"));e.append(l.element);e.append(g);a.element.append(e);this.f.getCurrentUser().on("options.changed.PREFERENCES_BRAILLE_LANGUAGE",function(a,c){f.html(b.getKeyByValue(c+
""))})}};l.prototype.initializeCaliperButton=function(a){this.caliperButton||(this.caliperButton=new d(this.f,"CaliperButton","icon-WCR_Measure-Caliper2-cont",!1),this.caliperButton.listenToTool(a,!0),this.caliperButton.setIcon("icon-WCR_Measure-Caliper2-cont",["icon-WCR_Measure-Caliper2-sub icon-red"]),this.caliperButton.setTooltip("viewer","CaliperTT"),this.caliperButton.addSubtoolbarComponent(new e(this.f,a.getCaliperModel())))};l.prototype.initializeScreenRulingButton=function(a){this.screenRulingButton||
(this.screenRulingButton=new d(this.f,"ScreenRulingButton","icon icon-WCR_Measure-Screen",!1),this.screenRulingButton.listenToTool(a,!0),this.screenRulingButton.setTooltip("viewer","ToolScreenTT"))};l.prototype.updateTools=function(){this.f.emit("toolManager.activeTool",_.bind(function(a){a&&(a.canBeUsedOnActivePage&&!a.canBeUsedOnActivePage())&&this.f.emit("toolManager.deactivateTool",a)},this));this.measureGroup.clearButtons();this.rulerTool&&this.rulerTool.canBeUsedOnActivePage()&&(this.initializeRulerButton(this.rulerTool),
this.measureGroup.addButton(this.rulerButton));this.eyedropperTool&&this.eyedropperTool.canBeUsedOnActivePage()&&(this.initializeEyeDropperButton(this.eyedropperTool),this.measureGroup.addButton(this.eyeDropperButton));this.screenRulingTool&&this.screenRulingTool.canBeUsedOnActivePage()&&(this.initializeScreenRulingButton(this.screenRulingTool),this.measureGroup.addButton(this.screenRulingButton));this.barcodeTool&&this.barcodeTool.canBeUsedOnActivePage()&&(this.initializeBarCodeButton(this.barcodeTool),
this.measureGroup.addButton(this.barcodeButton));this.brailleTool&&this.brailleTool.canBeUsedOnActivePage()&&(this.initializeBrailleButton(this.brailleTool),this.measureGroup.addButton(this.brailleButton));this.caliperTool&&this.caliperTool.canBeUsedOnActivePage()&&(this.initializeCaliperButton(this.caliperTool),this.measureGroup.addButton(this.caliperButton));this._emit("changed.content")};return l});
define("web-viewer/measure/MeasureModule","underscore web-viewer/core/AbstractModule web-viewer/measure/RulerTool web-viewer/measure/BarcodeMeasureTool web-viewer/measure/BrailleMeasureTool web-viewer/measure/EyeDropperMeasureTool web-viewer/measure/CaliperTool web-viewer/measure/CaliperModel web-viewer/measure/ScreenRulingMeasureTool web-viewer/measure/MeasureToolbarComponent web-viewer/measure/MeasureConstants web-viewer/utils/ListenerUtil utils/XMLUtils jquery".split(" "),function(c,b,d,f,i,g,
a,h,e,j,k,l,n,p){var q=function(m,k){b.call(this,m,k,"measure");l.mixin(this,m);p.when(this._checkBarCodeAndBrailleLicenses()).done(c.bind(function(b,k){this.tools=[];this.rulerTool=new d(m,"ruler");this._publishTool(this.rulerTool);this.tools.push(this.rulerTool);b&&(this.barcodeTool=new f(m,this),this._publishTool(this.barcodeTool),this.tools.push(this.barcodeTool));k&&(this.brailleTool=new i(m,this),this._publishTool(this.brailleTool),this.tools.push(this.brailleTool));this.eyedropperTool=new g(m,
"eyedropper");this._publishTool(this.eyedropperTool);this.tools.push(this.eyedropperTool);this.screenRulingTool=new e(m,"screenruling");this._publishTool(this.screenRulingTool);this.tools.push(this.screenRulingTool);this.caliperModel=new h(m,[this.getPrivateChannelName(),"caliper","model"]);this.caliperTool=new a(m,this.caliperModel);this._publishTool(this.caliperTool);this.tools.push(this.caliperTool);this._publishToolbarComponent(j.toolbarName,c.bind(function(){return this._measureToolbarComponent=
new j(m,this.rulerTool,this.eyedropperTool,this.barcodeTool,this.brailleTool,this.caliperTool,this.screenRulingTool)},this));this._registerListener("module.graphics.model.changed.**",c.debounce(c.partial(this.updateMeasureTools,!1),10),this);this._registerListener("module.compare.referenceOffset.changed",c.partial(this.updateMeasureTools,!0),this)},this))};q.prototype=Object.create(b.prototype);q.prototype.constructor=q;q.prototype.updateMeasureTools=function(a){c.each(this.tools,function(b){b.isActive()&&
b.updateIfNeeded(a)})};q.prototype.getState=function(){var a={rulerState:this.rulerTool.getToolState(),eyedropperState:this.eyedropperTool.getToolState(),caliperState:this.caliperTool.getToolState(),sizeUnitState:this.f.getOption("PREFERENCES_UNIT_SIZE")};this.barcodeTool&&(a.barcodeState=this.barcodeTool.getToolState());this.brailleTool&&(a.brailleState=this.brailleTool.getToolState());return a};q.prototype.setState=function(a){void 0!==a.rulerState&&(a.rulerState.isActive&&this.f.emit("toolManager.activateTool",
this.rulerTool),this.rulerTool.setToolState(a.rulerState),this.f.emit("toolManager.interruptTools",!0));void 0!==a.barcodeState&&this.barcodeTool&&this.barcodeTool.setToolState(a.barcodeState);void 0!==a.brailleState&&this.brailleTool&&this.brailleTool.setToolState(a.brailleState);void 0!==a.eyedropperState&&this.eyedropperTool.setToolState(a.eyedropperState);void 0!==a.caliperState&&this.caliperTool.setToolState(a.caliperState);void 0!==a.sizeUnitState&&this.f.setOption("PREFERENCES_UNIT_SIZE",a.sizeUnitState)};
q.prototype._checkBarCodeAndBrailleLicenses=function(){var a=p.Deferred();p.when(this._getServerInfoFlags()).done(function(b){a.resolve((b&k.ServerInfoFlags.barCode)===k.ServerInfoFlags.barCode||(b&k.ServerInfoFlags.barCodeGV)===k.ServerInfoFlags.barCodeGV,(b&k.ServerInfoFlags.braille)===k.ServerInfoFlags.braille)});return a.promise()};q.prototype._getServerInfoFlags=function(){var a=p.Deferred();void 0!==this._serverFlags?a.resolve(this._serverFlags):this.f.ajax(this.f.getDataAdapter().ViewServer("getserverinfo.jsp"),
{success:c.bind(function(b){if(b&&(b=n.xml2obj(b))&&(b.status&&"0"==b.status.value)&&b.status.server){this._serverFlags=parseInt(b.status.server.flags,10);a.resolve(this._serverFlags);return}this.f.emit("error.WARNING","Problem while fetching server flags");a.resolve(0)},this),error:c.bind(function(b,c,d){this.f.emit("error.WARNING","Problem while fetching server flags",c,d);a.resolve(0)},this)});return a.promise()};return q});